*****************************************************************************
** Engine: 14 Bit Amplifier II                                             **
**                                                                         **
** Project: Eagleplayer 2.05                                               **
** Authors: Jan Blumenthal & Henryk Richter                                **
** Start  : 1993/01/09                                                     **
** $Rev: 23 $ $Author: buggs $                                             **
** $Date: 2016-11-22 07:27:29 +0100 (Di, 22. Nov 2016) $                   **
**                                                                         **
*****************************************************************************
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program (See the included file COPYING);
** if not, write to the Free Software Foundation, Inc.,
** 675 Mass Ave, Cambridge, MA 02139, USA.
**
**************************************************************************** 


	ifne	AHIOUT

;-----------------------------------------------------------------------------------------------------
;-----------------------------------------------------------------------------------------------------
;------------------------------------------ AHI Code -------------------------------------------------
;-----------------------------------------------------------------------------------------------------
AmpOut_AHI:
		dc.l	AHIAMP_Init
		dc.l	AHIAMP_End
		dc.l	AHIAMP_StartInt
		dc.l	AHIAMP_StopInt
		dc.l	AHIAMP_Check
		dc.l	0					;OHW_GetMixRates
		dc.l	0					;OHW_SetMixRate (optional)
		dc.l	AHIAMP_SetPlayMode			;OHW_SetPlayMode (optional)
		dc.l	AHIAMP_SetBoost				;OHW_SetBoost (optional)
		dc.l	AHIAMP_Startup
		dc.l	AHIAMP_Exit
		dc.l	AHIAMP_Configure			;OHW_Reserved
	ifne	(*-AmpOut_AHI)-OHW_Sizeof
	error	"Structure Size Mismatch!"
	endc


; A5 - Amplifier internal "datas"
;
AHIAMP_Startup:
	push	d1-a6
	;lea	AHIAMP_utilityname(pc),a1
	;move.l	4.w,a6
	;moveq	#0,d0
	;jsr	_LVOOpenLibrary(A6)
	;move.l	d0,AHIAMP_Utilitybase
	;beq.s	failAHI$

	OPENAHI	4

	move.l	d0,AHIAMP_AHIBase
	bne.s	haveAHI$

	lea	FailOpenMessage(pc),a0
	bsr	Merror

	moveq	#0,d0
	bra	noAHI$
haveAHI$
	bsr	AHIAMP_CollectModeNames

	moveq	#-1,d0
noAHI$
	pop	d1-a6
	not.l	d0	;success: 0, failure -1
	rts

AHIAMP_Exit:
	push	d1-a6

	tst.w	AHINameListInit(a5)
	beq.s	noNamelist$
nlloop$
	lea	AHINameList(a5),a1
	IFEMPTY	a1,noNamelist$

	move.l	LH_HEAD(a1),a1
	push	a1
	REMOVE
	pop	a1
	moveq	#ML_Sizeof,d0
	move.l	4.w,a6
	jsr	_LVOfreemem(A6)

	bra	nlloop$
noNamelist$
	move.l	AHIAMP_AHIBase(pc),d0
	beq.s	noAHI$
	CLOSEAHI
	clr.l	AHIAMP_AHIBase
noAHI$
	;move.l	AHIAMP_Utilitybase(pc),d0
	;beq.s	noUtility$
	;move.l	d0,a1
	;move.l	4.w,a6
	;jsr	_LVOCloseLibrary(a6)
	;clr.l	AHIAMP_Utilitybase
;noUtility$
	pop	d1-a6
	moveq	#0,d0	;0=ok, matches the default return code when this call is not implemented
	rts

;------------------------------ config requester --------------------------------
;input:  A5 - datas (Amplifier)
;output: D0 - ok = 0 / error <>0
;regs:   all saved
;note:   
;
AHIAMP_Configure:
	push	d1-a6
	move.l	AHIAMP_AHIBase(pc),d0
	beq.w	noAHI$
	move.l	d0,a6

	lea	AHIAMP_Tagbuffer,a0
	move.l	#TAG_DONE,(a0)
	jsr     _LVOAHI_AllocAudioRequestA(a6)
	tst.l	d0
	beq.w	noAHI$
	move.l	d0,a0

	lea	AHIAMP_Tagbuffer,a1
	move.l	#AHIR_Window,(a1)+
	move.l	winhandle(a5),(a1)+
	move.l	#AHIR_SleepWindow,(a1)+
	move.l	#1,(a1)+
	move.l	#AHIR_DoMixFreq,(a1)+
	move.l	#1,(a1)+

	lea     Prefslist(a5),a2
	move.w	SelectedW(a5),d2
	mulu	#P_Sizeof,d2
	move.l	#AHIR_InitialMixFreq,(a1)+
	move.l	P_Mixrate(a2,d2.w),(a1)+
	move.l	#AHIR_InitialAudioID,(a1)+
	move.l	P_AHIMode(a2,d2.w),(a1)+

;       AHIR_InitialAudioID (ULONG) - Initial setting of the Mode list view
;       AHIR_InitialMixFreq (ULONG) - Initial setting of the frequency
	move.l	#AHIR_FilterTags,(a1)+
	lea	AHIAMP_ModeFilterTags(pc),a2
	move.l	a2,(a1)+

	move.l	#TAG_DONE,(a1)+
	lea	AHIAMP_Tagbuffer,a1

	push	a0
	jsr	_LVOAHI_AudioRequestA(a6)
	pop	a0
	move.l	d0,d7
	beq.s	cancel$
	; OK, we have a new set of variables selected by the user, copy to prefs

	move.l	ahiam_AudioID(a0),d0	;audio ID
	move.l	ahiam_MixFreq(a0),d5	;mix Freq

;	move.l	d0,0
;Melody fast Stereo 00 06 00 04
;Paula fast 14 bit cal 00 02 00 04
;Toccata fast 16 Bit stereo 00 0a 00 04
	
	;set prefs, either local or global
	lea     Prefslist(a5),a1

	tst.b	onglobal(A5)
	bne.s	setglobal$
	
	move.w	SelectedW(a5),d2
	mulu	#P_Sizeof,d2
	move.l	d5,P_Mixrate(a1,d2.w)
	move.l	d0,P_AHIMode(a1,d2.w)
	bra.s	prefsdone$
setglobal$
	moveq	#MaxVoices-2,d2
loopglobal$
	move.l	d5,P_Mixrate(a1)
	move.l	d0,P_AHIMode(a1)
	lea	P_Sizeof(a1),a1
	dbf	d2,loopglobal$
prefsdone$

cancel$
	jsr	_LVOAHI_FreeAudioRequest(a6)

	tst.l	d7
	beq.s	nogadupdate$

	bsr	MakeLV			;Listview in Ordnung bringen

	;d5: mixing frequency
	moveq	#MIXSL_ExplicitFreq,d1
	bsr	HandleMixingSlider	;update mixing slider with supplied frequency
nogadupdate$

;       requester = AHI_AllocAudioRequestA( tags );
;       D0                                  A0
;       success = AHI_AudioRequestA( requester, tags );
;       D0                           A0         A1
;       AHI_FreeAudioRequest( requester );
;                             A0

	moveq	#-1,d0	;will be zero after neg below
noAHI$
	pop	d1-a6
	neg.l	d0	;success: 0, failure -1
	rts


; Input: A5 - Amplifier "Datas"
;
AHIAMP_CollectModeNames:
	push	all
	move.l	AHIAMP_AHIBase(pc),d0
	beq	noAHI$

	tst.w	AHINameListInit(a5)	;do this only once
	bne.w	noAHI$

	lea	AHINameList(a5),a1
	NEWLIST	a1			;macro in Lists.i
	move.w	#1,AHINameListInit(a5)

	moveq	#AHI_INVALID_ID,d7
loop$
	move.l	d7,d0			;current mode
	move.l	AHIAMP_AHIBase(pc),a6
	jsr	_LVOAHI_NextAudioID(a6)
	cmp.l	#AHI_INVALID_ID,d0
	beq.w	done$
	move.l	d0,d7			;store current mode in D7

	;check ID whether it supports stereo
	lea	AHIAMP_Tagbuffer2,a1
	move.l	#AHIDB_Stereo,(a1)+
	lea	temp(a5),a0
	move.l	a0,(a1)+
	move.l	#AHIDB_Panning,(a1)+
	addq.l	#4,a0
	move.l	a0,(a1)+
	move.l	#TAG_DONE,(a1)+
	lea     AHIAMP_Tagbuffer2,a1

	;AHIBase still in A6, mode still in D0
	suba.l	a2,a2
	jsr	_LVOAHI_GetAudioAttrsA(A6)
	tst.l	d0
	beq.w	done$

	move.l	temp(a5),d0
	beq.s	loop$		;no stereo ?
	move.l	temp+4(a5),d0
	beq.s	loop$		;no panning ?

	move.l	4.w,a6
	moveq	#ML_Sizeof,d0
	move.l	#MEMF_PUBLIC,d1
	jsr	_LVOallocmem(A6)
	tst.l	d0
	beq	done$
	
	move.l	d0,a4
	lea	AHINameList(a5),a0
	move.l	a4,a1			
	ADDTAIL
	lea	ML_Nodename(a4),a0
	move.l	a0,ln_name(A4)
	clr.b	(a0)			;default: empty name (see below for fallback)
	move.l	d7,ML_AHIMode(a4)	;remember AHI mode ID

	lea	AHIAMP_Tagbuffer2,a1
	move.l	#AHIDB_Name,(a1)+
	move.l	a0,(a1)+
	move.l	#AHIDB_BufferLen,(a1)+
	moveq	#ML_NameLength-1,d1
	move.l	d1,(a1)+
	move.l	#TAG_DONE,(a1)+
	lea     AHIAMP_Tagbuffer2,a1

	move.l	d7,d0
	suba.l	a2,a2
	move.l	AHIAMP_AHIBase(pc),a6
	jsr	_LVOAHI_GetAudioAttrsA(A6)

	lea	ML_Nodename(a4),a1
	tst.b	(a1)
	bne	loop$			;if there is a name, just loop

	lea	unknownstring(pc),a1	;default: "unnamed"
	move.l	ln_name(a4),a0
.copy
	move.b	(a1)+,(a0)+
	bne.s	.copy
;	move.l	a1,ln_name(a4)		;
;	move.l	a1,ML_Nodename(a4)

	bra	loop$
done$

noAHI$
	pop	all
	rts


;D0 - Mode ID
;A1 - output array
;D1 - max. length
;A5 - datas
;AHIAMP_Mode2Name:

; Caution: don't call this when a module is playing or starting, AHI gets confused when
; called from different tasks (at least with one AHI Base)
; -> collect list of modes at start of Amplifier
;
;D0 - Mode ID
;A1 - output array
;D1 - max. length
;A5 - datas
;changed:
; A1
AHIAMP_Mode2Name:
	push	d0-a0/a2-a6

	ifne	1
	;new code: use local cache
		move.l	a1,a4
		clr.b	(a1)
		tst.w	AHINameListInit(a5)	;do this only once
		beq.w	noAHI$

		lea	AHINameList(a5),a1
		IFEMPTY	a1,noAHI$

		move.l	LH_HEAD(a1),d2
		beq	noAHI$			;shouldn't happen...
searchloop$		
		move.l	d2,a1
		cmp.l	ML_AHIMode(a1),d0
		beq.s	found$

		SUCC	a1,d2
		bne	searchloop$
		lea	unknownstring(pc),a0	;default: "unnamed"
		bra.s	loop$
found$
		;d1: remaining space in A1 (now A4)
		move.l	LN_NAME(a1),a0
loop$
		subq	#1,d1
		ble	finish$
		move.b	(a0)+,(a4)+
		bne	loop$
		subq.l	#1,a4
finish$
		clr.b	(a4)
noAHI$
		move.l	a4,a1
	else
	;old code: ask AHI every time
		move.l	a1,a4
		lea	temp(a5),a0

		lea	AHIAMP_Tagbuffer2,a1
		;move.l	#AHIDB_AudioID,(a1)+	;was wrong: ID is in reg D0 -> this is for the returned ID
		;move.l	d0,(a1)+
		move.l	#AHIDB_Name,(a1)+
		move.l	a0,(a1)+
		move.l	#AHIDB_BufferLen,(a1)+
		ext.l	d1
		move.l	d1,(a1)+
		move.l	#TAG_DONE,(a1)+
		lea     AHIAMP_Tagbuffer2,a1

		moveq	#0,d1
		move.l	AHIAMP_AHIBase(pc),d2
			beq.s	noAHI$
		move.l	d2,a6
		suba.l	a2,a2
		jsr	_LVOAHI_GetAudioAttrsA(A6)
		move.l	a4,a1

		tst.l	d0
		beq.s	noAHI$

		lea	temp(a5),a0
findend$
		move.b	(a0)+,(a1)+
		beq.s	end$
		subq.w	#1,d1
		bpl.s	findend$
end$
		subq.l	#1,a1
noAHI$
	endc
	pop	d0-a0/a2-a6
	rts
;--------------------- set surround mode mono-stereo-surround --------------------------------
;input:  A5 - datas (Amplifier)
;        D0 - mode (<0=mono, 0=stereo, >=0 surround), range is <64...64 
;output: D0 - ok = 0 / error <>0
;regs:   all saved
;note:   - optional, set pointer to NULL if you won't implement this
;        - output agnostic function, selects CopyBuffer variants and calls table init functions
AHIAMP_SetPlayMode:
	push	d1-a6

	move.l	d0,d1

	lea	copybufStereoA,a4
	lea	copybufemptyStereoA,a6

	tst.b	d1			; Stereo ? -> use stereo routine (faster than the other)
	beq.s	.setit

;	lea	copybufSurround14_030,a4 ; table based surround
;	move.l	SurroundTabAddrMid(pc),d2
;	bne.w	.tablebasedsurround	; use table based surround when table is present

	lea	copybufSurroundA,a4	; surround routine used in empty and non-empty cases

.tablebasedsurround:
	move.l	a4,a6			; 

	tst.b	d1
	bpl.s	.setit

	lea	copybufMonoA,a4		; surround routine used in empty and non-empty cases
	move.l	a4,a6			; 
	neg.b	d1
.setit:

	lea	cbufad,a5
	move.l	a4,(a5)+	;cbufad
	move.l	a6,(a5)+	;cbufempty

	and.w	#127,d1		;8 Bit -> 16 Bit
	cmp.w	#64,d1
	ble.s	.efvolok
	moveq	#64,d1
.efvolok
	move	d1,effectvol	

	; TODO: UPS buffer fill in 14 Bit mode
	lea	myupsstruct,a6
	lea	UPSBuffer0,a5

	lea	UPSBuffer0a,a0
	lea	UPSBuffer1a,a1

	move.l	a0,(a5)+
	move.l	a0,ups_voice1adr(A6)
	move.l	a0,ups_voice4adr(A6)

	move.l	a1,(a5)+
	move.l	a1,ups_voice2adr(A6)
	move.l	a1,ups_voice3adr(A6)

	move.l	a1,(a5)+		; irrelevant
	move.l	a0,(a5)+		; irrelevant

	move.w	#64,ups_voice1vol(a6)
	move.w	#64,ups_voice2vol(a6)
	move.w	#0,ups_voice3vol(a6)
	move.w	#0,ups_voice4vol(a6)

	clr.l	tmpvol
	clr.w	tmpvol2

	bsr	Makevoltable	; update volume table
	bsr	MakeSurroundTab ; update surround table (68030 and below)

	pop	d1-a6
	moveq	#0,d0
	rts


; D0: boost*10
AHIAMP_SetBoost:
	push	all
	move.l	buff14,d7		;128 kByte Buffer, allocated internally, available for the output HW to use
	beq.s	noboost$
	move.l	d7,a0

	; quick'n'easy boost table, linear boost with saturation
	ext.l	d0
	move.w	#$8000,d1		;-32768
	ext.l	d1
	move.l	d1,d3
negloop$
	move.l	d1,d2
	muls.l	d0,d2			;*(boost*10)
	divs.l	#10,d2			;/10
	cmp.l	d3,d2			;-32768.l
	bgt.s	negok$
	move.l	d3,d2			;
negok$
	move.w	d2,(a0)+

	addq.l	#1,d1
	bne.s	negloop$		;zero excluded

	moveq	#0,d1
	move.w	#32767,d3
	ext.l	d3
posloop$
	move.l	d1,d2
	muls.l	d0,d2			;*(boost*10)
	divs.l	#10,d2			;/10
	cmp.l	d3,d2			;32767.l
	ble.s	posok$
	move.l	d3,d2			;
posok$
	move.w	d2,(a0)+

	addq.l	#1,d1
	cmp.l	d3,d1
	ble.s	posloop$

noboost$
	pop	all
	rts

; Recalculate mixing parameters, find best frequency first
;  
; Input:
;  A5 - Amplifier globals
;  D0 - Mixing Rate
; Output:
;  D0 - 0=ok, else error
AHIAMP_CalcnewmixingPeriod:
	push	d1-a6

	;-------------------------------
	move.l	d0,playmixrate
	bne.s	sanefreq$
	move.l	#44100,d0			;no frequency found (possibly no soundcard present), use a default to avoid division by zero
sanefreq$
	move.l	#14187580/4,clock		;Clock constant (reference clock constant is always the PAL constant)

	ifne	1
	move.l	d0,d7
	
        move.l  clock(pc),d2
	move.l	d2,d0
        move.l  d7,d1                           ;mixingrate(pc),d1
        divu    d1,d0
        move.l  d2,d1
        divu    d0,d1
        swap    d1
        clr     d1
        swap    d1
        move.l  d1,mrate                        ;Abspielrate f?r Mixroutine setzen
	else
	move.l	d0,mrate			;no recalculation of mixing rate (used in "mix,mix2")
	move.l	d0,d1
	endc

;	move.l	AudioRate(pc),d2		;3546895 for PAL
	move.l	clock(pc),d2			;always PAL reference clock

	move.l	d2,d0
	lsl.l	#2,d0
	divu	d1,d0
	move.w	d0,mixingperiod4

	move.l	d2,d0
	divu	d1,d0
	swap	d0
	clr	d0
	swap	d0
	move.l	d0,newmixingperiod

	move.l	d0,d4
	move.l	#262144,d1		;no change in scaling for PAL
	mulu.l	d1,d4			;mixingperiod * 4 * 65536 -> same scaling as sample period plus room for fractional part
	move.l	d4,referenceperiod	;reference period for mixing step calculations (independent of underlying PAL/NTSC hardware)

	Push	a1
	lea	myupsstruct,a1
	move.w	d0,ups_voice1per(a1)
	move.w	d0,ups_voice2per(a1)
	move.w	d0,ups_voice3per(a1)
	move.w	d0,ups_voice4per(a1)
	Pop	a1

	bsr.w	ResetASPeriods			;make sure, new interpolation factors are calculated

	pop	d1-a6
	move.l	mrate,d0
	rts

;----------------------------------------------------------------------------------------------------
;--------------------------- setzt Lautstaerke, Laenge, Period neu ------------------------------------
;----------------------------------------------------------------------------------------------------
; TODO: call only when necessary 
AHIAMP_SetHardWare:
	ifne	userprogram
		move.l	MyEPBase(pc),a5
		move.l	dtg_SndVol(A5),d0	; dtg_SndVol & dtg_SndLBal
		move.w	dtg_SndRBal(A5),d1	; dtg_SndVol & dtg_SndLBal
	
		cmp.w	tmpvol2(pc),d1
		bne.s	newvol$
		cmp.l	tmpvol(pc),d0
		beq.s	weiter$
newvol$
		move.l	d0,tmpvol
		move.w	d1,tmpvol2

		push	a1			;signal main task to recalculate volume/balance
		move.l	my2ndsignal+datas,d1
		moveq	#0,d0
		bset	d1,d0
		move.l	mytask+datas,a1
		move.l	4.w,a6
		jsr	_LVOSignal(a6)
		pop	a1
weiter$		
	endc
		rts

;----------------------------------------------------------------------------------------------------
;------------------------------- Mixroutine Main Loop -----------------------------------------------
;----------------------------------------------------------------------------------------------------
; main call from secondary interrupt (software-int to stay system-friendly)
; A0 - output buffer
; D0 - length (currently ignored) 
AHIAMP_DoMix:
	movem.l	d0-a6,-(Sp)
	move.l	A0,.fillbuffer
	bsr	AHIAMP_SetHardware

	move.l	myaudiostruct(pc),a4

	;--------------------- mix left panned channels ----------------------
	clr.w	.curchannelsl

	move	numstructs,d7
	subq.w	#1,d7
	blt.w	.noleft

	move.l	mixad1,a1				; copy mix routine
;	lea	fm_mix,a1
.left_loop
		tst.w	AS_LeftRight(a4)
		ble.s	.left_noleft

			lea	TempBuffer,a2			; 16 Bit output buffer (temporary before scaling)
			move.w	#SamLEN*2,d0			;
			move.l	Vtabaddr(pc),a6

			movem.l	a1/a4/d7,-(sp)			; no registers saved by mixer, store needed pointers
			jsr	(a1)				; mix
			movem.l	(sp)+,a1/a4/d7
		
			tst.w	d0
			beq	.left_nochannel			;we expect that moveq is the last command

			add.w	#1,.curchannelsl
			move.l	mixad2,a1
.left_nochannel:
.left_noleft:
		lea	AS_Sizeof(a4),a4
		dbf	d7,.left_loop

		; if no channel was active, Tempbuffer will be "dirty", use pointer to 0-buffer in these cases
		lea	Tempbuffer,a0
		move	.curchannelsl(pc),d0
		bne.s	.leftok
		lea	ZeroSamplebuffer,a0
.leftok:	move.l	a0,.lbuffer
.noleft:

	;--------------------- mix right panned channels ----------------------
	clr.w	.curchannelsr

	move.l	myaudiostruct(pc),a4

	move	numstructs,d7
	subq.w	#1,d7
	blt.w	.noright
	
	move.l	mixad1,a1	;	
;	lea	fm_mix,a1

.right_loop
		tst.w	AS_LeftRight(a4)
		bge.s	.right_noright

			lea	TempBuffer2,a2			; 16 Bit output buffer (temporary before scaling)
			move.w	#SamLEN*2,d0			;
			move.l	VtabaddrR(pc),a6
			movem.l	a1/a4/d7,-(sp)			; no registers saved by mixer, store needed pointers
			jsr	(a1)				; mix
			movem.l	(sp)+,a1/a4/d7
			tst.w	d0
			beq	.right_nochannel		;we expect that moveq is the last command
			
			add.w	#1,.curchannelsr
			move.l	mixad2,a1	;	
.right_nochannel:
.right_noright:
		lea	AS_Sizeof(a4),a4
		dbf	d7,.right_loop

		; if no channel was active, Tempbuffer will be "dirty", use pointer to 0-buffer in these cases
		lea	Tempbuffer2,a0
		move	.curchannelsr(pc),d0
		bne.s	.rightok1
		lea	ZeroSamplebuffer,a0
.rightok1:	move.l	a0,.rbuffer
.noright:

	;--------------------- perform mono/surround, copy to ChipRAM  ----------------------
	move.l	.lbuffer(pc),a0			; 16 Bit mixing buffer (before scaling or zero buffer)
	move.l	.rbuffer(pc),a2			; 16 Bit mixing buffer (before scaling or zero buffer)

	move.l	.fillbuffer(pc),a1		;main output buffer
	move.l	UPSBuffer0,a5			;main UPS buffer
	move.l	UPSBuffer1,a4			;main UPS buffer

	move.l	cbufad,a6
	tst.w	.curchannelsl
	bne.s	.left_notempty
	tst.w	.curchannelsr
	bne.s	.right_notempty
	move.l	cbufempty,a6
	bra.s	.left_nofilter
.right_notempty:
.left_notempty:
	; highboost left/right (pointless with a good sound card, TODO: disable last entry in cycle gadget)
	move.l	boostad(pc),d0
	beq.s	.left_nofilter
	push	all
	move.l	d0,a5
	lea	HB_DelayL,a1
	move	#SamLEN*2,d7
	push	a2/a5
	jsr	(a5)	
	pop	a0/a5
	lea	HB_DelayR,a1
	move	#SamLEN*2,d7
	jsr	(a5)				
	pop	all

.left_nofilter:
	lea	TBufLeft,a3
	move	prefetchL(pc),d0
	jsr	(a6)

	;-------------- Copy Audio Structure back to Player, if necessary -------------------------
	bsr	CopyASBack
	movem.l	(sp)+,d0-a6
	moveq	#0,d0
	rts
	
	; active left/right buffers, either Tempbuffer or Zerobuffer
.lbuffer	dc.l	0
.rbuffer	dc.l	0
	; num active channels left/right
.curchannelsl:	dc.w	0
.curchannelsr:	dc.w	0
.fillbuffer	dc.l	0

;-----------------------------------------------------------------------------------------------------
;-----------------------------------------------------------------------------------------------------
;--------------------------------- 16 Bit Output Routines  -------------------------------------------
;-----------------------------------------------------------------------------------------------------
; Concept:   collect a variable number of channels in the mixing routines (unsigned), and scale it to
;            the relevant 14 bit dynamic range afterwards
; Workflow:

; There are several routines for this phase:
;  1. empty copy   - just zeroes the chipram buffer when no mixing was done
;  2. stereo copy  - fill one chipram buffer pair per channel
;  3. surround copy- apply the delayed opposite channel to the current channel
;                  - branch to stereo copy
;
; Input:
; Output:
;         -
;
; Used Registers: all, none saved
; 
; Notes/Caveats: 
;        number of samples still hardcoded (SamLEN*2)
;-----------------------------------------------------------------------------------------------------



;---------------------- no channel playing, write silence to two channels --
; Inputs:
;  D0 - prefetch
;  A0 - input samples left channel, 16 bit signed
;  A1 - output samples 16 bit, interleaved 
;  A2 - input samples right channel, 16 bit signed
;  A3 - temp buffer for delayed samples in mono/surround
;  A4 - UPS buffer in fastram (right)
;  A5 - UPS buffer in fastram (left)
copybufemptyStereoA:
	ifne	benchmark
	move	#$3ff,$dff180
	endc

	move	#SamLEN*2/16-1,d7
	moveq.l	#0,d1
	moveq.l	#0,d2
	moveq.l	#0,d3
	moveq.l	#0,d4

	add.l	#SamLEN*2*4,A1	;Samlen*2 samples, *32 bit per entry
	add.l	#SamLEN*2,A4
	add.l	#SamLEN*2,A5
.ldd3
	movem.l	d1-d4,-(a1)	;main samples
	movem.l	d1-d4,-(a1)	;main samples
	movem.l	d1-d4,-(a1)	;main samples
	movem.l	d1-d4,-(a1)	;main samples

	movem.l	d1-d4,-(a4)	;UPS buffer
	movem.l	d1-d4,-(a5)	;UPS buffer
	dbf	d7,.ldd3

	ifne	benchmark
	move	#$888,$dff180
	endc
	rts

;---------------------- fuer Stereo 14 Bit ---------------------
; Inputs (*=used here):
;  D0 - prefetch
;  A0 - input samples left channel, 16 bit signed
;  A1 - output samples 16 bit, interleaved 
;  A2 - input samples right channel, 16 bit signed
;  A3 - temp buffer for delayed samples in mono/surround
;  A4 - UPS buffer in fastram (right)
;  A5 - UPS buffer in fastram (left)
copybufStereoA:		;for 68020-68060, UPS Struktur in fast ram
	ifne	benchmark
	move	#$0ff,$dff180
	endc

	move.l  buff14_2(pc),a6 	;middle of the boost table

	move	#SamLEN*2/2-1,d7	;mixed samples=SamLEN*2

.ldd3
        movem.w	(a0)+,d0/d1		;left
	movem.w	(a2)+,d2/d3		;right
        move    (a6,d0.l*2),d0		;l0
        move    (a6,d1.l*2),d1		;l1
	move	d0,d4		;UPS L0.w
	move	d1,d5		;UPS L1.w
	swap	d0
	move    (a6,d2.l*2),d2		;r0
	lsr.w	#8,d5		;UPS L1.b
	swap	d1
	move.b	d5,d4		;UPS L0.b L1.b
	move    (a6,d3.l*2),d3		;r1
	move.w	d4,(a5)+	;UPS L
	move.w	d2,d0			;l0 r0
	move.w	d3,d1			;l1 r1
	lsr.w	#8,d3		;l1.b
	move.l	d0,(a1)+
	move.b	d3,d2		;l0 l1
	move.l	d1,(a1)+
	move	d2,(a4)+	;UPS R
        dbf     d7,.ldd3

	ifne	benchmark
	move	#$0,$dff180
	endc

	rts

;---------------------- Surround 16 Bit ---------------------
; Inputs:
;  D0 - prefetch (ignored here, variables read directly)
;  A0 - input samples left channel, 16 bit signed
;  A1 - output samples 16 bit, interleaved 
;  A2 - input samples right channel, 16 bit signed
;  A3 - temp buffer for delayed samples in mono/surround
;  A4 - UPS buffer in fastram (right)
;  A5 - UPS buffer in fastram (left)
;
; Notes: empty copy routine disabled in surround mode because of other channel possibly
;        contributing to sum channel
; - prefetchL, prefetchR accessed directly in here
; - TBufLeft, TBufRight accessed directly in here
; Note:

; todo: change order of first / second word for better scheduling of UPS operation
surroundT	macro
	move	d6,d1		;volume multiplier
	move	d6,d2		;volume multiplier
	muls	(a6)+,d1	;other channel data * volume
	muls	(a6)+,d2	;
	addq.l	#8,a3		;next output position
	asr.l	#6,d1		;divide by 64
	asr.l	#6,d2		;divide by 64
	add.w	(a0),d1		;current channel input
	add.w	2(a0),d2	;current channel input
	addq.l	#4,a0		;input forward
	move    (a4,d1.w*2),(a3) ;with boost
	;move	d1,(a3)		;no boost
	move    (a4,d2.w*2),4(a3) ;with boost
	;move	d2,4(a3)	;no boost

		endm

ups_T	macro
	lsr.w	#8,d2
	move.b	d2,d1
	move	d1,(\1)+
	endm

copybufSurroundA:	;68040/68060 targeted routine (multiplies instead of table accesses)
	ifne	benchmark
	move	#$4f4,$dff180
	endc


	move	#SamLEN,d7	;mixed samples=SamLEN*2, two operations in each run, hence no * 2 here
	push	a0		;input left (see below pop a6)
	push	a4		;store UPS pointer for right channel (gets back to a5 later)

	move.l  buff14_2(pc),a4 	;middle of the boost table

	move	effectvol(pc),d6	; effect volume 0..64
	neg.w	d6			; negative: we want inverse additions

	;------------- left channel --------------------------
	lea	TBufRight,a6	;Temp buffer, stored from last run
	lea.l	-8(a1),a3	;ignore temp buffer in A3 -> load output array to A3 -8 (pre-increment in loop)

	move	prefetchL(pc),d0
	move	d7,d5
	sub.w	d0,d5
	subq	#1,d0
prefetchL1$
	surroundT		;modified d1,d2,a0,a3,a6, used d6
	ups_T	a5

	dbf	d0,prefetchL1$

	;fill rest with data from current right channel
	subq.w	#1,d5
	lea	(a2),a6		;current right channel
mainsurroundL1$
	surroundT		;modified d1,d2,a0,a3,a6, used d6
	ups_T	a5
	dbf	d5,mainsurroundL1$

	; post-processing: copy data to temp buffer for next run
	lea	TBufRight,a3	;Temp buffer, stored from last run
	move	prefetchL(pc),d0
	subq	#1,d0
left_post$
	move.l	(a6)+,(a3)+
	dbf	d0,left_post$

	pop	a5		;restore UPS pointer for right channel (from push a4)
	;------------- right channel --------------------------
	lea	TBufLeft,a6	;Temp buffer, stored from last run
	lea	-6(a1),a3	;output array right channel to A3 (-8+2 = first byte right channel -8)
	move.l	a2,a0		;input right channel
	move	prefetchR(pc),d0
	move	d7,d5
	sub.w	d0,d5
	subq	#1,d0
prefetchR1$
	surroundT		;modified d1,d2,a0,a3,a6, used d6
	ups_T	a5
	dbf	d0,prefetchR1$

	;fill rest with data from current left channel
	pop	a6		;input left (from push a0)
	subq.w	#1,d5
mainsurroundR1$
	surroundT		;modified d1,d2,a0,a3,a6, used d6
	ups_T	a5
	dbf	d5,mainsurroundR1$

	; post-processing: copy data to temp buffer for next run
	lea	TBufLeft,a3	;Temp buffer, stored from last run
	move	prefetchR(pc),d0
	subq	#1,d0
right_post$
	move.l	(a6)+,(a3)+
	dbf	d0,right_post$

	rts

;---------------------- Mono 16 Bit ---------------------
; Inputs:
;  D0 - prefetch
;  A0 - input samples main channel (left/right)
;  A1 - output samples high volume channel
;  A2 - input samples other channel (for mono/surround)
;  A3 - temp buffer for delayed samples in mono/surround
;  A4 - output samples low volume channel
;  A5 - UPS buffer in fastram, same contents as high volume channel
;
; Notes: - empty copy routine disabled in surround mode because of other channel possibly
;          contributing to sum channel
;        - slow...
;        - UPS output does not respect boost
copybufMonoA:
	ifne	benchmark
	move	#$0ff,$dff180
	endc

	move	effectvol(pc),d6	; effect volume 0..64

	move.l  buff14_2(pc),a6 	;middle of the boost table

	move	#SamLEN*2-1,d7		;mixed samples=SamLEN*2
.ldd3
        move.w	(a0)+,d0		;left
	move	d6,d4
	move	d6,d5
	move.w	(a2)+,d2		;right
	muls	d0,d4			;left*effect
	muls	d2,d5			;right*effect
	asr.l	#6,d4			;left*effect/64
	asr.l	#6,d5			;right*effect/64
	add	d5,d0
	add	d4,d2
        move    (a6,d0.w*2),(a1)+	;volume boost table (nonlinear)
	move    (a6,d2.w*2),(a1)+	;volume boost table (nonlinear)
	lsr.w	#8,d0
	lsr.w	#8,d2
	move.b	d0,(a5)+
	move.b	d2,(a4)+
        dbf     d7,.ldd3

	ifne	benchmark
	move	#$0,$dff180
	endc
	rts


;--------------------- return whether this output hardware is available --------------------------------
;input:  A5 - datas
;output: D0 - 1=yes, 0=no
;regs:   all saved (except D0)
;
AHIAMP_Check:
	push	d1-a6
	moveq	#0,d7

	; quick check for AHI device
        move.l  4.w,a6
        lea     AHIAMP_Dosname(pc),a1
        moveq   #33,d0
        jsr     _LVOOpenLibrary(A6)     ;Open DOS
        tst.l   d0
        beq     error$
	move.l	d0,a6

	lea	AHIAMP_AHIDev(pc),a0
	move.l	a0,d1
	move.l	#ACCESS_READ,d2
	jsr	_LVOLock(a6)
	move.l	d0,d1
	beq.s	nolock1$
	jsr	_LVOUnLock(a6)
	addq.l	#1,d7
nolock1$
	lea	AHIAMP_AHIAud(pc),a0
	move.l	a0,d1
	move.l	#ACCESS_READ,d2
	jsr	_LVOLock(a6)
	move.l	d0,d1
	beq.s	nolock2$
	jsr	_LVOUnLock(a6)
	addq.l	#1,d7
nolock2$

	move.l	a6,a1
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)


	moveq	#0,d0	;error
	subq.w	#2,d7	;2 files checked, so this must be 2 in success case
	bne.s	error$

	moveq	#1,d0
error$
	pop	d1-a6
	rts

AHIAMP_Dosname:	dc.b	`dos.library`,0
AHIAMP_AHIDev:	dc.b	`devs:ahi.device`,0
AHIAMP_AHIAud:	dc.b	`devs:Audiomodes`,0

; In
;  A0 - tag list
;  A5 - EP Base
; Out:
;  D0 == 0 -> OK, D0 < 0 -> error
AHIAMP_CheckReqs:	;check requirements of current replayer whether we can meet them
	move.l	#EPAMT_Flags,d0
	jsr	ENPP_FindTag(A5)
	beq	.err

	moveq	#1,d2
	move.l	d0,d1
	move.l	d0,d6
	and.l	#EPAMB_WaitForStruct,d6

	and.l	#EPAMB_8Bit,d0
	bne	.ok

	moveq	#2,d2
	btst	#EPAMF_8BitUnsigned,d1
	bne	.ok
	
	moveq	#3,d2
	btst	#EPAMF_16Bit,d1			;erstmal nur 16 Bit signed
	beq	.err
.ok
	move.b	d2,fformat

	move.l	#EPAMT_Audiostructs,d0
	jsr	ENPP_FindTag(A5)
	beq	.err
	move.l	d0,d7

	move.l	#EPAMT_NumStructs,d0
	jsr	ENPP_FindTag(A5)
	beq	.err
	move.l	d7,a0

	move	d0,numstructs

	subq.w	#1,d0			;Anzahl der Audio-Strukturen
	blt	.err

	moveq	#0,d1
	moveq	#0,d2
	lea	(a0),a2
.countvoc
	tst.w	AS_LeftRight(a2)
	bpl.s	.addL
	bmi.s	.addR
	bra.s	.noADD
.addL
	cmp.w	#2,AS_Leftright(a2)
	beq	.err
	addq.w	#1,d1
	bra.s	.noADD
.addR
	addq.w	#1,d2
.noadd
	lea	as_sizeof(a2),a2
	dbf	d0,.countvoc

	move.w	d1,numleft		;remember left/right voices -> may still lead to error (!)
	move.w	d2,numright

	move.l	#mix,mixad1		;sane default: 8 bit mixing
	move.l	#mix2,mixad2		;sane default: 8 bit mixing -> will be overwritten by setMixRoutine call
	st	onplay

	move.w	d2,d0
	add.w	d1,d0
	beq	.err			;no active voices ? none ? any ? Why, but why ?

	cmp	#MaxVoices,d0		;more than 32 active voices ?
	bhi	.err			;bail out for now (though it would be easy to support more than that)

        cmp.b   #3,fformat
        bne.s   .normal8bit

        cmp     #1,d2			;currently, only two channels supported in 16 Bit mode -> subject to change
        bne     .err
        cmp     #1,d1
        bne     .err

.normal8bit
	subq.w	#2,d0
	bgt.s	.hi1
	moveq	#0,d0
.hi1
	mulu	#P_Sizeof,d0
	lea	Prefslist+datas,a1
	lea	(a1,d0.w),a1
	move.l	a1,usedmode
	
	move.w	P_Flags(A1),d0		;Flags.w (Bit0=disable)
	and.b	#PBB_Disable,d0
	bne	.err			;Modus disabled !!

	move.l	a0,epg_audiostruct(A5)	;Audiostruct setzen
	tst.l	d6			;Flag fuer "WaitforStruct" gesetzt ?
	beq.s	.normal
	lea	Extra_AS,a0		;ja, also eigene AS Struktur verwenden
.normal
	move.l	a0,myAudioStruct	;AudioStruct vom Replayer sichern

	bsr	setMixRoutine		;requires "usedmode"

	bsr	InitTables
	bne.s	.err2

	move.l	usedmode,a1
	move.b	P_Surround(a1),d0		;Playmode
	ext.w	d0
	ext.l	d0
	bsr	AHIAMP_SetPlayMode

	move.b	P_SurroundDelay(a1),d0
	bsr	setPrefetch

	moveq	#0,d0
	move.w	P_Vboost(a1),d0
	bsr	AHIAMP_SetBoost

	move.l	P_AHIMode(a1),d0	;AHI Mode ID
	move.l	d0,AHIAMP_AHIModeID	;store requested Mode ID
	move.l	P_Mixrate(a1),d0
	move.l	d0,AHIAMP_AHIRate	;store requested Mixrate

	move.w	numleft,d0
	add.w	numright,d0
	bsr	SelectEntry

	bsr	Copy_AS2

	moveq	#0,d0
	rts
.err
	moveq	#-1,d0
.err2
	sf	onplay
	rts



;--------------------------------------------------------------------
; Init/End
;          - Initplayer -> A0: tag list
;                          A5: EP globals (not Amplifier globals!)
;                       -> return  D0: 0=OK, <>0=Error
;
; Start-Stop: Startint (no parameters, except A5=EP globals)
;
;             Stopint  (no parameters, except A5=EP globals)
;
AHIAMP_Init:
	; general init
	bsr	AHIAMP_CheckReqs	;check requirements of current replayer whether we can meet them
	tst.l	d0
	bne.w	AHIAM_INIT_failAHI

	move.l	AHIAMP_AHIBase(pc),d0
	beq.s	AHIAM_INIT_failAHI
	move.l	d0,a6

	; get default mode
	lea	AHIAMP_AHIBestTags(pc),a1
	jsr	_LVOAHI_BestAudioIDA(a6)
	move.l	d0,AHIAMP_AHIDefModeID
	cmp.l	#AHI_INVALID_ID,d0
	beq.s	AHIAM_INIT_failAHI

	moveq	#0,d0
	rts
AHIAM_INIT_failAHI:
	moveq	#-1,d0
	rts



AHIAMP_End:
	sf	onplay
	move    #-1,Currentnumvoc+datas         ;kein Modul am Spielen


	bsr     myFreemem                       ;clear allocated memory

	moveq	#0,d0
	rts



AHIAMP_StartInt:
        lea     StartBSSBuffer,a0
        move.l  #[ENDBSSBUFFER-StartBSSBuffer],d0
        bsr     ClearBuf

	move.l  AHIAMP_AHIBase(pc),d0
	beq.w	noAHI$
	move.l	d0,a6

	move.l	AHIAMP_AHIModeID(pc),d0
	cmp.l	#AHI_INVALID_ID,d0
	beq.s	useDef$
	cmp.l	#AHI_DEFAULT_ID,d0	; no user config yet, use "best mode" in obtained on startup
	beq	useDef$			;

	move.l	AHIAMP_AHIRate(pc),d1
	bra.s	alloc$
useDef$
	move.l	AHIAMP_AHIDefModeID(pc),d0
	move.l	#28600,d1
alloc$
	;d1: rate, d0: mode -> find best frequency
	bsr	AHIAMP_BestFrequency
	;d1: best frequency
	;move.l	d0,AHIAMP_CurModeID
	move.l	d1,AHIAMP_CurFrequency

	;  audioctrl = AHI_AllocAudioA( tags );
        ;  D0                           A1
	lea     AHIAMP_Tagbuffer,a1
	move.l	#AHIA_AudioID,(a1)+
	move.l	d0,(a1)+
	move.l	#AHIA_MixFreq,(a1)+
	move.l	d1,(a1)+
	move.l	#AHIA_Channels,(a1)+
	move.l	#1,(a1)+
	move.l	#AHIA_Sounds,(a1)+
	move.l	#2,(a1)+
	move.l	#AHIA_SoundFunc,(a1)+
	lea	AHIAMP_Hook(pc),a0
	move.l	a0,(a1)+
;	move.l	#AHIA_UserData,(a1)+
;	move.l	#0,(a1)+
	move.l	#TAG_DONE,(a1)+
	lea     AHIAMP_Tagbuffer,a1
	jsr	_LVOAHI_AllocAudioA(a6)
	move.l	d0,AHIAMP_Control
	beq.w	noAHI$
	;
	; initialize callback hook
	lea	AHIAMP_Hook(pc),a0
	lea	AHIAMP_CallbackFunc(pc),a1
	move.l	a1,h_Entry(a0)		;
	move.l	a1,h_SubEntry(a0)	;we want the lowlevel entry point
	clr.l	h_Data(a0)		;no data (yet)

	lea	datas,a5		;better safe than sorry....
	move.l	AHIAMP_CurFrequency(pc),d0
	bsr	AHIAMP_CalcnewmixingPeriod

	clr.l	tmpvol
	clr.w	tmpvol2
	clr.l	calcvol
	clr.l	calcvol+4
	move.l	newmixingperiod(pc),mixingperiod

	;
	; we have an audio control: now define sounds and start playing
	;
        ;error = AHI_LoadSound( sound, type, info, audioctrl );
        ;D0                     D0:16  D1    A0    A2
	;sound 0
	lea	AHIAMP_Sample0(pc),a0
	move.l	#AHIST_S16S,ahisi_Type(a0)
	lea	AHIAMP_Buffer0,a1
	move.l	a1,ahisi_Address(a0)
	move.l	#SamLEN*2,ahisi_Length(a0)	;SamLEN*2 stereo samples

	moveq	#0,d0
	move.l	d0,AHIAMP_Sound0
	moveq	#AHIST_DYNAMICSAMPLE,d1
	move.l	AHIAMP_Control(pc),a2
	jsr	_LVOAHI_LoadSound(a6)
	tst.l	d0
	bne.w	failAHI$

	;sound 1
	lea	AHIAMP_Sample1(pc),a0
	move.l	#AHIST_S16S,ahisi_Type(a0)
	lea	AHIAMP_Buffer1,a1
	move.l	a1,ahisi_Address(a0)
	move.l	#SamLEN*2,ahisi_Length(a0)	;SamLEN*2 stereo samples

	moveq	#1,d0
	move.l	d0,AHIAMP_Sound1
	moveq	#AHIST_DYNAMICSAMPLE,d1
	move.l	AHIAMP_Control(pc),a2
	jsr	_LVOAHI_LoadSound(a6)
	tst.l	d0
	bne.w	failAHI$

	;initialize doublebuffer
	lea	AHIAMP_DSound(pc),a0
	move.l	AHIAMP_Sound0(pc),(a0)
	move.l	AHIAMP_Sound1(pc),4(a0)
	lea	AHIAMP_Sample0(pc),a1
	move.l	a1,AHIAMP_DSample-AHIAMP_DSound(a0)
	lea	AHIAMP_Sample1(pc),a1
	move.l	a1,AHIAMP_DSample-AHIAMP_DSound+4(a0)

	;start play
	;       error = AHI_ControlAudioA( audioctrl, tags );
	;       D0                         A2         A1
	lea	AHIAMP_Tagbuffer,a1
	move.l	#AHIC_Play,(a1)+
	move.l	#1,(a1)+
	move.l	#TAG_DONE,(a1)+
	lea	AHIAMP_Tagbuffer,a1
	move.l	AHIAMP_Control(pc),a2
	jsr	_LVOAHI_ControlAudioA(a6)

	; define sound parameters
	lea	AHIAMP_Tagbuffer,a1
	move.l	#AHIP_BeginChannel,(a1)+
	clr.l	(a1)+
	move.l	#AHIP_Freq,(a1)+
	move.l	AHIAMP_CurFrequency(pc),(a1)+
	move.l	#AHIP_Vol,(a1)+
	move.l	#$10000,(a1)+
	move.l	#AHIP_Pan,(a1)+
	move.l	#$8000,(a1)+
	move.l	#AHIP_Sound,(a1)+
	move.l	AHIAMP_DSound(pc),(a1)+
	move.l	#AHIP_Offset,(a1)+
	clr.l	(a1)+
	move.l	#AHIP_Length,(a1)+
	clr.l	(a1)+
	move.l	#AHIP_EndChannel,(a1)+
	clr.l	(a1)+
	move.l	#TAG_DONE,(a1)+
	lea     AHIAMP_Tagbuffer,a1
	move.l	AHIAMP_Control(pc),a2
	jsr	_LVOAHI_PlayA(a6)

	bsr	AHIAMP_StartUPS
	; 
	moveq	#0,d0
	rts
noAHI$
failAHI$
	moveq	#-1,d0
	rts



AHIAMP_StopInt:
	move.l	AHIAMP_Control(pc),d0
	beq.s	noControl$
	move.l	d0,a2
	move.l	AHIAMP_AHIBase(pc),a6

	; stop play
	lea	AHIAMP_Tagbuffer,a1
	move.l	#AHIC_Play,(a1)+
	clr.l	(a1)+
	move.l	#TAG_DONE,(a1)+
	lea	AHIAMP_Tagbuffer,a1
	move.l	AHIAMP_Control(pc),a2
	jsr	_LVOAHI_ControlAudioA(a6)

	;       AHI_UnloadSound( sound, audioctrl );
	;                        D0:16  A2
	; should be done by FreeAudio() ....
	moveq	#0,d0
	jsr	_LVOAHI_UnloadSound(a6)
	moveq	#1,d0
	jsr	_LVOAHI_UnloadSound(a6)

	;       AHI_FreeAudio( audioctrl );
	;                      A2
	jsr	_LVOAHI_FreeAudio(a6)

	clr.l	AHIAMP_Control
noControl$
	rts



;       A0 - pointer to hook itself
;       A1 - pointer to parameter packet ("message")
;       A2 - Hook specific address data ("object," e.g, gadget )
AHIAMP_CallbackFunc:
	push	d0-a6

	; buffer swap
	lea	AHIAMP_DSound(pc),a0
	move.l	(a0),d0
	move.l	4(a0),(a0)
	move.l	d0,4(a0)
	move.l	AHIAMP_DSample-AHIAMP_DSound(a0),d0
	move.l  4+AHIAMP_DSample-AHIAMP_DSound(a0),AHIAMP_DSample-AHIAMP_DSound(a0)
	move.l	d0,4+AHIAMP_DSample-AHIAMP_DSound(a0)

	;fill the current buffer, then append sound to the "play list"
	move.l	AHIAMP_DSample(pc),a0
	move.l	ahisi_Address(a0),a0
	move.l	#SamLEN*2,d0
	bsr	AHIAMP_DoMix

	; AHI_SetSound( channel, sound, offset, length, audioctrl, flags );
        ;               D0:16   D1:16   D2      D3      A2         D4
	moveq	#0,d0
	move.l	AHIAMP_DSound(pc),d1	;current sound index
	moveq	#0,d2	;offset
	moveq	#0,d3	;length
	moveq	#0,d4	;flags
	move.l	AHIAMP_Control(pc),a2
	move.l  AHIAMP_AHIBase(pc),a6
	jsr	_LVOAHI_SetSound(a6)

	
	pop	d0-a6
	moveq	#0,d0
	rts



; Find best mixrate
;  D0 - modeID
;  D1 - desired mixrate
; output:
;  D1 - 
AHIAMP_BestFrequency:
	push	d0/d2-a6
        ;success = AHI_GetAudioAttrsA( ID, [audioctrl], tags );
        ;D0                            D0  A2           A1

	lea	AHIAMP_Tagbuffer,a1
	move.l	#AHIDB_IndexArg,(a1)+
	move.l	d1,(a1)+
	move.l	#AHIDB_Index,(a1)+
	lea	AHIAMP_Index(pc),a0
	move.l	a0,(a1)+
	move.l	#TAG_DONE,(a1)+
	lea     AHIAMP_Tagbuffer,a1
;AHIDB_Name
;AHIDB_AudioID

	moveq	#0,d1
	move.l	AHIAMP_AHIBase(pc),d2
	beq.s	noAHI$
	move.l	d2,a6
	suba.l	a2,a2
	move.l	d0,d7	;remember Mode ID
	jsr	_LVOAHI_GetAudioAttrsA(A6)
	move.l	d7,d0	;restore Mode ID

	lea     AHIAMP_Tagbuffer,a1
	move.l	#AHIDB_FrequencyArg,(a1)+
	move.l	AHIAMP_Index(pc),(A1)+
	move.l	#AHIDB_Frequency,(a1)+
	lea	AHIAMP_AHIFoundRate(pc),a0
	move.l	a0,(a1)+
	move.l  #TAG_DONE,(a1)+

	lea     AHIAMP_Tagbuffer,a1
	suba.l	a2,a2
	jsr	_LVOAHI_GetAudioAttrsA(A6)

	move.l	AHIAMP_AHIFoundRate(pc),d1
noAHI$
	pop	d0/d2-a6
	rts

AHIAMP_StartUPS:
	push	all
        lea     myupsstruct,a1
        move.w  #UPSB_Adr!UPSB_LEN!UPSB_Per!UPSB_Vol!UPSB_DMACON,ups_flags(a1)
        move.w  #15,UPS_DmaCon(a1)
        clr.w   UPS_Enabled(a1)

        move.w  #64,ups_voice1vol(a1)
        move.w  #64,ups_voice2vol(a1)
        move.w  #0,ups_voice3vol(a1)
        move.w  #0,ups_voice4vol(a1)

        move.l  newmixingperiod(pc),d0
        move.w  d0,ups_voice1per(a1)
        move.w  d0,ups_voice2per(a1)
        clr.w   ups_voice3per(a1)
        clr.w   ups_voice4per(a1)

        move.w  #SamLEN,ups_voice1len(A1)
        move.w  #SamLEN,ups_voice2len(A1)
        clr.w   ups_voice3len(A1)
        clr.w   ups_voice4len(A1)

        lea     myupsstruct,a6
        movem.l UPSBuffer0(pc),d3-d4
        move.l  d3,ups_voice1adr(A6)
        move.l  d4,ups_voice2adr(A6)
        clr.l   ups_voice3adr(A6)
        clr.l   ups_voice4adr(A6)
	pop	all
	rts

;AHIAMP_utilityname	dc.b	'utility.library',0
		cnop	0,4

	; libraries, memory and stuff...
AHIAMP_AHIBase:		dc.l	0
;AHIAMP_Utilitybase	dc.l	0
AHIAMP_AHIDefModeID:	dc.l	AHI_DEFAULT_ID	;fallback: default mode

AHIAMP_AHIModeID:	dc.l	AHI_INVALID_ID		;
AHIAMP_AHIRate:		dc.l	28862			;
AHIAMP_Index:		dc.l	0
AHIAMP_AHIFoundRate:	dc.l	0

;AHIAMP_CurModeID:	dc.l	0	;mode to use for startint/stopint
AHIAMP_CurFrequency:	dc.l	0
AHIAMP_Control:		dc.l	0	;current audio control after audio alloc

; internal Sound structuring: 1 DW ID, then AHISampleInfo
AHIAMP_Sound0:		dc.l	0
AHIAMP_Sample0:		ds.b	AHISampleInfo_SIZEOF

AHIAMP_Sound1:		dc.l	0
AHIAMP_Sample1:		ds.b	AHISampleInfo_SIZEOF

;Double buffering data
AHIAMP_DSound:		dc.l	0,0
AHIAMP_DSample:		dc.l	0,0

AHIAMP_Hook:		ds.b	h_SIZEOF	;callback hook
			
;/* default best mode Tags */
AHIAMP_AHIBestTags:	dc.l	AHIDB_Panning,1
			dc.l	AHIDB_Stereo, 1
			dc.l	AHIDB_MaxChannels, 1
			dc.l	AHIDB_MinMixFreq, 22050
			dc.l	AHIDB_MaxMixFreq, 44100
			dc.l	AHIDB_Bits, 16 
			dc.l	TAG_DONE
AHIAMP_ModeFilterTags:	dc.l	AHIDB_Stereo,1
			dc.l	AHIDB_Panning,1
			;dc.l	AHIDB_Bits,16
			dc.l	TAG_DONE			

	endc

