*****************************************************************************
** Engine: 14 Bit Amplifier II                                             **
**                                                                         **
** Project: Eagleplayer 2.05                                               **
** Authors: Jan Blumenthal & Henryk Richter                                **
** Start  : 1993/01/09                                                     **
** $Rev: 23 $ $Author: buggs $                                             **
** $Date: 2016-08-22 20:00:02 +0200 (Mo, 22. Aug 2016) $                   **
**                                                                         **
*****************************************************************************
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program (See the included file COPYING);
** if not, write to the Free Software Foundation, Inc.,
** 675 Mass Ave, Cambridge, MA 02139, USA.
**
**************************************************************************** 
;	ifnd	INC_AMPOUT_FILTERTABLES4	;disabled: confuses ASM-Pro
;INC_AMPOUT_FILTERTABLES4	equ	1
; Notes:
;  the 1/16 sample accuracy variant doesn't include downsampling tables yet

	;external definitions:
	;  fmix_accuracy (0/1), where 0 = 1/16 sample accuracy, 1=1/32 sample accuracy
	;defined in filter tables:
	;  FM_tabs, 1<<FM_tabs_Bits entries as pointers to shorts
	;  FM_sinc_norm, pre-multiplier (actual value = FM_sinc_norm/32768)
	
	; TABLE for upsampling, assuming scale 1.0 for sinc wave
	ifne	fmix_accuracy			 	;0=1/16 sample polyphase, 1=1/32 sample polyphase

	ifne	1	; set this to 0 if you don't want downsampling support (shorter tables but potential aliasing problems)

FM_tabs:
	dc.l	FM_tab_100
	dc.l	FM_tab_138
	dc.l	FM_tab_165
	dc.l	FM_tab_192

;/* normalization by 1.563230e+00 */
FM_sinc_norm  EQU  20961
FM_tab_100:
	 dc.w	0,32596,0,0
	 dc.w	-810,32745,884,-222
	 dc.w	-1555,32767,1851,-468
	 dc.w	-2230,32662,2899,-734
	 dc.w	-2834,32427,4022,-1020
	 dc.w	-3364,32065,5218,-1323
	 dc.w	-3821,31577,6481,-1640
	 dc.w	-4204,30965,7803,-1968
	 dc.w	-4513,30234,9178,-2303
	 dc.w	-4751,29390,10597,-2640
	 dc.w	-4919,28438,12052,-2976
	 dc.w	-5020,27387,13533,-3304
	 dc.w	-5057,26245,15030,-3621
	 dc.w	-5035,25020,16531,-3920
	 dc.w	-4958,23723,18027,-4196
	 dc.w	-4830,22364,19505,-4444
	 dc.w	-4657,20955,20955,-4657
	 dc.w	-4444,19505,22364,-4830
	 dc.w	-4196,18027,23723,-4958
	 dc.w	-3920,16531,25020,-5035
	 dc.w	-3621,15030,26245,-5057
	 dc.w	-3304,13533,27387,-5020
	 dc.w	-2976,12052,28438,-4919
	 dc.w	-2640,10597,29390,-4751
	 dc.w	-2303,9178,30234,-4513
	 dc.w	-1968,7803,30965,-4204
	 dc.w	-1640,6481,31577,-3821
	 dc.w	-1323,5218,32065,-3364
	 dc.w	-1020,4022,32427,-2834
	 dc.w	-734,2899,32662,-2230
	 dc.w	-468,1851,32767,-1555
	 dc.w	-222,884,32745,-810

	 dc.w	0,0,32596,0
	 dc.w	-222,-810,32745,884
	 dc.w	-468,-1555,32767,1851
	 dc.w	-734,-2230,32662,2899
	 dc.w	-1020,-2834,32427,4022
	 dc.w	-1323,-3364,32065,5218
	 dc.w	-1640,-3821,31577,6481
	 dc.w	-1968,-4204,30965,7803
	 dc.w	-2303,-4513,30234,9178
	 dc.w	-2640,-4751,29390,10597
	 dc.w	-2976,-4919,28438,12052
	 dc.w	-3304,-5020,27387,13533
	 dc.w	-3621,-5057,26245,15030
	 dc.w	-3920,-5035,25020,16531
	 dc.w	-4196,-4958,23723,18027
	 dc.w	-4444,-4830,22364,19505
	 dc.w	-4657,-4657,20955,20955
	 dc.w	-4830,-4444,19505,22364
	 dc.w	-4958,-4196,18027,23723
	 dc.w	-5035,-3920,16531,25020
	 dc.w	-5057,-3621,15030,26245
	 dc.w	-5020,-3304,13533,27387
	 dc.w	-4919,-2976,12052,28438
	 dc.w	-4751,-2640,10597,29390
	 dc.w	-4513,-2303,9178,30234
	 dc.w	-4204,-1968,7803,30965
	 dc.w	-3821,-1640,6481,31577
	 dc.w	-3364,-1323,5218,32065
	 dc.w	-2834,-1020,4022,32427
	 dc.w	-2230,-734,2899,32662
	 dc.w	-1555,-468,1851,32767
	 dc.w	-810,-222,884,32745

	 dc.w	0,0,0,32596
	 dc.w	884,-222,-810,32745
	 dc.w	1851,-468,-1555,32767
	 dc.w	2899,-734,-2230,32662
	 dc.w	4022,-1020,-2834,32427
	 dc.w	5218,-1323,-3364,32065
	 dc.w	6481,-1640,-3821,31577
	 dc.w	7803,-1968,-4204,30965
	 dc.w	9178,-2303,-4513,30234
	 dc.w	10597,-2640,-4751,29390
	 dc.w	12052,-2976,-4919,28438
	 dc.w	13533,-3304,-5020,27387
	 dc.w	15030,-3621,-5057,26245
	 dc.w	16531,-3920,-5035,25020
	 dc.w	18027,-4196,-4958,23723
	 dc.w	19505,-4444,-4830,22364
	 dc.w	20955,-4657,-4657,20955
	 dc.w	22364,-4830,-4444,19505
	 dc.w	23723,-4958,-4196,18027
	 dc.w	25020,-5035,-3920,16531
	 dc.w	26245,-5057,-3621,15030
	 dc.w	27387,-5020,-3304,13533
	 dc.w	28438,-4919,-2976,12052
	 dc.w	29390,-4751,-2640,10597
	 dc.w	30234,-4513,-2303,9178
	 dc.w	30965,-4204,-1968,7803
	 dc.w	31577,-3821,-1640,6481
	 dc.w	32065,-3364,-1323,5218
	 dc.w	32427,-2834,-1020,4022
	 dc.w	32662,-2230,-734,2899
	 dc.w	32767,-1555,-468,1851
	 dc.w	32745,-810,-222,884

	 dc.w	32596,0,0,0
	 dc.w	32745,884,-222,-810
	 dc.w	32767,1851,-468,-1555
	 dc.w	32662,2899,-734,-2230
	 dc.w	32427,4022,-1020,-2834
	 dc.w	32065,5218,-1323,-3364
	 dc.w	31577,6481,-1640,-3821
	 dc.w	30965,7803,-1968,-4204
	 dc.w	30234,9178,-2303,-4513
	 dc.w	29390,10597,-2640,-4751
	 dc.w	28438,12052,-2976,-4919
	 dc.w	27387,13533,-3304,-5020
	 dc.w	26245,15030,-3621,-5057
	 dc.w	25020,16531,-3920,-5035
	 dc.w	23723,18027,-4196,-4958
	 dc.w	22364,19505,-4444,-4830
	 dc.w	20955,20955,-4657,-4657
	 dc.w	19505,22364,-4830,-4444
	 dc.w	18027,23723,-4958,-4196
	 dc.w	16531,25020,-5035,-3920
	 dc.w	15030,26245,-5057,-3621
	 dc.w	13533,27387,-5020,-3304
	 dc.w	12052,28438,-4919,-2976
	 dc.w	10597,29390,-4751,-2640
	 dc.w	9178,30234,-4513,-2303
	 dc.w	7803,30965,-4204,-1968
	 dc.w	6481,31577,-3821,-1640
	 dc.w	5218,32065,-3364,-1323
	 dc.w	4022,32427,-2834,-1020
	 dc.w	2899,32662,-2230,-734
	 dc.w	1851,32767,-1555,-468
	 dc.w	884,32745,-810,-222

FM_tab_138:
	 dc.w	8752,29200,8752,-4148
	 dc.w	7905,29231,9648,-4228
	 dc.w	7074,29208,10561,-4287
	 dc.w	6259,29132,11488,-4323
	 dc.w	5462,29000,12427,-4333
	 dc.w	4687,28813,13373,-4317
	 dc.w	3934,28570,14323,-4272
	 dc.w	3206,28271,15275,-4197
	 dc.w	2505,27917,16224,-4090
	 dc.w	1832,27508,17165,-3949
	 dc.w	1189,27045,18096,-3775
	 dc.w	578,26529,19013,-3564
	 dc.w	0,25963,19910,-3318
	 dc.w	-543,25348,20785,-3034
	 dc.w	-1051,24686,21633,-2713
	 dc.w	-1523,23981,22451,-2354
	 dc.w	-1957,23235,23235,-1957
	 dc.w	-2354,22451,23981,-1523
	 dc.w	-2713,21633,24686,-1051
	 dc.w	-3034,20785,25348,-543
	 dc.w	-3318,19910,25963,0
	 dc.w	-3564,19013,26529,578
	 dc.w	-3775,18096,27045,1189
	 dc.w	-3949,17165,27508,1832
	 dc.w	-4090,16224,27917,2505
	 dc.w	-4197,15275,28271,3206
	 dc.w	-4272,14323,28570,3934
	 dc.w	-4317,13373,28813,4687
	 dc.w	-4333,12427,29000,5462
	 dc.w	-4323,11488,29132,6259
	 dc.w	-4287,10561,29208,7074
	 dc.w	-4228,9648,29231,7905

	 dc.w	-4148,8752,29200,8752
	 dc.w	-4228,7905,29231,9648
	 dc.w	-4287,7074,29208,10561
	 dc.w	-4323,6259,29132,11488
	 dc.w	-4333,5462,29000,12427
	 dc.w	-4317,4687,28813,13373
	 dc.w	-4272,3934,28570,14323
	 dc.w	-4197,3206,28271,15275
	 dc.w	-4090,2505,27917,16224
	 dc.w	-3949,1832,27508,17165
	 dc.w	-3775,1189,27045,18096
	 dc.w	-3564,578,26529,19013
	 dc.w	-3318,0,25963,19910
	 dc.w	-3034,-543,25348,20785
	 dc.w	-2713,-1051,24686,21633
	 dc.w	-2354,-1523,23981,22451
	 dc.w	-1957,-1957,23235,23235
	 dc.w	-1523,-2354,22451,23981
	 dc.w	-1051,-2713,21633,24686
	 dc.w	-543,-3034,20785,25348
	 dc.w	0,-3318,19910,25963
	 dc.w	578,-3564,19013,26529
	 dc.w	1189,-3775,18096,27045
	 dc.w	1832,-3949,17165,27508
	 dc.w	2505,-4090,16224,27917
	 dc.w	3206,-4197,15275,28271
	 dc.w	3934,-4272,14323,28570
	 dc.w	4687,-4317,13373,28813
	 dc.w	5462,-4333,12427,29000
	 dc.w	6259,-4323,11488,29132
	 dc.w	7074,-4287,10561,29208
	 dc.w	7905,-4228,9648,29231

	 dc.w	8752,-4148,8752,29200
	 dc.w	9648,-4228,7905,29231
	 dc.w	10561,-4287,7074,29208
	 dc.w	11488,-4323,6259,29132
	 dc.w	12427,-4333,5462,29000
	 dc.w	13373,-4317,4687,28813
	 dc.w	14323,-4272,3934,28570
	 dc.w	15275,-4197,3206,28271
	 dc.w	16224,-4090,2505,27917
	 dc.w	17165,-3949,1832,27508
	 dc.w	18096,-3775,1189,27045
	 dc.w	19013,-3564,578,26529
	 dc.w	19910,-3318,0,25963
	 dc.w	20785,-3034,-543,25348
	 dc.w	21633,-2713,-1051,24686
	 dc.w	22451,-2354,-1523,23981
	 dc.w	23235,-1957,-1957,23235
	 dc.w	23981,-1523,-2354,22451
	 dc.w	24686,-1051,-2713,21633
	 dc.w	25348,-543,-3034,20785
	 dc.w	25963,0,-3318,19910
	 dc.w	26529,578,-3564,19013
	 dc.w	27045,1189,-3775,18096
	 dc.w	27508,1832,-3949,17165
	 dc.w	27917,2505,-4090,16224
	 dc.w	28271,3206,-4197,15275
	 dc.w	28570,3934,-4272,14323
	 dc.w	28813,4687,-4317,13373
	 dc.w	29000,5462,-4333,12427
	 dc.w	29132,6259,-4323,11488
	 dc.w	29208,7074,-4287,10561
	 dc.w	29231,7905,-4228,9648

	 dc.w	29200,8752,-4148,8752
	 dc.w	29231,9648,-4228,7905
	 dc.w	29208,10561,-4287,7074
	 dc.w	29132,11488,-4323,6259
	 dc.w	29000,12427,-4333,5462
	 dc.w	28813,13373,-4317,4687
	 dc.w	28570,14323,-4272,3934
	 dc.w	28271,15275,-4197,3206
	 dc.w	27917,16224,-4090,2505
	 dc.w	27508,17165,-3949,1832
	 dc.w	27045,18096,-3775,1189
	 dc.w	26529,19013,-3564,578
	 dc.w	25963,19910,-3318,0
	 dc.w	25348,20785,-3034,-543
	 dc.w	24686,21633,-2713,-1051
	 dc.w	23981,22451,-2354,-1523
	 dc.w	23235,23235,-1957,-1957
	 dc.w	22451,23981,-1523,-2354
	 dc.w	21633,24686,-1051,-2713
	 dc.w	20785,25348,-543,-3034
	 dc.w	19910,25963,0,-3318
	 dc.w	19013,26529,578,-3564
	 dc.w	18096,27045,1189,-3775
	 dc.w	17165,27508,1832,-3949
	 dc.w	16224,27917,2505,-4090
	 dc.w	15275,28271,3206,-4197
	 dc.w	14323,28570,3934,-4272
	 dc.w	13373,28813,4687,-4317
	 dc.w	12427,29000,5462,-4333
	 dc.w	11488,29132,6259,-4323
	 dc.w	10561,29208,7074,-4287
	 dc.w	9648,29231,7905,-4228

FM_tab_165:
	 dc.w	11589,24993,11589,-3052
	 dc.w	10902,24895,12199,-2878
	 dc.w	10225,24771,12808,-2685
	 dc.w	9557,24622,13413,-2474
	 dc.w	8899,24447,14015,-2243
	 dc.w	8252,24247,14611,-1992
	 dc.w	7617,24022,15201,-1722
	 dc.w	6995,23773,15783,-1433
	 dc.w	6385,23499,16357,-1123
	 dc.w	5789,23202,16921,-794
	 dc.w	5208,22881,17474,-445
	 dc.w	4642,22537,18015,-76
	 dc.w	4091,22172,18543,312
	 dc.w	3557,21785,19057,720
	 dc.w	3039,21377,19555,1147
	 dc.w	2539,20949,20037,1593
	 dc.w	2057,20502,20502,2057
	 dc.w	1593,20037,20949,2539
	 dc.w	1147,19555,21377,3039
	 dc.w	720,19057,21785,3557
	 dc.w	312,18543,22172,4091
	 dc.w	-76,18015,22537,4642
	 dc.w	-445,17474,22881,5208
	 dc.w	-794,16921,23202,5789
	 dc.w	-1123,16357,23499,6385
	 dc.w	-1433,15783,23773,6995
	 dc.w	-1722,15201,24022,7617
	 dc.w	-1992,14611,24247,8252
	 dc.w	-2243,14015,24447,8899
	 dc.w	-2474,13413,24622,9557
	 dc.w	-2685,12808,24771,10225
	 dc.w	-2878,12199,24895,10902

	 dc.w	-3052,11589,24993,11589
	 dc.w	-2878,10902,24895,12199
	 dc.w	-2685,10225,24771,12808
	 dc.w	-2474,9557,24622,13413
	 dc.w	-2243,8899,24447,14015
	 dc.w	-1992,8252,24247,14611
	 dc.w	-1722,7617,24022,15201
	 dc.w	-1433,6995,23773,15783
	 dc.w	-1123,6385,23499,16357
	 dc.w	-794,5789,23202,16921
	 dc.w	-445,5208,22881,17474
	 dc.w	-76,4642,22537,18015
	 dc.w	312,4091,22172,18543
	 dc.w	720,3557,21785,19057
	 dc.w	1147,3039,21377,19555
	 dc.w	1593,2539,20949,20037
	 dc.w	2057,2057,20502,20502
	 dc.w	2539,1593,20037,20949
	 dc.w	3039,1147,19555,21377
	 dc.w	3557,720,19057,21785
	 dc.w	4091,312,18543,22172
	 dc.w	4642,-76,18015,22537
	 dc.w	5208,-445,17474,22881
	 dc.w	5789,-794,16921,23202
	 dc.w	6385,-1123,16357,23499
	 dc.w	6995,-1433,15783,23773
	 dc.w	7617,-1722,15201,24022
	 dc.w	8252,-1992,14611,24247
	 dc.w	8899,-2243,14015,24447
	 dc.w	9557,-2474,13413,24622
	 dc.w	10225,-2685,12808,24771
	 dc.w	10902,-2878,12199,24895

	 dc.w	11589,-3052,11589,24993
	 dc.w	12199,-2878,10902,24895
	 dc.w	12808,-2685,10225,24771
	 dc.w	13413,-2474,9557,24622
	 dc.w	14015,-2243,8899,24447
	 dc.w	14611,-1992,8252,24247
	 dc.w	15201,-1722,7617,24022
	 dc.w	15783,-1433,6995,23773
	 dc.w	16357,-1123,6385,23499
	 dc.w	16921,-794,5789,23202
	 dc.w	17474,-445,5208,22881
	 dc.w	18015,-76,4642,22537
	 dc.w	18543,312,4091,22172
	 dc.w	19057,720,3557,21785
	 dc.w	19555,1147,3039,21377
	 dc.w	20037,1593,2539,20949
	 dc.w	20502,2057,2057,20502
	 dc.w	20949,2539,1593,20037
	 dc.w	21377,3039,1147,19555
	 dc.w	21785,3557,720,19057
	 dc.w	22172,4091,312,18543
	 dc.w	22537,4642,-76,18015
	 dc.w	22881,5208,-445,17474
	 dc.w	23202,5789,-794,16921
	 dc.w	23499,6385,-1123,16357
	 dc.w	23773,6995,-1433,15783
	 dc.w	24022,7617,-1722,15201
	 dc.w	24247,8252,-1992,14611
	 dc.w	24447,8899,-2243,14015
	 dc.w	24622,9557,-2474,13413
	 dc.w	24771,10225,-2685,12808
	 dc.w	24895,10902,-2878,12199

	 dc.w	24993,11589,-3052,11589
	 dc.w	24895,12199,-2878,10902
	 dc.w	24771,12808,-2685,10225
	 dc.w	24622,13413,-2474,9557
	 dc.w	24447,14015,-2243,8899
	 dc.w	24247,14611,-1992,8252
	 dc.w	24022,15201,-1722,7617
	 dc.w	23773,15783,-1433,6995
	 dc.w	23499,16357,-1123,6385
	 dc.w	23202,16921,-794,5789
	 dc.w	22881,17474,-445,5208
	 dc.w	22537,18015,-76,4642
	 dc.w	22172,18543,312,4091
	 dc.w	21785,19057,720,3557
	 dc.w	21377,19555,1147,3039
	 dc.w	20949,20037,1593,2539
	 dc.w	20502,20502,2057,2057
	 dc.w	20037,20949,2539,1593
	 dc.w	19555,21377,3039,1147
	 dc.w	19057,21785,3557,720
	 dc.w	18543,22172,4091,312
	 dc.w	18015,22537,4642,-76
	 dc.w	17474,22881,5208,-445
	 dc.w	16921,23202,5789,-794
	 dc.w	16357,23499,6385,-1123
	 dc.w	15783,23773,6995,-1433
	 dc.w	15201,24022,7617,-1722
	 dc.w	14611,24247,8252,-1992
	 dc.w	14015,24447,8899,-2243
	 dc.w	13413,24622,9557,-2474
	 dc.w	12808,24771,10225,-2685
	 dc.w	12199,24895,10902,-2878

FM_tab_192:
	 dc.w	13551,23362,13551,-758
	 dc.w	12967,23225,13985,-471
	 dc.w	12390,23075,14414,-172
	 dc.w	11820,22912,14837,138
	 dc.w	11258,22736,15255,459
	 dc.w	10703,22547,15666,791
	 dc.w	10156,22346,16071,1134
	 dc.w	9616,22133,16470,1488
	 dc.w	9085,21908,16861,1853
	 dc.w	8563,21671,17245,2229
	 dc.w	8049,21422,17621,2616
	 dc.w	7543,21162,17989,3013
	 dc.w	7047,20890,18349,3421
	 dc.w	6560,20608,18700,3839
	 dc.w	6082,20315,19042,4268
	 dc.w	5614,20012,19375,4706
	 dc.w	5155,19698,19698,5155
	 dc.w	4706,19375,20012,5614
	 dc.w	4268,19042,20315,6082
	 dc.w	3839,18700,20608,6560
	 dc.w	3421,18349,20890,7047
	 dc.w	3013,17989,21162,7543
	 dc.w	2616,17621,21422,8049
	 dc.w	2229,17245,21671,8563
	 dc.w	1853,16861,21908,9085
	 dc.w	1488,16470,22133,9616
	 dc.w	1134,16071,22346,10156
	 dc.w	791,15666,22547,10703
	 dc.w	459,15255,22736,11258
	 dc.w	138,14837,22912,11820
	 dc.w	-172,14414,23075,12390
	 dc.w	-471,13985,23225,12967

	 dc.w	-758,13551,23362,13551
	 dc.w	-471,12967,23225,13985
	 dc.w	-172,12390,23075,14414
	 dc.w	138,11820,22912,14837
	 dc.w	459,11258,22736,15255
	 dc.w	791,10703,22547,15666
	 dc.w	1134,10156,22346,16071
	 dc.w	1488,9616,22133,16470
	 dc.w	1853,9085,21908,16861
	 dc.w	2229,8563,21671,17245
	 dc.w	2616,8049,21422,17621
	 dc.w	3013,7543,21162,17989
	 dc.w	3421,7047,20890,18349
	 dc.w	3839,6560,20608,18700
	 dc.w	4268,6082,20315,19042
	 dc.w	4706,5614,20012,19375
	 dc.w	5155,5155,19698,19698
	 dc.w	5614,4706,19375,20012
	 dc.w	6082,4268,19042,20315
	 dc.w	6560,3839,18700,20608
	 dc.w	7047,3421,18349,20890
	 dc.w	7543,3013,17989,21162
	 dc.w	8049,2616,17621,21422
	 dc.w	8563,2229,17245,21671
	 dc.w	9085,1853,16861,21908
	 dc.w	9616,1488,16470,22133
	 dc.w	10156,1134,16071,22346
	 dc.w	10703,791,15666,22547
	 dc.w	11258,459,15255,22736
	 dc.w	11820,138,14837,22912
	 dc.w	12390,-172,14414,23075
	 dc.w	12967,-471,13985,23225

	 dc.w	13551,-758,13551,23362
	 dc.w	13985,-471,12967,23225
	 dc.w	14414,-172,12390,23075
	 dc.w	14837,138,11820,22912
	 dc.w	15255,459,11258,22736
	 dc.w	15666,791,10703,22547
	 dc.w	16071,1134,10156,22346
	 dc.w	16470,1488,9616,22133
	 dc.w	16861,1853,9085,21908
	 dc.w	17245,2229,8563,21671
	 dc.w	17621,2616,8049,21422
	 dc.w	17989,3013,7543,21162
	 dc.w	18349,3421,7047,20890
	 dc.w	18700,3839,6560,20608
	 dc.w	19042,4268,6082,20315
	 dc.w	19375,4706,5614,20012
	 dc.w	19698,5155,5155,19698
	 dc.w	20012,5614,4706,19375
	 dc.w	20315,6082,4268,19042
	 dc.w	20608,6560,3839,18700
	 dc.w	20890,7047,3421,18349
	 dc.w	21162,7543,3013,17989
	 dc.w	21422,8049,2616,17621
	 dc.w	21671,8563,2229,17245
	 dc.w	21908,9085,1853,16861
	 dc.w	22133,9616,1488,16470
	 dc.w	22346,10156,1134,16071
	 dc.w	22547,10703,791,15666
	 dc.w	22736,11258,459,15255
	 dc.w	22912,11820,138,14837
	 dc.w	23075,12390,-172,14414
	 dc.w	23225,12967,-471,13985

	 dc.w	23362,13551,-758,13551
	 dc.w	23225,13985,-471,12967
	 dc.w	23075,14414,-172,12390
	 dc.w	22912,14837,138,11820
	 dc.w	22736,15255,459,11258
	 dc.w	22547,15666,791,10703
	 dc.w	22346,16071,1134,10156
	 dc.w	22133,16470,1488,9616
	 dc.w	21908,16861,1853,9085
	 dc.w	21671,17245,2229,8563
	 dc.w	21422,17621,2616,8049
	 dc.w	21162,17989,3013,7543
	 dc.w	20890,18349,3421,7047
	 dc.w	20608,18700,3839,6560
	 dc.w	20315,19042,4268,6082
	 dc.w	20012,19375,4706,5614
	 dc.w	19698,19698,5155,5155
	 dc.w	19375,20012,5614,4706
	 dc.w	19042,20315,6082,4268
	 dc.w	18700,20608,6560,3839
	 dc.w	18349,20890,7047,3421
	 dc.w	17989,21162,7543,3013
	 dc.w	17621,21422,8049,2616
	 dc.w	17245,21671,8563,2229
	 dc.w	16861,21908,9085,1853
	 dc.w	16470,22133,9616,1488
	 dc.w	16071,22346,10156,1134
	 dc.w	15666,22547,10703,791
	 dc.w	15255,22736,11258,459
	 dc.w	14837,22912,11820,138
	 dc.w	14414,23075,12390,-172
	 dc.w	13985,23225,12967,-471

	else

FM_tabs:
	dc.l	FM_tab_100
	dc.l	FM_tab_125
	dc.l	FM_tab_150
	dc.l	FM_tab_175

FM_tab_100:
	 dc.w	0,32596,0,0
	 dc.w	-810,32745,884,-222
	 dc.w	-1555,32767,1851,-468
	 dc.w	-2230,32662,2899,-734
	 dc.w	-2834,32427,4022,-1020
	 dc.w	-3364,32065,5218,-1323
	 dc.w	-3821,31577,6481,-1640
	 dc.w	-4204,30965,7803,-1968
	 dc.w	-4513,30234,9178,-2303
	 dc.w	-4751,29390,10597,-2640
	 dc.w	-4919,28438,12052,-2976
	 dc.w	-5020,27387,13533,-3304
	 dc.w	-5057,26245,15030,-3621
	 dc.w	-5035,25020,16531,-3920
	 dc.w	-4958,23723,18027,-4196
	 dc.w	-4830,22364,19505,-4444
	 dc.w	-4657,20955,20955,-4657
	 dc.w	-4444,19505,22364,-4830
	 dc.w	-4196,18027,23723,-4958
	 dc.w	-3920,16531,25020,-5035
	 dc.w	-3621,15030,26245,-5057
	 dc.w	-3304,13533,27387,-5020
	 dc.w	-2976,12052,28438,-4919
	 dc.w	-2640,10597,29390,-4751
	 dc.w	-2303,9178,30234,-4513
	 dc.w	-1968,7803,30965,-4204
	 dc.w	-1640,6481,31577,-3821
	 dc.w	-1323,5218,32065,-3364
	 dc.w	-1020,4022,32427,-2834
	 dc.w	-734,2899,32662,-2230
	 dc.w	-468,1851,32767,-1555
	 dc.w	-222,884,32745,-810

	 dc.w	0,0,32596,0
	 dc.w	-222,-810,32745,884
	 dc.w	-468,-1555,32767,1851
	 dc.w	-734,-2230,32662,2899
	 dc.w	-1020,-2834,32427,4022
	 dc.w	-1323,-3364,32065,5218
	 dc.w	-1640,-3821,31577,6481
	 dc.w	-1968,-4204,30965,7803
	 dc.w	-2303,-4513,30234,9178
	 dc.w	-2640,-4751,29390,10597
	 dc.w	-2976,-4919,28438,12052
	 dc.w	-3304,-5020,27387,13533
	 dc.w	-3621,-5057,26245,15030
	 dc.w	-3920,-5035,25020,16531
	 dc.w	-4196,-4958,23723,18027
	 dc.w	-4444,-4830,22364,19505
	 dc.w	-4657,-4657,20955,20955
	 dc.w	-4830,-4444,19505,22364
	 dc.w	-4958,-4196,18027,23723
	 dc.w	-5035,-3920,16531,25020
	 dc.w	-5057,-3621,15030,26245
	 dc.w	-5020,-3304,13533,27387
	 dc.w	-4919,-2976,12052,28438
	 dc.w	-4751,-2640,10597,29390
	 dc.w	-4513,-2303,9178,30234
	 dc.w	-4204,-1968,7803,30965
	 dc.w	-3821,-1640,6481,31577
	 dc.w	-3364,-1323,5218,32065
	 dc.w	-2834,-1020,4022,32427
	 dc.w	-2230,-734,2899,32662
	 dc.w	-1555,-468,1851,32767
	 dc.w	-810,-222,884,32745

	 dc.w	0,0,0,32596
	 dc.w	884,-222,-810,32745
	 dc.w	1851,-468,-1555,32767
	 dc.w	2899,-734,-2230,32662
	 dc.w	4022,-1020,-2834,32427
	 dc.w	5218,-1323,-3364,32065
	 dc.w	6481,-1640,-3821,31577
	 dc.w	7803,-1968,-4204,30965
	 dc.w	9178,-2303,-4513,30234
	 dc.w	10597,-2640,-4751,29390
	 dc.w	12052,-2976,-4919,28438
	 dc.w	13533,-3304,-5020,27387
	 dc.w	15030,-3621,-5057,26245
	 dc.w	16531,-3920,-5035,25020
	 dc.w	18027,-4196,-4958,23723
	 dc.w	19505,-4444,-4830,22364
	 dc.w	20955,-4657,-4657,20955
	 dc.w	22364,-4830,-4444,19505
	 dc.w	23723,-4958,-4196,18027
	 dc.w	25020,-5035,-3920,16531
	 dc.w	26245,-5057,-3621,15030
	 dc.w	27387,-5020,-3304,13533
	 dc.w	28438,-4919,-2976,12052
	 dc.w	29390,-4751,-2640,10597
	 dc.w	30234,-4513,-2303,9178
	 dc.w	30965,-4204,-1968,7803
	 dc.w	31577,-3821,-1640,6481
	 dc.w	32065,-3364,-1323,5218
	 dc.w	32427,-2834,-1020,4022
	 dc.w	32662,-2230,-734,2899
	 dc.w	32767,-1555,-468,1851
	 dc.w	32745,-810,-222,884

	 dc.w	32596,0,0,0
	 dc.w	32745,884,-222,-810
	 dc.w	32767,1851,-468,-1555
	 dc.w	32662,2899,-734,-2230
	 dc.w	32427,4022,-1020,-2834
	 dc.w	32065,5218,-1323,-3364
	 dc.w	31577,6481,-1640,-3821
	 dc.w	30965,7803,-1968,-4204
	 dc.w	30234,9178,-2303,-4513
	 dc.w	29390,10597,-2640,-4751
	 dc.w	28438,12052,-2976,-4919
	 dc.w	27387,13533,-3304,-5020
	 dc.w	26245,15030,-3621,-5057
	 dc.w	25020,16531,-3920,-5035
	 dc.w	23723,18027,-4196,-4958
	 dc.w	22364,19505,-4444,-4830
	 dc.w	20955,20955,-4657,-4657
	 dc.w	19505,22364,-4830,-4444
	 dc.w	18027,23723,-4958,-4196
	 dc.w	16531,25020,-5035,-3920
	 dc.w	15030,26245,-5057,-3621
	 dc.w	13533,27387,-5020,-3304
	 dc.w	12052,28438,-4919,-2976
	 dc.w	10597,29390,-4751,-2640
	 dc.w	9178,30234,-4513,-2303
	 dc.w	7803,30965,-4204,-1968
	 dc.w	6481,31577,-3821,-1640
	 dc.w	5218,32065,-3364,-1323
	 dc.w	4022,32427,-2834,-1020
	 dc.w	2899,32662,-2230,-734
	 dc.w	1851,32767,-1555,-468
	 dc.w	884,32745,-810,-222

;/* normalization by 1.563230e+00 */
FM_sinc_norm  EQU  20961

FM_tab_125:
	 dc.w	5901,28442,5901,-3194
	 dc.w	5073,28556,6816,-3396
	 dc.w	4265,28605,7764,-3586
	 dc.w	3481,28587,8743,-3762
	 dc.w	2723,28499,9747,-3921
	 dc.w	1993,28342,10775,-4061
	 dc.w	1295,28112,11820,-4178
	 dc.w	629,27811,12879,-4270
	 dc.w	0,27437,13945,-4334
	 dc.w	-592,26993,15014,-4367
	 dc.w	-1143,26478,16080,-4366
	 dc.w	-1653,25895,17137,-4330
	 dc.w	-2121,25247,18178,-4256
	 dc.w	-2544,24536,19198,-4142
	 dc.w	-2922,23767,20190,-3986
	 dc.w	-3255,22942,21149,-3787
	 dc.w	-3543,22068,22068,-3543
	 dc.w	-3787,21149,22942,-3255
	 dc.w	-3986,20190,23767,-2922
	 dc.w	-4142,19198,24536,-2544
	 dc.w	-4256,18178,25247,-2121
	 dc.w	-4330,17137,25895,-1653
	 dc.w	-4366,16080,26478,-1143
	 dc.w	-4367,15014,26993,-592
	 dc.w	-4334,13945,27437,0
	 dc.w	-4270,12879,27811,629
	 dc.w	-4178,11820,28112,1295
	 dc.w	-4061,10775,28342,1993
	 dc.w	-3921,9747,28499,2723
	 dc.w	-3762,8743,28587,3481
	 dc.w	-3586,7764,28605,4265
	 dc.w	-3396,6816,28556,5073

	 dc.w	-3194,5901,28442,5901
	 dc.w	-3396,5073,28556,6816
	 dc.w	-3586,4265,28605,7764
	 dc.w	-3762,3481,28587,8743
	 dc.w	-3921,2723,28499,9747
	 dc.w	-4061,1993,28342,10775
	 dc.w	-4178,1295,28112,11820
	 dc.w	-4270,629,27811,12879
	 dc.w	-4334,0,27437,13945
	 dc.w	-4367,-592,26993,15014
	 dc.w	-4366,-1143,26478,16080
	 dc.w	-4330,-1653,25895,17137
	 dc.w	-4256,-2121,25247,18178
	 dc.w	-4142,-2544,24536,19198
	 dc.w	-3986,-2922,23767,20190
	 dc.w	-3787,-3255,22942,21149
	 dc.w	-3543,-3543,22068,22068
	 dc.w	-3255,-3787,21149,22942
	 dc.w	-2922,-3986,20190,23767
	 dc.w	-2544,-4142,19198,24536
	 dc.w	-2121,-4256,18178,25247
	 dc.w	-1653,-4330,17137,25895
	 dc.w	-1143,-4366,16080,26478
	 dc.w	-592,-4367,15014,26993
	 dc.w	0,-4334,13945,27437
	 dc.w	629,-4270,12879,27811
	 dc.w	1295,-4178,11820,28112
	 dc.w	1993,-4061,10775,28342
	 dc.w	2723,-3921,9747,28499
	 dc.w	3481,-3762,8743,28587
	 dc.w	4265,-3586,7764,28605
	 dc.w	5073,-3396,6816,28556

	 dc.w	5901,-3194,5901,28442
	 dc.w	6816,-3396,5073,28556
	 dc.w	7764,-3586,4265,28605
	 dc.w	8743,-3762,3481,28587
	 dc.w	9747,-3921,2723,28499
	 dc.w	10775,-4061,1993,28342
	 dc.w	11820,-4178,1295,28112
	 dc.w	12879,-4270,629,27811
	 dc.w	13945,-4334,0,27437
	 dc.w	15014,-4367,-592,26993
	 dc.w	16080,-4366,-1143,26478
	 dc.w	17137,-4330,-1653,25895
	 dc.w	18178,-4256,-2121,25247
	 dc.w	19198,-4142,-2544,24536
	 dc.w	20190,-3986,-2922,23767
	 dc.w	21149,-3787,-3255,22942
	 dc.w	22068,-3543,-3543,22068
	 dc.w	22942,-3255,-3787,21149
	 dc.w	23767,-2922,-3986,20190
	 dc.w	24536,-2544,-4142,19198
	 dc.w	25247,-2121,-4256,18178
	 dc.w	25895,-1653,-4330,17137
	 dc.w	26478,-1143,-4366,16080
	 dc.w	26993,-592,-4367,15014
	 dc.w	27437,0,-4334,13945
	 dc.w	27811,629,-4270,12879
	 dc.w	28112,1295,-4178,11820
	 dc.w	28342,1993,-4061,10775
	 dc.w	28499,2723,-3921,9747
	 dc.w	28587,3481,-3762,8743
	 dc.w	28605,4265,-3586,7764
	 dc.w	28556,5073,-3396,6816

	 dc.w	28442,5901,-3194,5901
	 dc.w	28556,6816,-3396,5073
	 dc.w	28605,7764,-3586,4265
	 dc.w	28587,8743,-3762,3481
	 dc.w	28499,9747,-3921,2723
	 dc.w	28342,10775,-4061,1993
	 dc.w	28112,11820,-4178,1295
	 dc.w	27811,12879,-4270,629
	 dc.w	27437,13945,-4334,0
	 dc.w	26993,15014,-4367,-592
	 dc.w	26478,16080,-4366,-1143
	 dc.w	25895,17137,-4330,-1653
	 dc.w	25247,18178,-4256,-2121
	 dc.w	24536,19198,-4142,-2544
	 dc.w	23767,20190,-3986,-2922
	 dc.w	22942,21149,-3787,-3255
	 dc.w	22068,22068,-3543,-3543
	 dc.w	21149,22942,-3255,-3787
	 dc.w	20190,23767,-2922,-3986
	 dc.w	19198,24536,-2544,-4142
	 dc.w	18178,25247,-2121,-4256
	 dc.w	17137,25895,-1653,-4330
	 dc.w	16080,26478,-1143,-4366
	 dc.w	15014,26993,-592,-4367
	 dc.w	13945,27437,0,-4334
	 dc.w	12879,27811,629,-4270
	 dc.w	11820,28112,1295,-4178
	 dc.w	10775,28342,1993,-4061
	 dc.w	9747,28499,2723,-3921
	 dc.w	8743,28587,3481,-3762
	 dc.w	7764,28605,4265,-3586
	 dc.w	6816,28556,5073,-3396

FM_tab_150:
	 dc.w	10225,26857,10225,-3916
	 dc.w	9461,26813,10978,-3861
	 dc.w	8707,26731,11736,-3784
	 dc.w	7966,26611,12497,-3684
	 dc.w	7239,26452,13259,-3560
	 dc.w	6526,26255,14020,-3411
	 dc.w	5829,26020,14778,-3237
	 dc.w	5149,25746,15530,-3036
	 dc.w	4488,25435,16275,-2809
	 dc.w	3847,25087,17010,-2555
	 dc.w	3227,24703,17733,-2273
	 dc.w	2628,24283,18442,-1964
	 dc.w	2053,23829,19134,-1626
	 dc.w	1502,23341,19808,-1261
	 dc.w	975,22822,20460,-868
	 dc.w	475,22273,21090,-448
	 dc.w	0,21695,21695,0
	 dc.w	-448,21090,22273,475
	 dc.w	-868,20460,22822,975
	 dc.w	-1261,19808,23341,1502
	 dc.w	-1626,19134,23829,2053
	 dc.w	-1964,18442,24283,2628
	 dc.w	-2273,17733,24703,3227
	 dc.w	-2555,17010,25087,3847
	 dc.w	-2809,16275,25435,4488
	 dc.w	-3036,15530,25746,5149
	 dc.w	-3237,14778,26020,5829
	 dc.w	-3411,14020,26255,6526
	 dc.w	-3560,13259,26452,7239
	 dc.w	-3684,12497,26611,7966
	 dc.w	-3784,11736,26731,8707
	 dc.w	-3861,10978,26813,9461

	 dc.w	-3916,10225,26857,10225
	 dc.w	-3861,9461,26813,10978
	 dc.w	-3784,8707,26731,11736
	 dc.w	-3684,7966,26611,12497
	 dc.w	-3560,7239,26452,13259
	 dc.w	-3411,6526,26255,14020
	 dc.w	-3237,5829,26020,14778
	 dc.w	-3036,5149,25746,15530
	 dc.w	-2809,4488,25435,16275
	 dc.w	-2555,3847,25087,17010
	 dc.w	-2273,3227,24703,17733
	 dc.w	-1964,2628,24283,18442
	 dc.w	-1626,2053,23829,19134
	 dc.w	-1261,1502,23341,19808
	 dc.w	-868,975,22822,20460
	 dc.w	-448,475,22273,21090
	 dc.w	0,0,21695,21695
	 dc.w	475,-448,21090,22273
	 dc.w	975,-868,20460,22822
	 dc.w	1502,-1261,19808,23341
	 dc.w	2053,-1626,19134,23829
	 dc.w	2628,-1964,18442,24283
	 dc.w	3227,-2273,17733,24703
	 dc.w	3847,-2555,17010,25087
	 dc.w	4488,-2809,16275,25435
	 dc.w	5149,-3036,15530,25746
	 dc.w	5829,-3237,14778,26020
	 dc.w	6526,-3411,14020,26255
	 dc.w	7239,-3560,13259,26452
	 dc.w	7966,-3684,12497,26611
	 dc.w	8707,-3784,11736,26731
	 dc.w	9461,-3861,10978,26813

	 dc.w	10225,-3916,10225,26857
	 dc.w	10978,-3861,9461,26813
	 dc.w	11736,-3784,8707,26731
	 dc.w	12497,-3684,7966,26611
	 dc.w	13259,-3560,7239,26452
	 dc.w	14020,-3411,6526,26255
	 dc.w	14778,-3237,5829,26020
	 dc.w	15530,-3036,5149,25746
	 dc.w	16275,-2809,4488,25435
	 dc.w	17010,-2555,3847,25087
	 dc.w	17733,-2273,3227,24703
	 dc.w	18442,-1964,2628,24283
	 dc.w	19134,-1626,2053,23829
	 dc.w	19808,-1261,1502,23341
	 dc.w	20460,-868,975,22822
	 dc.w	21090,-448,475,22273
	 dc.w	21695,0,0,21695
	 dc.w	22273,475,-448,21090
	 dc.w	22822,975,-868,20460
	 dc.w	23341,1502,-1261,19808
	 dc.w	23829,2053,-1626,19134
	 dc.w	24283,2628,-1964,18442
	 dc.w	24703,3227,-2273,17733
	 dc.w	25087,3847,-2555,17010
	 dc.w	25435,4488,-2809,16275
	 dc.w	25746,5149,-3036,15530
	 dc.w	26020,5829,-3237,14778
	 dc.w	26255,6526,-3411,14020
	 dc.w	26452,7239,-3560,13259
	 dc.w	26611,7966,-3684,12497
	 dc.w	26731,8707,-3784,11736
	 dc.w	26813,9461,-3861,10978

	 dc.w	26857,10225,-3916,10225
	 dc.w	26813,10978,-3861,9461
	 dc.w	26731,11736,-3784,8707
	 dc.w	26611,12497,-3684,7966
	 dc.w	26452,13259,-3560,7239
	 dc.w	26255,14020,-3411,6526
	 dc.w	26020,14778,-3237,5829
	 dc.w	25746,15530,-3036,5149
	 dc.w	25435,16275,-2809,4488
	 dc.w	25087,17010,-2555,3847
	 dc.w	24703,17733,-2273,3227
	 dc.w	24283,18442,-1964,2628
	 dc.w	23829,19134,-1626,2053
	 dc.w	23341,19808,-1261,1502
	 dc.w	22822,20460,-868,975
	 dc.w	22273,21090,-448,475
	 dc.w	21695,21695,0,0
	 dc.w	21090,22273,475,-448
	 dc.w	20460,22822,975,-868
	 dc.w	19808,23341,1502,-1261
	 dc.w	19134,23829,2053,-1626
	 dc.w	18442,24283,2628,-1964
	 dc.w	17733,24703,3227,-2273
	 dc.w	17010,25087,3847,-2555
	 dc.w	16275,25435,4488,-2809
	 dc.w	15530,25746,5149,-3036
	 dc.w	14778,26020,5829,-3237
	 dc.w	14020,26255,6526,-3411
	 dc.w	13259,26452,7239,-3560
	 dc.w	12497,26611,7966,-3684
	 dc.w	11736,26731,8707,-3784
	 dc.w	10978,26813,9461,-3861

FM_tab_175:
	 dc.w	12373,24202,12373,-2275
	 dc.w	11729,24083,12908,-2046
	 dc.w	11092,23944,13439,-1802
	 dc.w	10464,23785,13965,-1541
	 dc.w	9845,23607,14486,-1265
	 dc.w	9236,23409,15001,-973
	 dc.w	8636,23193,15509,-664
	 dc.w	8047,22957,16009,-340
	 dc.w	7468,22704,16501,0
	 dc.w	6901,22432,16984,356
	 dc.w	6345,22142,17458,728
	 dc.w	5802,21835,17921,1115
	 dc.w	5271,21511,18373,1518
	 dc.w	4753,21171,18813,1936
	 dc.w	4248,20814,19241,2370
	 dc.w	3757,20443,19655,2818
	 dc.w	3280,20056,20056,3280
	 dc.w	2818,19655,20443,3757
	 dc.w	2370,19241,20814,4248
	 dc.w	1936,18813,21171,4753
	 dc.w	1518,18373,21511,5271
	 dc.w	1115,17921,21835,5802
	 dc.w	728,17458,22142,6345
	 dc.w	356,16984,22432,6901
	 dc.w	0,16501,22704,7468
	 dc.w	-340,16009,22957,8047
	 dc.w	-664,15509,23193,8636
	 dc.w	-973,15001,23409,9236
	 dc.w	-1265,14486,23607,9845
	 dc.w	-1541,13965,23785,10464
	 dc.w	-1802,13439,23944,11092
	 dc.w	-2046,12908,24083,11729

	 dc.w	-2275,12373,24202,12373
	 dc.w	-2046,11729,24083,12908
	 dc.w	-1802,11092,23944,13439
	 dc.w	-1541,10464,23785,13965
	 dc.w	-1265,9845,23607,14486
	 dc.w	-973,9236,23409,15001
	 dc.w	-664,8636,23193,15509
	 dc.w	-340,8047,22957,16009
	 dc.w	0,7468,22704,16501
	 dc.w	356,6901,22432,16984
	 dc.w	728,6345,22142,17458
	 dc.w	1115,5802,21835,17921
	 dc.w	1518,5271,21511,18373
	 dc.w	1936,4753,21171,18813
	 dc.w	2370,4248,20814,19241
	 dc.w	2818,3757,20443,19655
	 dc.w	3280,3280,20056,20056
	 dc.w	3757,2818,19655,20443
	 dc.w	4248,2370,19241,20814
	 dc.w	4753,1936,18813,21171
	 dc.w	5271,1518,18373,21511
	 dc.w	5802,1115,17921,21835
	 dc.w	6345,728,17458,22142
	 dc.w	6901,356,16984,22432
	 dc.w	7468,0,16501,22704
	 dc.w	8047,-340,16009,22957
	 dc.w	8636,-664,15509,23193
	 dc.w	9236,-973,15001,23409
	 dc.w	9845,-1265,14486,23607
	 dc.w	10464,-1541,13965,23785
	 dc.w	11092,-1802,13439,23944
	 dc.w	11729,-2046,12908,24083

	 dc.w	12373,-2275,12373,24202
	 dc.w	12908,-2046,11729,24083
	 dc.w	13439,-1802,11092,23944
	 dc.w	13965,-1541,10464,23785
	 dc.w	14486,-1265,9845,23607
	 dc.w	15001,-973,9236,23409
	 dc.w	15509,-664,8636,23193
	 dc.w	16009,-340,8047,22957
	 dc.w	16501,0,7468,22704
	 dc.w	16984,356,6901,22432
	 dc.w	17458,728,6345,22142
	 dc.w	17921,1115,5802,21835
	 dc.w	18373,1518,5271,21511
	 dc.w	18813,1936,4753,21171
	 dc.w	19241,2370,4248,20814
	 dc.w	19655,2818,3757,20443
	 dc.w	20056,3280,3280,20056
	 dc.w	20443,3757,2818,19655
	 dc.w	20814,4248,2370,19241
	 dc.w	21171,4753,1936,18813
	 dc.w	21511,5271,1518,18373
	 dc.w	21835,5802,1115,17921
	 dc.w	22142,6345,728,17458
	 dc.w	22432,6901,356,16984
	 dc.w	22704,7468,0,16501
	 dc.w	22957,8047,-340,16009
	 dc.w	23193,8636,-664,15509
	 dc.w	23409,9236,-973,15001
	 dc.w	23607,9845,-1265,14486
	 dc.w	23785,10464,-1541,13965
	 dc.w	23944,11092,-1802,13439
	 dc.w	24083,11729,-2046,12908

	 dc.w	24202,12373,-2275,12373
	 dc.w	24083,12908,-2046,11729
	 dc.w	23944,13439,-1802,11092
	 dc.w	23785,13965,-1541,10464
	 dc.w	23607,14486,-1265,9845
	 dc.w	23409,15001,-973,9236
	 dc.w	23193,15509,-664,8636
	 dc.w	22957,16009,-340,8047
	 dc.w	22704,16501,0,7468
	 dc.w	22432,16984,356,6901
	 dc.w	22142,17458,728,6345
	 dc.w	21835,17921,1115,5802
	 dc.w	21511,18373,1518,5271
	 dc.w	21171,18813,1936,4753
	 dc.w	20814,19241,2370,4248
	 dc.w	20443,19655,2818,3757
	 dc.w	20056,20056,3280,3280
	 dc.w	19655,20443,3757,2818
	 dc.w	19241,20814,4248,2370
	 dc.w	18813,21171,4753,1936
	 dc.w	18373,21511,5271,1518
	 dc.w	17921,21835,5802,1115
	 dc.w	17458,22142,6345,728
	 dc.w	16984,22432,6901,356
	 dc.w	16501,22704,7468,0
	 dc.w	16009,22957,8047,-340
	 dc.w	15509,23193,8636,-664
	 dc.w	15001,23409,9236,-973
	 dc.w	14486,23607,9845,-1265
	 dc.w	13965,23785,10464,-1541
	 dc.w	13439,23944,11092,-1802
	 dc.w	12908,24083,11729,-2046

	endc

	else		; fmix_accuracy

	;TODO: downsampling ratios are missing here...
FM_tabs:
	dc.l	FM_tab_100
	dc.l	FM_tab_100
	dc.l	FM_tab_100
	dc.l	FM_tab_100

FM_tab_100:
	 dc.w	0,32596,0,0
	 dc.w	-1555,32767,1851,-468
	 dc.w	-2834,32427,4022,-1020
	 dc.w	-3821,31577,6481,-1640
	 dc.w	-4513,30234,9178,-2303
	 dc.w	-4919,28438,12052,-2976
	 dc.w	-5057,26245,15030,-3621
	 dc.w	-4958,23723,18027,-4196
	 dc.w	-4657,20955,20955,-4657
	 dc.w	-4196,18027,23723,-4958
	 dc.w	-3621,15030,26245,-5057
	 dc.w	-2976,12052,28438,-4919
	 dc.w	-2303,9178,30234,-4513
	 dc.w	-1640,6481,31577,-3821
	 dc.w	-1020,4022,32427,-2834
	 dc.w	-468,1851,32767,-1555

	 dc.w	0,0,32596,0
	 dc.w	-468,-1555,32767,1851
	 dc.w	-1020,-2834,32427,4022
	 dc.w	-1640,-3821,31577,6481
	 dc.w	-2303,-4513,30234,9178
	 dc.w	-2976,-4919,28438,12052
	 dc.w	-3621,-5057,26245,15030
	 dc.w	-4196,-4958,23723,18027
	 dc.w	-4657,-4657,20955,20955
	 dc.w	-4958,-4196,18027,23723
	 dc.w	-5057,-3621,15030,26245
	 dc.w	-4919,-2976,12052,28438
	 dc.w	-4513,-2303,9178,30234
	 dc.w	-3821,-1640,6481,31577
	 dc.w	-2834,-1020,4022,32427
	 dc.w	-1555,-468,1851,32767

	 dc.w	0,0,0,32596
	 dc.w	1851,-468,-1555,32767
	 dc.w	4022,-1020,-2834,32427
	 dc.w	6481,-1640,-3821,31577
	 dc.w	9178,-2303,-4513,30234
	 dc.w	12052,-2976,-4919,28438
	 dc.w	15030,-3621,-5057,26245
	 dc.w	18027,-4196,-4958,23723
	 dc.w	20955,-4657,-4657,20955
	 dc.w	23723,-4958,-4196,18027
	 dc.w	26245,-5057,-3621,15030
	 dc.w	28438,-4919,-2976,12052
	 dc.w	30234,-4513,-2303,9178
	 dc.w	31577,-3821,-1640,6481
	 dc.w	32427,-2834,-1020,4022
	 dc.w	32767,-1555,-468,1851

	 dc.w	32596,0,0,0
	 dc.w	32767,1851,-468,-1555
	 dc.w	32427,4022,-1020,-2834
	 dc.w	31577,6481,-1640,-3821
	 dc.w	30234,9178,-2303,-4513
	 dc.w	28438,12052,-2976,-4919
	 dc.w	26245,15030,-3621,-5057
	 dc.w	23723,18027,-4196,-4958
	 dc.w	20955,20955,-4657,-4657
	 dc.w	18027,23723,-4958,-4196
	 dc.w	15030,26245,-5057,-3621
	 dc.w	12052,28438,-4919,-2976
	 dc.w	9178,30234,-4513,-2303
	 dc.w	6481,31577,-3821,-1640
	 dc.w	4022,32427,-2834,-1020
	 dc.w	1851,32767,-1555,-468

;/* normalization by 1.563230e+00 */
FM_sinc_norm  EQU  20960

	endc		;fmix_accuracy

;	endc		;INC_AMPOUT_FILTERTABLES4

