*----------------------------------------------------------------------------*
*--------------- Hilfsmacros zum Erstellen von Userprogrammen ---------------*
*---------------  by Eagleeye of DEFECT 1994 04.04.1994      ---------------*
*----------------------------------------------------------------------------*

	*------------ DebuggerStatus festlegen -----------*
		if	Executable
Debugger	EQU	0
		else
Debugger	EQU	DebuggerTest
		endc

	*----------- Macro fr JumpTabelle -----------*
UPT		MACRO
		dc.w	\1-AktionTab
		ENDM

	*----------- Macro fr IDCMPTabelle ----------*
IDCT		MACRO
		if	\1
		dc.w	\2-IDCMPTab
		else
		dc.w	Return-IDCMPTab
		endc
		ENDM

BsrIf		MACRO
		if	\2
		bsr.w	\1
		endc
		ENDM

BeqIf		MACRO
		if	\2
		beq.w	\1
		endc
		ENDM

BneIf		MACRO
		if	\2
		bne.w	\1
		endc
		ENDM

BsrIfeq		MACRO
		ifeq	\2
		bsr.w	\1
		endc
		ENDM

BeqIfeq		MACRO
		ifeq	\2
		beq.w	\1
		endc
		ENDM

BneIfeq		MACRO
		ifeq	\2
		bne.w	\1
		endc
		ENDM

PushLibs	MACRO
		movem.l	d0/d1/a0/a1/a6,-(a7)
		ENDM

PopLibs		MACRO
		movem.l	(a7)+,d0/d1/a0/a1/a6
		ENDM


*--------------------- SpecialFlags fr IDCMP-Auswertungen ------------------*
EID_SizeVerify		= IDCMPFlags&$00000001
EID_NewSize		= IDCMPFlags&$00000002
EID_RefreshWindow	= IDCMPFlags&$00000004
EID_MouseButtons	= IDCMPFlags&$00000008
EID_MouseMove		= IDCMPFlags&$00000010
EID_GadgetDown		= IDCMPFlags&$00000020
EID_GadgetUp		= IDCMPFlags&$00000040
EID_ReqSet		= IDCMPFlags&$00000080
EID_MenuPic		= IDCMPFlags&$00000100
EID_CloseWindow		= IDCMPFlags&$00000200
EID_RawKey		= IDCMPFlags&$00000400
EID_ReqVerify		= IDCMPFlags&$00000800
EID_ReqClear		= IDCMPFlags&$00001000
EID_MenuVerify		= IDCMPFlags&$00002000
EID_NewPrefs		= IDCMPFlags&$00004000
EID_DiskInserted	= IDCMPFlags&$00008000
EID_DiskRemoved		= IDCMPFlags&$00010000
EID_WBenchMessage	= IDCMPFlags&$00020000
EID_ActivateWindow	= IDCMPFlags&$00040000
EID_InActivateWindow	= IDCMPFlags&$00080000
EID_Deltamove		= IDCMPFlags&$00100000
EID_Vanillakey		= IDCMPFlags&$00200000
EID_IntuiTicks		= IDCMPFlags&$00400000
EID_IDCMPUpdate		= IDCMPFlags&$00800000
EID_MenuHelp		= IDCMPFlags&$01000000
EID_ChangeWindow	= IDCMPFlags&$02000000
EID_GadgetHelp		= IDCMPFlags&$04000000
EID_NoMessageTyp1	= IDCMPFlags&$08000000
EID_NoMessageTyp2	= IDCMPFlags&$10000000
EID_NoMessageTyp3	= IDCMPFlags&$20000000
EID_NoMessageTyp4	= IDCMPFlags&$40000000
EID_NoMessageTyp5	= IDCMPFlags&$40000000

*--------------------------- Windowflags einzeln --------------------------*
EWF_WindowSize		= WindowFlags&$00000001
EWF_WindowDrag		= WindowFlags&$00000002
EWF_WindowDepth		= WindowFlags&$00000004
EWF_WindowClose		= WindowFlags&$00000008
EWF_SizeBright		= WindowFlags&$00000010
EWF_SizeBottom		= WindowFlags&$00000020
EWF_SimpleRefresh	= WindowFlags&$00000040
EWF_Super_Bitmap	= WindowFlags&$00000080
EWF_Other_Refresh	= WindowFlags&$000000c0
EWF_BackDrop		= WindowFlags&$00000100
EWF_ReportMouse		= WindowFlags&$00000200
EWF_GimmeZeroZero	= WindowFlags&$00000400
EWF_Borderless		= WindowFlags&$00000800
EWF_Activate		= WindowFlags&$00001000
EWF_WindowActive	= WindowFlags&$00002000
EWF_InRequest		= WindowFlags&$00004000
EWF_MenuState		= WindowFlags&$00008000
EWF_RMBTrap		= WindowFlags&$00010000
EWF_NoCareRefresh	= WindowFlags&$00020000
EWF_NW_Extended		= WindowFlags&$00040000
EWF_InActivateWindow	= WindowFlags&$00080000
EWF_NewLookMenus	= WindowFlags&$00200000

UserStartPrg	Macro
EUS_Structure:	bra.w	UserStart			;EUS_Jump
		dc.b	`EP-USERPRG`			;EUS_Identifier
		dc.l	0				;EUS_Next
		ifne	debugger
		dc.w	-2				;EUS_Usernr
		else
		dc.w	0				;EUS_Usernr
		endc

		dc.l	0				;EUS_EPBase
		dc.l	0				;EUS_FreeTable
		dc.l	0				;EUS_TaskAdr
		dc.l	0				;EUS_UnUsed1
		dc.l	0				;EUS_UnUsed2
		dc.l	0				;EUS_UnUsed3
		dc.l	0				;EUS_UnUsed4
		dc.w	Ticks				;EUS_Ticks
		dc.w	0				;EUS_TickCounter
		dc.l	TickFlags			;EUS_TickFlags
		dc.l	MsgFlags			;EUS_MsgFlags
		dc.l	MyProzessName			;EUS_PName
		dc.l	MyCreatorname			;EUS_Creator
		dc.l	MySpecialInfo			;EUS_AboutUPRG
		dc.w	37				;EUS_Kickstart
		dc.l	8				;EUS_EPVersion
		dc.w	1				;EUS_Version
		dc.w	1				;EUS_Revision
		dc.l	MyMenuName			;EUS_Username
		dc.w	WindowLeft			;EUS_WinX
		dc.w	WindowTop			;EUS_WinY
		dc.w	EUSB_Openwin			;EUS_Flags
		dc.w	WindowInnerWidth		;EUS_Special
		dc.w	WindowInnerHeight		;EUS_Special+2
		dc.l	0				;EUS_Special2
		dc.l	0				;EUS_Special3
		dc.b	04,04,19,94			;EUS_Creatordate
		dc.b	-5				;EUS_Priority
		dc.b	0				;EUS_Reserved1
		dc.w	0				;EUS_Reserved2
		dc.l	0				;EUS_Reserved3
		dc.l	0				;EUS_Reserved4
		dc.l	0				;EUS_Reserved5
		dc.l	0				;EUS_Reserved6

UserStart:	if	executable
		move.w	EUS_Structure+EUS_UserNr(pc),d0	;d0=0, nicht von
		beq.w	NoSignal			;Eagleplayer gestartet
		move.l	EUS_Structure+EUS_EPBase(pc),a0
		tst.l	DTG_GadToolsBase(a0)
		beq.w	NoKickStart20
		else
		bsrifeq	DebuggerHelp,Executable
		endc
		lea	Puffer,a5
		bsr	ClrPuffer


	*-------------- Kickstart testen --------------*
		move.l	4.w,a6
		move.w	20(a6),KickStart(a5)
		clr.w	Kick2On(a5)
		clr.w	Kick3On(a5)
		cmp.w	#37,KickStart(a5)
		blo.w	NoKickstart20
		move.w	#1,Kick2On(a5)
		cmp.w	#39,Kickstart(a5)
		blo.s	.NoKick3
		move.w	#1,Kick3On(a5)

	*------------ Task suchen & finden ------------*
.NoKick3:	sub.l	a1,a1
		move.l	4.w,a6
		jsr	_LVOFindTask(a6)
		move.l	d0,TaskAdr(a5)
		beq.w	NoSignal

	*- Signal fr Interruptansteuerung des Eagleplayers -*
	*------------------ allokieren ----------------------*
	if	SignalUsed
		moveq	#0,d6
		moveq	#-1,d0
		jsr	_LVOAllocSignal(a6)	;Signal allokieren
		tst.l	d0
		blt	NoSignal
		move.l	d0,Signal(a5)
		bset	d0,d6
		move.l	d6,SignalBits(a5)
	endc

	*--------------- Liste initialisieren ----------------*
		if	withlistview
		lea	ListViewStruct(a5),a0
		newlist	a0
		endc

*-------------------------- Mesage an Eagleplayer schicken -----------------*
*---- Input:	;d1 = Enabled(0) oder Disabled(1)			----*
*----		d2 = US_Class						----*
*----		d3 = Command						----*
*----		d4 = ArgList						----*
*----		d5 = Result						----*
	if Executable+Debugger
		if debugger
		move.l	#EUS_Structure,d5
		else
		moveq	#0,d5
		endc
		moveq	#0,d1
		moveq	#USClass_NewUserPrg,d2
		moveq	#0,d3
		moveq	#0,d4
		if	debugger
		move.w	#-2,MerkUserNr(a5)
		endc
		bsrif	SendeOneMessage,Executable+Debugger
		if	debugger
		move.w	MyMessage+UM_UserNr(a5),MerkUserNr(a5)
		tst.l	d0
		endc
	else
		bsr.w	OpenMyWindow
	endc
		beq.s	NoEaglePlayer
	
	ifeq	AlwaysFillListView
		bsrif	FirstFillListViews,WithListView
	endc

	*------------ Hauptprogramm ablaufen lassen ------------*
		bsr.w	Warten

	*------------ Userprogramm offiziel beenden ------------*
CloseWin:	bsrif	WaitUserMessages,Executable+Debugger
		bsr.w	CloseMyWindow
		bsrif	DeleteListViewList,WithListView


*----------------------------------------------------------------------------*
*--- Eagleplayer hat die erste Message nicht beantwortet oder ist nicht da --*
*----------------------------------------------------------------------------*
NoEagleplayer:	if	SignalUsed
		move.l	Signal(a5),d0
		move.l	4.w,a6
		jsr	_LVOFreeSignal(a6)
		endc
NoSignal:	bsrifeq	DebuggerHelpEnd,Debugger+Executable

	*----------- Ende des Userprogramms ------------*
Ende:		moveq	#0,d0
	if Executable
		rts
	else
		illegal
	endc
	ENDM
