*****************************************************************************
**               AIFF Music Format Replayer for Eagleplayer 2.0+           **
**  (C) Henryk "Buggs" Richter ,all copyright notices have to stay intact  **
**  Needs ASM-One 1.29 !                                                   **
*****************************************************************************
;Multibuffering
;RAW Support
;TODO: check whether the buffer is fine now.
;
	;
	incdir	include:
	include	exec/exec_lib.i
	include	exec/execbase.i
	include	exec/memory.i
	include	exec/types.i
	include	dos/dos_lib.i
	include	dos/dostags.i
	include	dos/dos.i
	include	misc/buggsmacros.i
	include	"misc/EaglePlayer.i"
	include	"misc/EaglePlayerengine.i"
	include	"misc/EaglePlayerFormatloader.i"

ver	macro
	dc.b	"0.87"
	endm
date	macro
	dc.b	"27.09.16"
	endm

test		=	0
loadbuffersize	=	32768			;Ladepuffergre in Bytes (grer als Playbuffersize !!)
Playbuffersize	=	2048			;Abspielpuffersize in Bytes
MinLoadBuffers	=	6			;min. 196 kB Ladepuffer
MaxLoadBuffers	=	12			;max. Anzahl der Ladepuffer (~385 kB)

 structure	LoadBuffer,0
 	word	LB_Number		;Nummer des Puffers, beginnend mit 0, wird fr den
 					;Fall bentigt, da das gesamte File beim Start
 					;eingeladen wird
	byte	LB_LastBuffer		;dies ist der letzte Puffer, durch Ladetask gesetzt (!=0)
	byte	LB_Pad			;align auf Longwortgre
	long	LB_Playoffset		;aktuelle Position beim Lesen, wird durch Laderoutine
					;auf 0 rckgesetzt
 	long	LB_LoadSize		;Anzahl der geladenen Bytes
 	struct	LB_Datas,loadbuffersize	;Daten
	Label	LB_Sizeof


 structure	AIFF_COMM,0
	ulong	COMM_ID
	ulong	COMM_Size
	word	COMM_numChannels
	ulong	COMM_numSampleFrames		;wieviele Sampleeinheiten enthlt das AIFF File
						;Sampleeinheit = alle Kanle, die zu einem
						;Zeitpunkt abgespielt werden
	word	COMM_sampleSize			;wieviele Bits enthlt das Sample
	double	COMM_sampleRate			;Abspielrate

	Label	COMM_Sizeof

;----------------------------------------------------------------------------------------------------
	ifne	test
Start:
		bsr	ClearBSS
		bsr	AIFF_Check
		bne.s	.Error
		bsr	InitPlay
		bsr	InitSound
		bsr	EndSound
		bsr	EndPlay
.Error:		illegal
	else
		section	0,code
	endc

		PLAYERHEADER PlayerTags

		dc.b '$VER: AIFF Eagleplayer V'
		ver
		dc.b	'('
		date
		dc.b	`)`,0
		even

PlayerTags
		dc.l	EP_PlayerVersion,Eagleversion
		dc.l	EP_Flags,EPB_CalcDuration!EPB_Moduleinfo!EPB_VolVoices!EPB_Restart!EPB_Songend!EPB_Volume!EPB_Balance!EPB_Voices!EPB_Analyzer
		dc.l	DTP_PlayerVersion,1
		dc.l	DTP_PlayerName,MI_Name
		dc.l	DTP_Creator,MI_Buggs
		dc.l	DTP_Check1,AIFF_Check
		dc.l	EP_Check7,Raw_Check
		dc.l	DTP_config,ClearBSS

		dc.l	DTP_InitPlayer,Initplay
		dc.l	DTP_EndPlayer,EndPlay

		dc.l	DTP_InitSound,InitSound
		dc.l	DTP_EndSound,EndSound

		dc.l	DTP_Startint,StartPlay

		dc.l	DTP_Volume,SetVoices
		dc.l	DTP_Balance,SetVoices
		dc.l	EP_Voices,SetVoices

		dc.l	EP_SetSpeed,Speedit

		dc.l	EP_NewModuleInfo,MI_InfoBuffer

		dc.l	EP_InitAmplifier,InitAudstruct

		dc.l	EP_SetPlayFrequency,SetRAWSpeed
		dc.l	EP_Eaglebase,EPBase
		dc.l	0

MI_Name		dc.b	`AIFF`,0
MI_Buggs	dc.b	`AIFF specifications  Apple Inc., player written by Buggs of Defect`,0

MI_myPlaymode	dc.b	`Player currently runs in `
MI_Playmodeadd	dc.b	0,0,0,0,0,0,0
MI_8Bit		dc.b	`8 Bit`,0
MI_16Bit	dc.b	`16 Bit`,0

	even
MI_InfoBuffer:	
	dc.l	MI_Samples,1			;4
	dc.l	MI_Duration,0			;12
	dc.l	MI_Playfrequency,0		;20
	dc.l	MI_Calcsize,0			;28
	dc.l	MI_LoadSize,0			;36
	dc.l	MI_Specialinfo,MI_myPlaymode	;44
	dc.l	MI_Voices,0			;52
	dc.l	0
EPBase		dc.l	0
;----------------------------------------------------------------------------------------------------
ClearBSS:
	lea	Datas,a0
	move	#DataSize/4-1,d0
clr$
	clr.l	(a0)+
	dbf	d0,clr$

	if	Test
	lea	MyDosname,a1
	move.l	4,a6
	moveq	#37,d0
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,MyDosbase
	endc

	rts

	if	test
MyDosbase	dc.l	0
MyDosname	dc.b	"dos.library",0
	endc


;----------------------------------------------------------------------------------------------------
Speedit:
	lea	$dff0a0,a5
	move.l	AIFF_SamplePer,d0
	bsr	PokePer
	lea	$10(a5),a5
	bsr	PokePer
	rts
;----------------------------------------------------------------------------------------------------
InitAudstruct:
		bsr	InitStruct
		move.l	a0,EPG_Amplifiertaglist(a5)
		tst.l	d0
		rts
InitStruct:
		push	d1-d7/a1-a6
	basereg	datas,a4
		lea	datas,a4

		lea	Audstruct0,a0		;Audio Struktur vorbereiten

		move.l	#EPAMB_AudioInts!EPAMB_Direct!EPAMB_8Bit,d7

		tst	AIFF_sampletype(A4)
		beq	.8bit
		tst	AIFF_Convert_to_8(a4)
		bne.s	.8bit

		move.l	#EPAMB_AudioInts!EPAMB_Direct!EPAMB_16Bit,d7
.8bit
		move.l	d7,NPFlags

		lea	(a0),a1
		move.w	#as_sizeof*2-1,d0
.clr		clr.b	(a1)+
		dbf	d0,.clr

		move.w	#01,AS_Leftright(a0)			;1. Kanal links
		move.w	#-1,AS_Leftright+as_sizeof*1(a0)	;2. Kanal rechts

		move.l	#AudioINT,AS_Int(a0)

		lea	AudTagliste(pc),a0

		pop	d1-d7/a1-a6
		moveq	#0,d0
Setvoices:
myrts:		rts

	endb	a4
AudTagliste
	dc.l	EPAMT_Numstructs,2
	dc.l	EPAMT_Audiostructs,Audstruct0
	dc.l	EPAMT_Flags
NPFlags
	dc.l	0
	dc.l    TAG_DONE,0
;--------------------------------------------------------------------------------------------------
	basereg	datas,a6
INT_Aud:
		push	all
		lea	datas,a6
		tst.b	AIFFR_NoPlay(A6)
		bne	fatal$

		tst.b	AIFFR_WaitPlay(A6)
		bne	not$

		moveq	#0,d0
		move	PlaybufNext(a6),d0
		lea	PlaybufL(a6),a1
		lea	PlaybufR(a6),a2
		add.l	d0,a1
		add.l	d0,a2
		eor.w	#Playbuffersize,d0
		move	d0,PlaybufNext(a6)

		move.l	EPBase,a5
		move.l	a1,d0
		moveq	#0,d1
		jsr	ENPP_PokeAdr(a5)
		move.l	#Playbuffersize/2,d0
		jsr	ENPP_PokeLen(a5)
;		move.l	AIFF_SamplePer,d0
;		jsr	ENPP_PokePer(a5)

		move.l	a2,d0
		addq	#1,d1
		jsr	ENPP_PokeAdr(a5)
		move.l	#Playbuffersize/2,d0
		jsr	ENPP_PokeLen(a5)
;		move.l	AIFF_SamplePer,d0
;		jsr	ENPP_PokePer(a5)

;-------------------- Puffer holen -----------------------
		move.l	AIFFR_CurrentBuf(a6),d0
		bne.s	take$

		suba.l	a0,a0				;kein alter Buffer
		bsr	newcurrentBuffer

		move.l	AIFFR_CurrentBuf(a6),d0
		beq.w	fail$

take$		move.l	d0,a0

;---------------------------- Offset und Restlnge berechnen ------------------------

		lea	LB_Datas(a0),a3
		move.l	LB_Playoffset(a0),d0
		move.l	LB_LoadSize(a0),d1
		sub.l	d0,d1
		bgt.s	goon$

		bsr	newcurrentBuffer
		move.l	AIFFR_CurrentBuf(a6),d0
		beq.w	fail$
		move.l	d0,a0
		lea	LB_Datas(a0),a3
		move.l	LB_Playoffset(a0),d0	;sollte 0 sein, siehe unten
		move.l	LB_LoadSize(a0),d1
goon$
		move	AIFF_BytesperFrame(a6),d2
		mulu	AIFF_ReadPerInt(A6),d2

		cmp.l	d2,d1
		blt.s	abnormal$
		moveq	#0,d1
		move	AIFF_ReadPerInt(A6),d1
		bra	normal$
.abnormal
		divu	AIFF_BytesperFrame(a6),d1
normal$
		add.l	d0,a3

;-------------------------------- eigentliche Abspielroutine -------------------------
		move	AIFF_sampletype(a6),d0
		beq	do8Bit$

		move	AIFF_NumChannels(a6),d0
		subq	#1,d0
		bne	dostereo16$

		tst	AIFF_Convert_to_8(a6)
		bne.s	do16_8_mono$
		bsr	FillBufMono16
		bra	end$
do16_8_mono$
		bsr	FillBufMono16_to_8
		bra	end$
dostereo16$
		tst	AIFF_Convert_to_8(a6)
		bne.s	do16_8$
		bsr	FillBufStereo16
		bra	end$
do16_8$
		bsr	FillBufStereo16_to_8
		bra	end$
do8Bit$
		move	AIFF_NumChannels(a6),d0
		subq	#1,d0
		bne	dostereo8$
		bsr	FillBufMono8
		bra	end$
dostereo8$
		bsr	FillBufStereo8
end$
		move.l	AIFFR_CurrentBuf(a6),d0
		beq	not$
		move.l	d0,a0
		lea	LB_Datas(a0),a1
		sub.l	a1,a3
		move.l	a3,LB_Playoffset(a0)
not$
;------------------------------------------------------------------------------------
		sf	AIFFR_WaitPlay(A6)
		pop	all
		rts
fail$
		move.w	#Playbuffersize,d2
		bsr	CLR_Rest
		pop	all
		rts
fatal$
		moveq	#$3,d0
		bsr	PokeDMA

		pop	all
		rts


FillBufMono16
		move	AIFF_ReadPerInt(A6),d2
		sub.w	d1,d2
		ble	fastmono16$

		subq	#1,d1
		bmi	dorest$
copy$
		move.w	(a3)+,d0
		move	d0,(a1)+
		move	d0,(a2)+
;	move	#$f0f,$dff180
		dbf	d1,copy$
dorest$
		subq	#1,d2
		bmi	fertig$

		bsr	newcurrentBuffer
		move.l	AIFFR_CurrentBuf(a6),d0
		beq	CLR_Rest16
		move.l	d0,a0
		lea	LB_Datas(a0),a3
copyrest$
		move.w	(a3)+,d0
		move	d0,(a1)+
		move	d0,(a2)+
		dbf	d2,copyrest$
fertig$		rts

fastmono16$
		lsr	#2,d1			;Anzahl der Worte -> Langworte*Anzahl

		subq	#1,d1
loop$
;		move	#$f0f,$dff180
		movem.l	(a3)+,d0/d2
		move.l	d0,(a1)+
		move.l	d2,(a1)+
		move.l	d0,(a2)+
		move.l	d2,(a2)+
		dbf	d1,loop$
		rts

FillBufStereo16
		move	AIFF_ReadPerInt(A6),d2
		sub.w	d1,d2
		ble	faststereo16$

		subq	#1,d1
		bmi	dorest$
copy$
		move.w	(a3)+,(a1)+
		move.w	(a3)+,(a2)+
		dbf	d1,copy$
dorest$
		subq	#1,d2
		bmi	fertig$

		bsr	newcurrentBuffer
		move.l	AIFFR_CurrentBuf(a6),d0
		beq	CLR_Rest16
		move.l	d0,a0
		lea	LB_Datas(a0),a3
copyrest$
		move.w	(a3)+,(a1)+
		move.w	(a3)+,(a2)+
		dbf	d2,copyrest$
fertig$		rts

faststereo16$
		lsr	#1,d1

		subq	#1,d1
loop$
;		move	#$f0f,$dff180
;		move.w	(a3)+,(a1)+
;		move.w	(a3)+,(a2)+

		movem.l	(a3)+,d0/d2
		move	d0,(a2)+
		move	d2,(a2)+
		swap	d0
		swap	d2
		move	d0,(a1)+
		move	d2,(a1)+
		dbf	d1,loop$
		rts


FillBufStereo16_to_8
		move	AIFF_ReadPerInt(A6),d2
		sub.w	d1,d2
;		ble	faststereo16_8$

		subq	#1,d1
		bmi	dorest$
copy$
		move.b	(a3)+,(a1)+
		addq.l	#1,a3
		move.b	(a3)+,(a2)+
		addq.l	#1,a3
		dbf	d1,copy$
dorest$
		subq	#1,d2
		bmi	fertig$

		bsr	newcurrentBuffer
		move.l	AIFFR_CurrentBuf(a6),d0
		beq	CLR_Rest
		move.l	d0,a0
		lea	LB_Datas(a0),a3
copyrest$
		move.b	(a3)+,(a1)+
		addq.l	#1,a3
		move.b	(a3)+,(a2)+
		addq.l	#1,a3
		dbf	d2,copyrest$
fertig$		rts

faststereo16_8$
		subq	#1,d1
fastcopy$
		move	(a3)+,d0
		move.b	d0,d1


		move.b	(a3)+,(a1)+
		addq.l	#1,a3
		move.b	(a3)+,(a2)+
		addq.l	#1,a3
		dbf	d1,fastcopy$
		rts

FillBufMono16_to_8
		move	AIFF_ReadPerInt(A6),d2
		sub.w	d1,d2

		subq	#1,d1
		bmi	dorest$
copy$
		move.b	(a3)+,d0
		addq.l	#1,a3
		move.b	d0,(a1)+
		move.b	d0,(a2)+
		dbf	d1,copy$
dorest$
		subq	#1,d2
		bmi	fertig$

		bsr	newcurrentBuffer
		move.l	AIFFR_CurrentBuf(a6),d0
		beq	CLR_Rest
		move.l	d0,a0
		lea	LB_Datas(a0),a3
copyrest$
		move.b	(a3)+,d0
		addq.l	#1,a3
		move.b	d0,(a1)+
		move.b	d0,(a2)+
		dbf	d2,copyrest$
fertig$		rts

FillBufStereo8
		move	AIFF_ReadPerInt(A6),d2
		sub.w	d1,d2

		subq	#1,d1
		bmi	dorest$
copy$
		move.b	(a3)+,(a1)+
		move.b	(a3)+,(a2)+
		dbf	d1,copy$
dorest$
		subq	#1,d2
		bmi	fertig$

		bsr	newcurrentBuffer
		move.l	AIFFR_CurrentBuf(a6),d0
		beq	CLR_Rest
		move.l	d0,a0
		lea	LB_Datas(a0),a3
copyrest$
		move.b	(a3)+,(a1)+
		move.b	(a3)+,(a2)+
		dbf	d2,copyrest$
fertig$		rts

FillBufMono8
		move	AIFF_ReadPerInt(A6),d2
		sub.w	d1,d2

		subq	#1,d1
		bmi	dorest$
copy$
		move.b	(a3)+,d0
		move.b	d0,(a1)+
		move.b	d0,(a2)+
		dbf	d1,copy$
dorest$
		subq	#1,d2
		bmi	fertig$

		bsr	newcurrentBuffer
		move.l	AIFFR_CurrentBuf(a6),d0
		beq	CLR_Rest
		move.l	d0,a0
		lea	LB_Datas(a0),a3
copyrest$
		move.b	(a3)+,d0
		move.b	d0,(a1)+
		move.b	d0,(a2)+
		dbf	d2,copyrest$
fertig$		rts

;----------------------- restliche Bytes lschen, wenn kein Puffer mehr bereit -----------------
CLR_Rest
		subq	#1,d2
		bmi	fertig$
CLR_Rest$
		clr.b	(a1)+
		clr.b	(a2)+
		dbf	d2,CLR_Rest$
fertig$		rts

CLR_Rest16
		subq	#1,d2
		bmi	fertig$
CLR_Rest$
		clr.w	(a1)+
		clr.w	(a2)+
		dbf	d2,CLR_Rest$
fertig$		rts

;------------------------------------------------------------------------------------------
;- Input:  A0 - alter Puffer oder 0
;- Output: A0 - neuer Puffer oder 0 (selbiges gilt fr AIFFR_CurrentBuf)
;
NewCurrentBuffer:
		push	d0-d7/a1-a6

		move.l	a0,d0
		beq.s	noold$

		lea	AIFF_ReadyBufList(a6),a1
such$		tst.l	(a1)+			;einer ist garantiert frei, da genau der jetzige
		bne.s	such$			;Puffer in eine Liste soll, die fr alle ausreicht

		move.l	a0,-4(a1)		;und in Readyliste eintragen

		tst.b	AIFFR_LoadOnce(a6)	;mssen wir darauf achten, da der Puffer erhalten
		bne.s	keepNum$		;bleibt ?
		clr.w	LB_Number(a0)		;nein, Puffer freigeben
keepNum$
		tst.b	LB_LastBuffer(a0)	;zuende gespielt ?
		beq.s	nosongend$

		move.l	EPBase(pc),a2		;Eagleplayer benachrichtigen, da das
		jsr	ENPP_Songend(a2)	;Songende erreicht wurde

		tst.b	AIFFP_NoLoad(A6)	;Test, ob noch irgend etwas nachgeladen wurde
		beq.s	nosortlist$

		move	LB_Number(a0),d0	;hchste Nummer (die des letzten Puffers)
		moveq	#0,d3				;aktuelle Nummer
		lea	AIFF_ReadyBufList(a6),a1	;Liste 1
		lea	AIFF_LoadedBufList(a6),a2	;Liste 2
sortlist$						;
		move.l	a1,a0				;Anfang der Liste
		moveq	#MaxLoadBuffers-1,d1		;max. Anzahl
suchentry$
		move.l	(a0)+,d2			;Eintrag ?
		bne.s	foundentry$			;yup
suchweiter$
		dbf	d1,suchentry$			;weitersuchen

		st	AIFFR_NoPlay(a6)		;Fatal Error, Replay anhalten

		suba.l	a0,a0				;sorry, wir haben nix zum Fttern des Players
		clr.l	AIFFR_CurrentBuf(a6)		;kein aktueller Puffer
		bra	fail$
foundentry$
		move.l	d2,a3				;
		cmp.w	LB_Number(a3),d3		;Stimmt Nummer ?
		bne	suchweiter$			;nein, weitersuchen

		clr.l	LB_Playoffset(a3)		;Offset rcksetzen

		clr.l	-4(a0)				;Eintrag aus Liste entfernen
		move.l	a3,(a2)+			;in andere Liste einklinken
		addq	#1,d3
		dbf	d0,sortlist$			;weiter

		moveq	#MaxLoadBuffers-1,d1		;max. Anzahl
		lea	AIFF_ReadyBufList(a6),a1	;Liste 1
clrentries$						;
		clr.l	(a1)+				;nur zur Sicherheit alle mglichen Eintrge
		clr.l	(a2)+				;beider Listen
		dbf	d1,clrentries$			;lschen
nosortlist$
nosongend$

noold$
		lea	AIFF_LoadedBufList(a6),a1 ;Liste der fertig geladenen Puffer
		moveq	#MaxLoadBuffers-1,d0	;
findfree$
		move.l	(a1)+,d1		;falls einmal aus Handshaking-Grnden ein Puffer
		bne	found$			;ausgelassen wurde, muss die gesamte Liste
		dbf	d0,findfree$		;durchsucht werden

		suba.l	a0,a0			;sorry, wir haben nix zum Fttern des Players
		clr.l	AIFFR_CurrentBuf(a6)	;kein aktueller Puffer

		bsr	signal_load$		;aber Hallo! Sofort Daten Laden, wird`s bald ?
		bra	fail$
found$
		move.l	d1,a0			;neuer Puffer

		lea	AIFF_LoadedBufList(a6),a2 ;alles bis nach oben durchscrollen
		moveq	#MaxLoadBuffers-1,d0
copylist$
		move.l	(a1)+,(a2)+
		dbf	d0,copylist$

		move.l	a0,AIFFR_CurrentBuf(a6)	;eintragen in Globals

		move.b	AIFFR_CountBufferchg(A6),d0
		addq.b	#1,d0
		cmp.b	AIFFR_NumCountBuffer(A6),d0
		blt	nosig$
		bsr	signal_load$		;Signal nur alle 2 mal schicken, das sollte reichen

		moveq	#0,d0
nosig$		move.b	d0,AIFFR_CountBufferchg(A6)

fail$
		pop	d0-d7/a1-a6
		rts

signal_load$
		push	all
		
		tst	AIFFP_Ready(A6)		;ist der Lade-Task noch da ?
		beq	local_fail$		;

		move.l	AIFFP_Address(A6),a1	;ok, geben wir dem mal was zu tun
		move.l	AIFFP_SignalLoad(A6),d1	;
		moveq	#0,d0			;
		bset	d1,d0			;
		move.l	myExecbase(A6),a6	;
	endb	a6
		jsr	_LVOsignal(a6)		;
local_fail$
		pop	all
		rts
;----------------------------------- Checkroutine ------------------------------------------------
AIFF_Check:
	basereg	Datas,a4
		lea	Datas,a4

	ifne	test
		lea	testsample,a0
		move.l	#testsize,d7
	else
		move.l	DTG_Chkdata(A5),a0
		move.l	DTG_Chksize(A5),d7
	endc

		move.l	a0,a1
		move.l	a0,d6
		add.l	d7,a1

		cmp.l	#`FORM`,(a0)
		bne.w	fail$
		addq.l	#4,a0
		move.l	(a0)+,TMP_FileSize(a4)
		cmp.l	#`AIFF`,(a0)+
		bne.w	fail$
		move.l	a0,a2

		move.l	#`COMM`,d0
		bsr	FindIFFchunk
		bne.w	.Commda

		move.l	#`COMM`,d0
		bsr	FindIFFHandleChunk
		beq.w	fail$


.COMMDa

		move	COMM_numChannels(A0),d1
		beq	fail$
		cmp	#2,d1
		bhi	fail$
		move	d1,TMP_numChannels(A4)
	
		moveq	#0,d0
		cmp	#8,COMM_sampleSize(a0)		;nur 8 Bit bis 16 Bit Samples untersttzt
		beq	weiter$
		blt	fail$				;ab 8 Bit bis 16 Bit wird gespielt

		moveq	#1,d0
		cmp	#16,COMM_sampleSize(a0)
		bhi	fail$
weiter$		move	d0,TMP_sampletype(a4)

		addq	#1,d0
		mulu	d1,d0
		move	d0,TMP_BytesperFrame(a4)

		move.l	COMM_numSampleFrames(A0),d0
		beq	fail$
		move.l	d0,TMP_numSampleFrames(A4)

		lea	COMM_sampleRate(A0),a0
		bsr	Extended2Long
		beq	fail$
		move.l	d0,TMP_sampleRate(A4)

		move.l	a2,a0
		move.l	#`SSND`,d0
		bsr	FindIFFchunk

		*bne.s	.SSNDDa
		*move.l	#`SSND`,d0
		*moveq	#$12-4,d1
		*bsr	FindIFFHandleChunk
		beq.s	fail$

.SSNDDa:	lea	16(a0),a0
		sub.l	d6,a0
		move.l	a0,TMP_BodyOffset(A4)

		move.l	a0,d0
		neg.l	d0
		move.l	d6,a0
		add.l	4(a0),d0
		move.l	d0,TMP_BodySize(A4)

		move.l	#MI_Calcsize,MI_InfoBuffer+24

		moveq	#0,d0
		rts

fail$		moveq	#-1,d0
		rts

;----------------------- Checkroutine fr RAW-Abspielen -------------------------------------------
RAW_Check:
		lea	Datas,a4
		move.l	a0,-(sp)				;Tagliste sichern

	ifeq	test
		move.l	DTG_Dosbase(a5),Dosbase(A4)		;DosBase holen

		move.l	dtg_PathArrayPtr(a5),a0			;Filepfad zusammensetzen
		clr.b	(a0)					;
		move.l	dtg_CopyDir(a5),a0			;
		jsr	(a0)					;
		move.l	dtg_CopyFile(a5),a0			;
		jsr	(a0)					;

		move.l	DOSBase(A4),a6				;File Lock holen, der dann
		move.l	dtg_PathArrayPtr(a5),d1			;an den Playproze weitergereicht
		moveq	#-2,d2					;wird
		jsr	_LVOLock(a6)				;
		move.l	d0,TMP_Filelock(a4)			;
		tst.l	d0
		beq	fail2$					;wg. a0,-(sp)

		lea	-[Fib_SizeOf+20](sp),sp			;Filelnge rauskriegen
		move.l	sp,d2					;kein Allocmem, einfach Stack benutzt
		addq.l	#4,d2					;Adresse auf 
		and.l	#~3,d2					; Langwortgre align
		move.l	d2,a3					;Adr sichern
		move.l	d0,d1					;Filelock
		jsr	_LVOExamine(a6)				;Examine
		tst.l	d0					;
		bne.s	ItsAll$					;
		bsr	UnlockFile				;
		bra	fail2$					;wg. a0,-(sp)
ItsAll$								;
		move.l	Fib_Size(a3),d7				;Wert sichern

		lea	Fib_SizeOf+20(sp),sp			;Filelnge rauskriegen

		bsr	UnlockFile
	endc
		move.l	d7,TMP_FileSize(a4)

		move.l	(sp)+,a3				;Tagliste holen

		move.l	a3,a0
		move.l	#FL_NumChannells,d0
		move.l	EPG_FindTag(a5),a1
		jsr	(a1)
		tst.l	d1
		beq.w	fail$				;Anzahl Kanle zwingend
		move	d0,TMP_numChannels(A4)

		cmp	#1,d0				;Mono ?
		beq	numchanok$			;ja, weiter

		move.l	a3,a0				;wenn Stereo, dann Flags
		move.l	#FL_Flags,d0			;notwendig, ob Interleaved
		move.l	EPG_FindTag(a5),a1		;oder nicht
		jsr	(a1)
		tst.l	d1
		beq	fail$				;Anzahl Kanle zwingend
		btst	#FLB_Interleaved,d0
		beq	fail$
numchanok$
		move.l	a3,a0
		move.l	#FL_SampleType,d0
		move.l	EPG_FindTag(a5),a1
		jsr	(a1)
		tst.l	d1
		beq.s	fail$				;Sampletyp zwingend


		moveq	#0,d1
		cmp.l	#FLST_8BitRAW,d0
		beq.s	weiter$

		moveq	#1,d1
		cmp.l	#FLST_16BitRAW,d0
		beq.s	weiter$

;FLST_8BitUnsignedRaw	EQU	2
;FLST_16BitRAW		EQU	3
;FLST_16BitUnsignedRAW	EQU	4
;FLST_16BitIntel		EQU	5
;FLST_16BitIntelUnsigned	EQU	6

		bra	fail$
weiter$
		move	d1,TMP_sampletype(a4)

		addq	#1,d1
		mulu	TMP_numChannels(A4),d1
		move	d1,TMP_BytesperFrame(a4)

		move.l	TMP_FileSize(a4),d0
		bsr	longdiv				;Filesize/Bytes per Frame
		move.l	d0,TMP_numSampleFrames(A4)

		move.l	a3,a0
		move.l	#FL_DefFreqPtr,d0
		move.l	EPG_FindTag(a5),a1
		jsr	(a1)
		tst.l	d1
		beq.s	fail$				;Sampletyp zwingend
		move.l	d0,a0
		move.l	(a0),TMP_SampleRate(a4)
		tst.l	(a0)
		beq.s	fail$

		clr.l	TMP_BodyOffset(A4)	;wird von Anfang an gespielt
		move.l	TMP_FileSize(a4),TMP_BodySize(A4);komplettes File

		move.l	#TAG_IGNORE,MI_InfoBuffer+24

		moveq	#0,d0
		rts

fail2$		move.l	(sp)+,a0
fail$		moveq	#-1,d0
		rts

;---------------------- Abspielrate des Samples ndern -----------------------
SetRAWSpeed:
		lea	datas,a4

		move.l	d0,AIFF_SampleRate(A4)

		move.l	myExecbase(A4),a1		;
		move.l	ex_eclockfrequency(a1),d2	;
		move.l	d2,d0				;
		lsl.l	#2,d2				;mal 4
		add.l	d0,d2				;mal 4+1 = mal 5!
	;	move.l	#3546895,d2			;

		move.l	AIFF_sampleRate(a4),d0		;
		divu	d0,d2				;
		and.l	#$ffff,d2			;
		move.l	d2,AIFF_SamplePer(A4)		;

		lea	$dff0a0,a5
		move.l	AIFF_SamplePer(A4),d0
		bsr	PokePer
		lea	$dff0b0,a5
		bsr	PokePer
		rts

;-------------------------------------------------------------------------------
;                    Suche angegebenen IFF Chunk
;Input:  A0 - aktuelle Position im IFF File 
;        D0 - zu suchender Chunk
;        A1 - geladene Lnge (Overflow check)
;Output: A0 - Pointer auf den Chunk
;        D0 - Suxxess, 0=fail, sonst Lnge des Chunks 
FindIFFchunk:

loop$
		cmp.l	(a0),d0
		beq	ok$
		add.l	4(a0),a0
		addq.l	#8,a0
		cmp.l	a0,a1
		bgt	loop$
		moveq	#0,d0
		rts
ok$		move.l	4(a0),d0
		rts


*-----------------------------------------------------------------------------*
* Input: PathArrayPtr = Pfad
*        D0 - zu suchender Chunk
*Output: A0 - Pointer auf den Chunk
*        D0 - Suxxess, 0=fail, sonst Lnge des Chunks 
*-----------------------------------------------------------------------------*
FindIFFHandleChunk:
		movem.l	d1-d7/a1-a6,-(a7)

		move.l	d0,d6
		moveq	#0,d7

		ifeq	Test
		move.l	DTG_PathArrayPtr(a5),d1
		else
		move.l	#Testname,d1
		endc

		ifeq	Test
		move.l	DTG_Dosbase(a5),a6
		else
		move.l	MyDosbase(pc),a6
		endc


		move.l	#1005,d2
		jsr	_LVOOpen(a6)
		tst.l	d0
		beq	.Error
		move.l	d0,d5

		*-- Position auf 1. Chunk --*
		move.l	d5,d1
		moveq	#0,d3
		moveq	#$c,d2
		jsr	_LVOSeek(a6)
		cmp.l	#-1,d0
		beq.w	.Error

		*-- nchsten Chunk testen --*
.RetrySeek:	lea	TMP_LoadBuffer(a4),a0
		move.l	a0,d2
		move.l	#8,d3
		move.l	d5,d1
		jsr	_LVORead(a6)
		cmp.l	d0,d3
		bne.w	.Error

		move.l	TMP_LoadBuffer+4(a4),d3
		move.l	TMP_LoadBuffer(a4),d0
		cmp.l	d6,d0
		beq.s	.JaFound

		move.l	d5,d1
		moveq	#0,d2
		*subq.l	#4,d3
		exg	d3,d2
		jsr	_LVOSeek(a6)
		cmp.l	#-1,d0
		beq.w	.Close
		bra.s	.RetrySeek

.JaFound:	lea	TMP_LoadBuffer+8(a4),a0
		move.l	a0,d2
		move.l	d5,d1
		moveq	#$12-4,d3			?msste reichen
		jsr	_LVORead(a6)
		cmp.l	d0,d3
		bne.s	.Close

		moveq	#1,d7

.Close:		move.l	d5,d1
		jsr	_LVOClose(a6)
.Error:		moveq	#0,d0
		tst.l	d7
		beq.w	.Return

		lea	TMP_LoadBuffer(a4),a0
		move.l	4(a0),d0
.Return:	movem.l	(a7)+,d1-d7/a1-a6
		tst.l	d0
		rts



;-------------------------------------------------------------------------------
;		Convert an 80 bit IEEE Standard 754 floating point number
;		into an integer value.
;Format: WORD Exponent, Bit 15 ist ``
;        LONG Mantisse[2]
;
;Input:  A0 - Pointer auf IEEE Zahl
;Output: D0 - Zahl als Integer
;
Extended2Long:
		move.b	(a0),d0			;Zahl negativ ?
		smi	d1
		ext.w	d1
		ext.l	d1
		or.b	#1,d1			;bei positiv -> 1, negativ -> -1

		move.l	2(a0),d0

		move	(a0),d2			;Exponent
		and	#$7fff,d2
		sub	#$3fff,d2
		bmi.s	ret_0$			;<0 ? -> raus

						; Special meaning?
		sub	#31,d2
						; Overflow?
		bpl.s	ret_maxInt$

		neg	d2
		lsr.l	d2,d0			; in D0 Samplerate
		rts
ret_0$
		moveq	#0,d2
		rts
ret_maxInt$	move.l	#$7FFFFFFF,d2
		rts
;--------------------------------------------------------------------------------------------------
StartPlay:
		lea	datas,a4

		moveq	#$3,d0
		bsr	PokeDMA

		lea	PlaybufL(A4),a0
		lea	(a0),a1
		lea	PlaybufR(a4),a2
		lea	(a2),a3
		move	#Playbuffersize*2/4-1,d0
.clr
		clr.l	(a1)+
		clr.l	(a3)+
		dbf	d0,.clr

		lea	$dff0a0,a5
		move.l	a0,D0
		bsr	PokeAdr
		move.l	#Playbuffersize/2,d0
		bsr	PokeLen
		move.l	AIFF_SamplePer(A4),d0
		bsr	PokePer
		moveq	#64,d0
		bsr	PokeVol

		lea	$dff0b0,a5
		move.l	a2,D0
		bsr	PokeAdr
		move.l	#Playbuffersize/2,d0
		bsr	PokeLen
		move.l	AIFF_SamplePer,d0
		bsr	PokePer
		moveq	#64,d0
		bsr	PokeVol

		move	#Playbuffersize,PlaybufNext

		move.b	#1,AIFFR_WaitPlay

		move	#$8003,d0
		bsr	PokeDMA
		moveq	#0,d0
		rts

;-----------------------------------------------------------------------------------
PokeVol:			;in D0 Lautstrke
	movem.l	d1/a5,-(sp)
	move.w	a5,d1		;Dff0a0/b0/c0/d0
	sub.w	#$f0a0,d1
	lsr.w	#4,d1		;Nummer der Stimme von 0-3
	move.l	EPBase,a5
	jsr	ENPP_Pokevol(a5)
	movem.l	(sp)+,d1/a5
	rts
PokePer:			;in D0 Periodenwert
		push	d1/d2/a5

		move.w	a5,d1		;Dff0a0/b0/c0/d0
		sub.w	#$f0a0,d1
		lsr.w	#4,d1		;Nummer der Stimme von 0-3
		and.w	#$f,d1

		move.l	EPBase,a5

		move	EPG_Speed(a5),d2
		beq.s	.speed0
	
		bmi.s	.slower
		mulu	#20,d0
		add	#20,d2
		divu	d2,d0
		bra.s	.speed0
.slower
		neg	d2
		add	#20,d2
		mulu	d2,d0
		divu	#20,d0
.speed0
		jsr	ENPP_PokePer(a5)
		pop	d1/d2/a5
		rts
PokeLen:			;in D0 Lnge in Worten
	movem.l	d1/a5,-(sp)
	move.w	a5,d1		;Dff0a0/b0/c0/d0
	sub.w	#$f0a0,d1
	lsr.w	#4,d1		;Nummer der Stimme von 0-3

	move.l	EPBase,a5
	jsr	ENPP_PokeLen(a5)

	movem.l	(sp)+,d1/a5
	rts
PokeAdr:			;in D0 Adresse
	movem.l	d1/a5,-(sp)
	move.w	a5,d1		;Dff0a0/b0/c0/d0
	sub.w	#$f0a0,d1
	lsr.w	#4,d1		;Nummer der Stimme von 0-3
	move.l	EPBase,a5
	jsr	ENPP_PokeAdr(a5)
	movem.l	(sp)+,d1/a5
	rts
PokeDMA:
	movem.l	d1/d2/a5,-(sp)
	move.l	EPBase,a5
	move.w	d0,d1
	and.w	#$8000,d0	;D0.w neg=enable ; 0/pos=disable
	and.l	#15,d1		;D1 = Maske (LONG !!)
	jsr	ENPP_DmaMask(a5)
	movem.l	(sp)+,d1/d2/a5
	rts

;-----------------------------------------------------------------------------------
;
;
;
InitPlay:
		lea	Datas,a4
		move	TMP_numChannels(A4),AIFF_Numchannels(A4)	;temporre Variablen kopieren
		move	TMP_sampletype(a4),AIFF_Sampletype(A4)		;
		move	TMP_BytesperFrame(A4),AIFF_BytesperFrame(a4)	;
		move.l	TMP_numSampleFrames(A4),AIFF_numSampleFrames(A4);
		move.l	TMP_sampleRate(a4),AIFF_sampleRate(a4)		;
		move.l	TMP_BodyOffset(A4),AIFF_BodyOffset(A4)		;
		move.l	TMP_BodySize(A4),AIFF_BodySize(A4)		;

		move.l	4,myExecbase(A4)
		move.l	a5,EPBase					;Eagleplayer Base sichern
		
		move.b	#2,AIFFR_NumCountBuffer(A4)		;Warteanzahl fr das Neuladen der
								;Puffer
		sf	AIFFR_LoadOnce(A4)			;Datei nur einmal laden `aus`

		move.l	#LB_Sizeof*MinLoadBuffers,d0		;Mindestanzahl an Puffern allozieren
		moveq	#MEMF_Fast!MEMF_Public,d1		;
		move.l	myExecbase(A4),a6			;
		jsr	_LVOAllocMem(A6)			;
		move.l	d0,AIFF_LoadBuf(A4)			;
		beq.w	fail$					;
								;
		cmp.l	#loadbuffersize*MinLoadBuffers,AIFF_BodySize(A4) ;reichen Puffer bereits
		ble	puffer_reicht$				; fr gesamtes File ?
		move.l	#LB_Sizeof*[MaxLoadBuffers-MinLoadBuffers],d0	;2. Anzahl Puffer allozieren
		moveq	#MEMF_Fast!MEMF_Public,d1		;
		move.l	myExecbase(A4),a6			;
		jsr	_LVOAllocMem(A6)			;
		move.l	d0,AIFF_LoadBuf2(A4)			;
		beq.s	puffer_nosecond$			;
								;
		move.b	#4,AIFFR_NumCountBuffer(A4)		;Warteanzahl fr das Neuladen der
								;Puffer
								;
								;
		cmp.l	#loadbuffersize*MaxLoadBuffers,AIFF_BodySize(A4) ;reichen Puffer jetzt fr
		bgt.s	puffer_nosecond$			; gesamtes File aus ?
puffer_reicht$							;
		st	AIFFR_LoadOnce(A4)			;Datei nur einmal laden an

puffer_nosecond$						;
	ifeq	test

		move.l	DTG_Dosbase(a5),Dosbase(A4)		;DosBase holen

		move.l	dtg_PathArrayPtr(a5),a0			;Filepfad zusammensetzen
		clr.b	(a0)					;
		move.l	dtg_CopyDir(a5),a0			;
		jsr	(a0)					;
		move.l	dtg_CopyFile(a5),a0			;
		jsr	(a0)					;

		move.l	DOSBase(A4),a6				;File Lock holen, der dann
		move.l	dtg_PathArrayPtr(a5),d1			;an den Playproze weitergereicht
		moveq	#-2,d2					;wird
		jsr	_LVOLock(a6)				;
		move.l	d0,PR_Filelock(a4)			;
		beq.w	fail$					;

		lea	-[Fib_SizeOf+20](sp),sp			;Filelnge rauskriegen
		move.l	sp,d2					;kein Allocmem, einfach Stack benutzt
		addq.l	#4,d2					;Adresse auf 
		and.l	#~3,d2					; Langwortgre align
		move.l	d2,a3					;Adr sichern
		move.l	d0,d1					;Filelock
		jsr	_LVOExamine(a6)				;Examine
		tst.l	d0					;
		beq.s	.ItsAll					;
		move.l	Fib_Size(a3),MI_InfoBuffer+36		;Wert sichern
.ItsAll								;
		lea	Fib_SizeOf+20(sp),sp			;Filelnge rauskriegen
	else
		lea	dos(pc),a1
		moveq	#37,d0
		move.l	myExecbase(A4),a6
		jsr	_LVOopenlibrary(a6)
		move.l	d0,dosbase(A4)

		move.l	DOSBase(A4),a6
		move.l	#filepath,d1
		moveq	#-2,d2
		jsr	_LVOLock(a6)			;File Lock
		move.l	d0,PR_Filelock(a4)
		beq.s	fail$

;		lea	testloadbuff,a0
;		move.l	a0,AIFF_LoadBuf(A4)
	endc

		move	#PlayBuffersize,AIFF_ReadPerInt(A4)
		lea	MI_8Bit(pc),a3

		tst	AIFF_Sampletype(A4)
		beq.s	.8bit

	;------------ Hier Suche nach geeignetem Amplifier fr 16 Bit Abspielen einfgen ------------
		sf	AIFF_Convert_to_8(a4)

		bsr	InitStruct			;Audio-Struct + Tagliste init + in A0 zurck
		jsr	ENPP_FindAmplifier(a5)
		tst.l	d0
		beq.s	.8bit

		move	#PlayBuffersize/2,AIFF_ReadPerInt(A4)
		lea	MI_16Bit(pc),a3
		bra.s	.16bit
.8bit
		st	AIFF_Convert_to_8(a4)
.16bit
		lea	MI_Playmodeadd(pc),a2
playmode$
		move.b	(a3)+,(a2)+
		bne.s	playmode$

		move.l	AIFF_sampleRate(A4),d1
		move.l	d1,MI_InfoBuffer+20	;Set Playfrequency

		move.l	AIFF_numSampleFrames(a4),d0
		bsr.s	longdiv
		move.l	d0,MI_InfoBuffer+12	;Set Duration

;		move.l	AIFF_BodyOffset(A4),d0	;Offset zu den Sampledaten
;		add.l	AIFF_BodySize(A4),d0	;Sampledaten
		move.l	TMP_FileSize(a4),d0
		addq.l	#8,d0
		move.l	d0,MI_InfoBuffer+28	;Set Size

		moveq	#0,d0
		move	AIFF_Numchannels(A4),d0
		move.l	d0,MI_InfoBuffer+52	;Wert sichern

		moveq	#0,d0
		rts
fail$
		moveq	#-1,d0
		rts

* divu_32 --- d0 = d0/d1, d1=jakojnns
longdiv
	move.l	d3,-(a7)
	swap	d1
	tst	d1
	bne.b	lb_5f8c
	swap	d1
	move.l	d1,d3
	swap	d0
	move	d0,d3
	beq.b	lb_5f7c
	divu	d1,d3
	move	d3,d0
lb_5f7c	swap	d0
	move	d0,d3
	divu	d1,d3
	move	d3,d0
	swap	d3
	move	d3,d1
	move.l	(a7)+,d3
	rts	

lb_5f8c	swap	d1
	move	d2,-(a7)
	moveq	#16-1,d3
	move	d3,d2
	move.l	d1,d3
	move.l	d0,d1
	clr	d1
	swap	d1
	swap	d0
	clr	d0
lb_5fa0	add.l	d0,d0
	addx.l	d1,d1
	cmp.l	d1,d3
	bhi.b	lb_5fac
	sub.l	d3,d1
	addq	#1,d0
lb_5fac	dbf	d2,lb_5fa0
	move	(a7)+,d2
	move.l	(a7)+,d3
	rts	
;------------------------------------------------------------------------------------------
;
;
;
EndPlay:
		lea	Datas,a4
;	ifeq	test
		move.l	AIFF_LoadBuf(A4),d0
		beq.s	exit1$
		move.l	d0,a1
		move.l	#LB_Sizeof*MinLoadBuffers,d0
		move.l	myExecbase(A4),a6
		jsr	_LVOFreemem(a6)
exit1$		clr.l	AIFF_LoadBuf(A4)

		move.l	AIFF_LoadBuf2(A4),d0
		beq.s	exit2$
		move.l	d0,a1
		move.l	#LB_Sizeof*[MaxLoadBuffers-MinLoadBuffers],d0
		move.l	myExecbase(A4),a6
		jsr	_LVOFreemem(a6)
exit2$		clr.l	AIFF_LoadBuf2(A4)

;	endc

		bsr	UnlockFile

		moveq	#0,d0
		rts

;------------------------------------------------------------------------------------------
;
;
;
InitSound:
		bsr	EndSound

		lea	Datas,a4

		move.l	myExecbase(A4),a1		;
		move.l	ex_eclockfrequency(a1),d2	;
		move.l	d2,d0				;
		lsl.l	#2,d2				;mal 4
		add.l	d0,d2				;mal 4+1 = mal 5!
	;	move.l	#3546895,d2			;
		move.l	AIFF_sampleRate(a4),d0		;
		divu	d0,d2				;
		and.l	#$ffff,d2			;
		move.l	d2,AIFF_SamplePer(A4)		;

		moveq	#-1,d0				;Signal allozieren, 
		move.l	myExecbase(A4),a6		;fr Returnmeldungen vom Proze
		jsr	_LVOallocsignal(a6)		;
		move.l	d0,AIFFP_SignalReturn(a4)	;
		bmi	fail$				;

		suba.l	a1,a1				;Task suchen
		move.l	myExecbase(A4),a6		;
		jsr	_LVOFindtask(A6)		;
		move.l	d0,AIFFP_SigTask(A4)		;

		move.l	AIFF_LoadBuf(A4),a0		;alle Puffer in Readylist setzen, sprich
		lea	AIFF_ReadyBufList(A4),a1	;alle knnen vom LadeProze voll Daten
		moveq	#MinLoadBuffers-1,d0		;geladen werden
initreadybuffers$					;
		clr	LB_Number(a0)			;
		sf	LB_LastBuffer(a0)		;
		move.l	a0,(a1)+			;
		add.l	#LB_Sizeof,a0			;
		dbf	d0,initreadybuffers$		;

		move.l	AIFF_LoadBuf2(A4),d0		;2. benutzbarer Puffer ?
		beq.s	nobuf2$				;nein
		move.l	d0,a0				;also in Liste einklinken
		moveq	#MaxLoadBuffers-MinLoadBuffers-1,d0
initreadybuffers2$					;
		clr	LB_Number(a0)			;
		sf	LB_LastBuffer(a0)		;
		move.l	a0,(a1)+			;alle Puffer knnen voll Daten geladen werden
		add.l	#LB_Sizeof,a0			;
		dbf	d0,initreadybuffers2$		;
		bra	buf2$				;
nobuf2$							;
		moveq	#MaxLoadBuffers-MinLoadBuffers-1,d0
clrreadybuffers2$					;
		clr.l	(a1)+				;
		dbf	d0,clrreadybuffers2$		;
buf2$
		move.l	#-1,AIFF_DummyBuf(a4)		;siehe in Datenarea
		
		moveq	#MaxLoadBuffers*2-1,d0		;kein Puffer ist `ready to play`
		lea	AIFF_LoadedBufList(A4),a2	;
initloadedbuffer$					;
		clr.l	(a2)+				;
		dbf	d0,initloadedbuffer$		;

		clr.l	AIFFR_CurrentBuf(a4)

		move.l	#-1,AIFFP_SignalQuit(a4)	;Initialwerte fr den LadeProze
		move.l	#-1,AIFFP_SignalLoad(a4)	;
		clr.l	AIFFP_Fail(A4)			;
		sf	AIFFP_Ready(A4)			;
		sf	AIFFP_NoLoad(A4)		;
		sf	AIFFP_ReadyToPlay(A4)		;

		sf	AIFFR_NoPlay(A4)		;<- fr Replay
		
		lea	mytags(A4),a0			;LadeProze starten
		move.l	a0,d1				;
		move.l	#NP_Entry,(a0)+			;
		move.l	#Process,(a0)+			;
		move.l	#NP_Name,(A0)+			;
		move.l	#PR_Name,(A0)+			;
		move.l	#NP_Priority,(a0)+		;
		move.l	#5,(a0)+			;
		clr.l	(a0)				;
		move.l	Dosbase(a4),a6			;
		jsr	_LVOCreateNewProc(a6)		;
		move.l	d0,AIFFP_Address(a4)		;
		beq.s	fail$				;

		moveq	#0,d0				;Auf Meldung vom Proze warten
		move.l	AIFFP_SignalReturn(a4),d3	;
		bset	d3,d0				;
		move.l	myExecbase(A4),a6		;
		jsr	_LVOWait(A6)			;

		tst.l	AIFFP_Fail(A4)			;Prozefehler ?
		bne	fail$				;

		tst.b	AIFFP_Ready(a4)			;Proze hat sich -warum auch immer-
		beq	EndSound			;selbst beendet ?

		move.l	AIFFP_Address(A4),a1		;alle Puffer mit Stuff fllen lassen
		move.l	AIFFP_SignalLoad(A4),d1		;
		moveq	#0,d0				;
		bset	d1,d0				;
		move.l	myExecbase(A4),a6		;
		jsr	_LVOsignal(a6)			;wir wollen Daten !!

		moveq	#0,d0				;Auf Meldung vom Proze warten, dann kann`s
		move.l	AIFFP_SignalReturn(a4),d3	;mit dem Abspielen losgehen
		bset	d3,d0				;
		move.l	myExecbase(A4),a6		;
		jsr	_LVOWait(A6)			;
							;
wart$							;nun noch warten, bis die Puffer alle
		tst.b	AIFFP_ReadyToPlay(A4)		;voll sind (wegen mglichem LoadBefore)
		bne.s	fertig$				;
		move.l	Dosbase(a4),a6			;
		moveq	#5,d1				;
		jsr	_LVODelay(a6)			;

		tst.b	AIFFP_Ready(a4)			;Proze hat sich aufgrund eines Dateifehlers
		beq	EndSound			;selbst beendet ?
		bra	wart$				;
fertig$
		moveq	#0,d0
		rts
fail$
fail2$
		moveq	#-1,d0
		rts
EndSound:
		lea	Datas,a4

		lea	PlaybufL(A4),a0			;Datenmll raus aus den Abspielpuffern
		move.w	#[Playbufend-PlaybufL]/4-1,d0	;
.clr		clr.l	(a0)+				;
		dbf	d0,.clr				;

		move.l	AIFFP_SignalReturn(a4),d0	;Signal freigeben
		bmi	nosig$				;
		move.l	myExecbase(A4),a6		;
		jsr	_LVOfreesignal(a6)		;
nosig$		move.l	#-1,AIFFP_SignalReturn(a4)	;

		lea	PR_Name(pc),a1			;Nachsehen, ob der LadeTask noch da ist
		move.l	myExecbase(A4),a6		;
		jsr	_LVOFindtask(a6)		;
		tst.l	d0				;
		beq	ende$				;
		move.l	d0,a1				;
		
		move.l	AIFFP_SignalQuit(A4),d1		;LadeTask mit freundlichem Nachdruck beenden
		moveq	#0,d0				;
		bset	d1,d0				;
		move.l	myExecbase(A4),a6		;
		jsr	_LVOsignal(a6)			;

loopwait$
		move.l	Dosbase(a4),a6			;kurz warten
		moveq	#1,d1				;
		jsr	_LVODelay(a6)			;

		lea	PR_Name(pc),a1			;Nachsehen, ob der LadeTask noch da ist
		move.l	myExecbase(A4),a6		;
		jsr	_LVOFindtask(a6)		;
		tst.l	d0				;
		beq	ende$				;

		bra	loopwait$			;und nachschauen, ob die Aufforderung
							;erfolgreich war
ende$
		moveq	#-1,d0				;-1, falls hier von Initsound aufgrund eines
							;Fehlers herverzweigt wurde
		rts
UnlockFile:
		push	all
		lea	Datas,a4
		move.l	Dosbase(A4),a6

		move.l	PR_Filelock(a4),d1
		beq	fail1$
		jsr	_LVOunlock(A6)
fail1$
		move.l	TMP_Filelock(a4),d1
		beq	fail$
		jsr	_LVOunlock(A6)
fail$
		clr.l	PR_Filelock(A4)
		clr.l	TMP_Filelock(A4)
		pop	all
		rts
*****************************************************************************************
*          Proze, der die Daten auf Kommando asynchron zum Abspielen liest             *
*****************************************************************************************
;Rules:
;1. nach dem Start dieses Prozesses wird auf jeden Fall ein Signal an den Parent Task
;   geschickt, falls AIFFP_Fail dabei != 0 ist, wurde der Proze bereits aufgrund eines
;   Fehlers beendet
;2. jedes Signal vom Parent wird erwidert, sobald es bernommen wurde, es sei denn,
;   der Parent-Task lscht die `AIFFP_SignalReturn` Speicherzelle mit -1
;3. sollte AIFFP_Ready = 0 sein, wurde der Proze beendet und darf naturgem nicht
;   mehr vom Parent angesprochen werden
;4. die Sicherheit der Datenbernahme wird dadurch gewhrleistet, da nur shared
;   Memory Areas beschrieben werden, die 0 sind und an denen nur einer der beiden
;   (Int oder Prozess) ein Interesse haben
;5. nach dem Setzen des `AIFFP_NoLoad`-Flags gibt der Lade-Proze die gesamte Kontrolle
;   ber die Pufferlisten ab, die dann komplett von der Abspielroutine verwaltet werden,
;   der Lade-Proze hat dann dort nichts mehr zu suchen
;
;mgliche Fehlercodes in AIFFP_Fail:
;0 - kein Fehler :-)
;1 - konnte Signal nicht bekommen (sehr unwahrscheinlicher Fehler)
;2 - Dateifehler beim Duplizieren des Locks, dem Dateiffnen vom Lock aus oder
;    beim Dateilesen
;
Process:
		lea	Datas,a4

		moveq	#0,d7			;Filehandle in D7 permanent gehalten
;---------------------------- Init: Signale allozieren ----------------------------------
		moveq	#-1,d0
		move.l	myExecbase(A4),a6
		jsr	_LVOallocsignal(a6)	;Signal allozieren
		move.l	d0,AIFFP_SignalQuit(a4)
		blt	PR_Fail1

		moveq	#-1,d0
		move.l	myExecbase(A4),a6
		jsr	_LVOallocsignal(a6)	;2. Signal allozieren (fr Interrupt)
		move.l	d0,AIFFP_SignalLoad(a4)
		blt	PR_Fail1

;---------------- Init: File ffnen und Seek auf richtige Position ----------------------

		move.l	PR_Filelock(a4),d1
		beq	PR_Fail2
		move.l	Dosbase(A4),a6
		jsr	_LVODuplock(A6)
		move.l	d0,d1
		beq	PR_Fail2
		move.l	d1,d6
		move.l	Dosbase(A4),a6
		jsr	_LVOopenfromlock(A6)
		move.l	d0,d7
		bne.s	weiter$

		move.l	d6,d1
		jsr	_LVOUnlock(A6)
		bra	PR_Fail2
weiter$	
		move.l	d7,d1
		move.l	AIFF_BodyOffset(a4),d2	;Offset fr die Rohdaten
		moveq	#Offset_Beginning,d3	;Modus: von Dateistart aus
		jsr	_LVOSeek(A6)		;
		clr.l	PR_Bytesread(a4)	;0 Bytes bisher gelesen (fr Restart-Check)

		clr.w	AIFFP_CurrentNumber(A4)	;aktuelle Nummer des Puffers
		st	AIFFP_Ready(A4)		;`hallo ! wir sind da`

		bsr	PR_SendSignal		;Signal: wir sind da
		bne	PR_ret			;huch! Antwort unmglich -> Proze beenden
;---------------------------------- Warteschleife -----------------------------------------
PR_WaitLoop
		moveq	#0,d0
		move.l	AIFFP_SignalQuit(a4),d3	;Quit-Kommando
		bset	d3,d0
		move.l	AIFFP_SignalLoad(a4),d4	;Lade-Kommando
		bset	d4,d0

		move.l	myExecbase(A4),a6
		jsr	_LVOWait(A6)

		btst	d3,d0		;Quit-Kommando austesten (htte auch SIGF_Break sein knnen, aber was solls)
		bne	PR_ret		;<- beim Verlassen des Prozesses wird das Signal quittiert

		bsr	PR_SendSignal	;Kommando erwidern
		bne	PR_ret			;huch! Antwort unmglich -> Proze beenden

	;------------- hier nun Datei in einen der Puffer laden --------------------------
loadnext$
		tst.b	AIFFP_NoLoad(A4)	;nix mehr laden ?
		bne.s	PR_WaitLoop		;ok, weiterwarten, bis Proze beendet wird

		lea	AIFF_ReadyBufList(a4),a1
		moveq	#MaxLoadBuffers-1,d0
searchempty$
		move.l	(a1)+,d1
		bne.s	foundempty$
searchnextempty$
		dbf	d0,searchempty$

		st	AIFFP_ReadyToPlay(a4)	;alle Puffer voll, Abspielen kann beginnen
		
		bra	PR_WaitLoop		;keinen leeren gefunden -> also sind alle Puffer
						;voll und einer beim Abspielen und wir knnen
						;"weiterpennen"
foundempty$
		move.l	d1,a0

		tst.b	AIFFR_LoadOnce(a4)	;mssen wir darauf achten, da der Puffer 
		beq.s	takeit$			;erhalten bleibt ?

		tst.w	LB_Number(A0)		;Nummer des Puffers testen
		bne	searchnextempty$	;-> nicht leer, anderen Suchen
takeit$
		clr.l	-4(a1)			;aus Readyliste rausnehmen

		clr.l	LB_Playoffset(a0)			;Offset rcksetzen
		sf	LB_LastBuffer(a0)			;Flag fr Songende lschen 
		move	AIFFP_CurrentNumber(A4),LB_Number(a0)	;Nummer des Puffers
		addq.w	#1,AIFFP_CurrentNumber(A4)		;Nummer fr nchsten Puffer erhhen
		
		push	a0
		lea	LB_Datas(a0),a1		;Versuch, 32 kB an Daten
		move.l	a1,d2			;zu lesen
		move.l	d7,d1			;
		move.l	#loadbuffersize,d3	;
		move.l	Dosbase(A4),a6		;
		jsr	_LVORead(A6)		;
		pop	a0
		move.l	d0,LB_LoadSize(a0)	;wieviel wurde wirklich geladen ?
		bmi	PR_Fail2		;nix-> Fehler und raus aus dem Programm

		add.l	d0,PR_Bytesread(A4)	;Anzahl der gelesenen Bytes updaten

		move.l	PR_Bytesread(A4),d0	;
		cmp.l	AIFF_BodySize(A4),d0	;alle Bytes gelesen ?
		blt.s	ok$

		push	a0			;
		move.l	d7,d1			;Filezeiger auf Start setzen
		move.l	AIFF_BodyOffset(a4),d2	;
		moveq	#Offset_Beginning,d3	;
		move.l	Dosbase(A4),a6		;
		jsr	_LVOSeek(A6)		;
		clr.l	PR_Bytesread(A4)	;
		pop	a0			;

		st	LB_LastBuffer(a0)	;ok, also ist der aktuelle auch der letzte Puffer,
						;der gelesen wird
		st	AIFFP_ReadyToPlay(a4)	;alle Puffer voll, Abspielen kann beginnen

		tst.b	AIFFR_LoadOnce(A4)	;Datei nur einmal komplett lesen ?
		beq.s	ok1$			;
		st	AIFFP_NoLoad(A4)	;Ok, also nix mehr laden
		bra.s	ok$
ok1$
		clr.w	AIFFP_CurrentNumber(A4)	;aktuelle Nummer des Puffers rcksetzen
ok$

weiterwarten2$
		lea	AIFF_LoadedBufList+MaxLoadBuffers*4(A4),a1 ;letzter Puffer+1
		tst.l	-4(a1)			;letzte Position leer ? (sollte eigentlich sein)
		beq.s	onefound$		;einer ist also auf jeden Fall frei

		bsr	PR_Delay		;warten, bis letzte Position frei wird
		bne	PR_ret			;-> raus, `QUIT`-Signal erhalten

		bra	weiterwarten2$		;und wir warten geduldig auf den Playtask
						;(sehr unwahrscheinlich)
onefound$

eintragenloop$				;solange suchen, bis volle Position gefunden, sprich
		move.l	-(a1),d1	;den letzten freien Puffer spezifizieren
		beq	eintragenloop$	;die Routine sollte Deadlock- bzw. Crashsicher sein,
					;da im schlimmsten Falle pltzlich eine Position mehr 
					;frei sein kann, was aber vom AudioInt-Task abgefangen
					;wird und zu keinerlei Problemen fhren kann, auer
					;da, wenn`s dumm luft die `weiterwarten2$`-Routine
					;doch noch zum Tragen kommen kann und das ist auch nicht
					;problembehaftet

		move.l	a0,4(a1)	;in Liste einfgen

		bra	loadnext$	;versuchen, gleich noch einen Puffer voll zu laden,
					;sonst warten

;---------------------------------- Programmende ---------------------------------------------
PR_ret
		move.l	d7,d1
		move.l	Dosbase(A4),a6
		jsr	_LVOClose(A6)
		moveq	#0,d0
		sf	AIFFP_Ready(A4)

		bsr	PR_SendSignal
		rts
;------------------------------- Signalfehler ------------------------------------------------
PR_Fail1:
		moveq	#1,d0
		move.l	d0,AIFFP_Fail(A4)
		sf	AIFFP_Ready(A4)

		bsr	PR_SendSignal
		rts
;-------------------------------- Dateifehler ------------------------------------------------
PR_Fail2:
		move.l	d7,d1
		beq	nofile$
		move.l	Dosbase(A4),a6
		jsr	_LVOClose(A6)
nofile$
		moveq	#2,d0
		move.l	d0,AIFFP_Fail(A4)
		sf	AIFFP_Ready(A4)

		bsr	PR_SendSignal
		rts
;---------------------- sende Handshake-Signal an Master-Task -------------------------------
PR_SendSignal:
		push	d1-a6
		move.l	AIFFP_SignalReturn(A4),d1	;wir sind schon abgeschrieben ?
		bmi	failsignal$			;ok, also `QUIT` !
		moveq	#0,d0
		bset	d1,d0
		move.l	AIFFP_SigTask(A4),a1
		move.l	myExecbase(A4),a6
		jsr	_LVOsignal(a6)
		moveq	#0,d1
failsignal$	move.l	d1,d0
		pop	d1-a6
		tst.l	d0
		rts
;-- warte 1/50 Sekunde, weil kein Puffer frei war zum Lesen/Schreiben und teste auf Kill-Signal ----
;Input: -
;Output: d0 != 0 -> Programm beenden
PR_Delay:
		push	d1-a6

		move.l	Dosbase(A4),a6
		moveq	#1,d1
		jsr	_LVODelay(A6)

		moveq	#0,d0
		moveq	#0,d1
		move.l	myExecbase(A4),a6
		jsr	_LVOSetSignal(A6)

		moveq	#-1,d7
		move.l	AIFFP_SignalQuit(a4),d1
		btst	d1,d0
		bne	quit$

		moveq	#0,d7

quit$		move.l	d7,d0
		pop	d1-a6
		tst.l	d0
		rts

	endb	a4


PR_Name:	dc.b	`Eagleplayer AIFF Playtask`,0
	ifne	test
dos		dc.b	`dos.library`,0

filepath
;	dc.b	`modules:adpcm-aiff/dark.aiff`,0
	dc.b	`modules:adpcm-aiff/HS_Plastic_fantastic.aiff`,0

;	dc.b	`src:test1.aiff`,0

	endc

	even
AudioINT
	dc.l	0			;letzter Node
	dc.l	0			;nchster Node
	dc.b	2			;Node Type = Interrupt
	dc.b	1			;Prioritt
	dc.l	0			;Name
	dc.l	0			;Zeiger auf Daten
	dc.l	INT_Aud			;Interrupt Routine

	Section	1,bss_p
Datas:
Dosbase			ds.l	1
myExecBase		ds.l	1

;----------------------- Samplespezifische Daten --------------------------------
AIFF_Convert_to_8	ds.w	1	;16 Bit -> 8 Bit ?
AIFF_NumChannels	ds.w	1	;1 oder 2 Kanle
AIFF_numSampleFrames	ds.l	1	;Anzahl der SampleBlcke
AIFF_sampletype		ds.w	1	;8 bit = 0, 16 Bit = 1
AIFF_sampleRate		ds.l	1	;Samplerate in Bytes pro Sekunde
AIFF_BytesperFrame	ds.w	1	;Bytes pro Einheit
AIFF_BodySize		ds.l	1	;Lnge der Audiodaten in Bytes
AIFF_BodyOffset		ds.l	1	;Offset fr die Audiodaten in der Datei

AIFF_SamplePer		ds.l	1	;Period value (aus Samplerate berechnet)
AIFF_ReadPerInt		ds.w	1	;bei 16 Bit mu nur die Hlfte aus dem Puffer gelesen werden

;-------------------------- Player- und Ladetaskdaten ---------------------------

AIFF_LoadBuf:		ds.l	1	;Pufferadresse
AIFF_LoadBuf2:		ds.l	1	;Adresse optionaler Puffer 2

AIFFR_CurrentBuf	ds.l	1	;aktueller Puffer beim Abspielen

AIFF_DummyBuf		ds.l	1	;damit die Suchroutine des Prozesses richtig arbeitet, 
					;wird hier einfach ein Wert von -1 eingetragen
AIFF_LoadedBufList	ds.l	MaxLoadBuffers*2;Puffer, die komplett ins Ram geladen wurden
			;bergabe: von hinten an letzte freie Speicherzelle suchen und Daten dort reinlegen,
			;          wenn letzte Position belegt, warten und danach nochmal versuchen
			;bernahme: erste belegte Speicherzelle suchen, rauslesen und gesamten Block
			;           nach oben scrollen
			;
			;das *2 gilt nur fr das Upscrolling, nach der Anzahl von NumLoadBuffers
			;drfen keine Daten abgelegt werden, reine Speedup Storage

AIFF_ReadyBufList	ds.l	MaxLoadBuffers	;Puffer, die abgespielt wurden und nun wieder vollgepackt werden knnen,
				;bergabe: leere Speicherzelle suchen (min. eine ist immer frei) und Adr reinschreiben
				;bernahme: volle Speicherzelle suchen, auslesen und danach
				;           auf 0 rcksetzen

AIFFP_SignalLoad:	ds.l	1	;Signalbit: Lade nchsten Puffer
AIFFP_SignalQuit:	ds.l	1	;Signalbit: Beende Proze
AIFFP_SignalReturn:	ds.l	1	;Signalbit: Kommando erhalten
AIFFP_SigTask:		ds.l	1	;Task, der das Returnsignal erhlt
AIFFP_Fail:		ds.l	1	;Flag: Prozefehler
AIFFP_Address:		ds.l	1	;Adresse des Prozesses
AIFFP_Ready:		ds.b	1	;Proze ist bereit
AIFFP_NoLoad:		ds.b	1	;alles wurde genau einmal eingeladen und ist komplett im
AIFFP_CurrentNumber:	ds.w	1	;aktuelle Nummer des Puffers

AIFFR_CountBufferchg:	ds.b	1	;Zhler: alle x abgespielten Puffer werden welche neu geladen
AIFFR_NumCountBuffer:	ds.b	1	;Anzahl: alle x abgespielten Puffer werden welche neu geladen
AIFFR_LoadOnce:		ds.b	1	;Kram nur einmal laden, da alles in den Puffer pat
AIFFR_NoPlay:		ds.b	1	;Totaler Fehler beim Listensortieren, Replay anhalten
AIFFR_WaitPlay:		ds.b	1	;kurz beim Start warten um Doppelabspielen zu vermeiden
AIFFP_ReadyToPlay:	ds.b	1	;alle Puffer voll, Abspielen kann beginnen
				
;---------- Werte, die bereits in der Checkroutine herausgesucht werden, ------------------------
;-------- wg. Mglichkeit des Doublebufferings der Samples durch den EP zwischengespeichert -----
TMP_numChannels		ds.w	1
TMP_sampletype		ds.w	1
TMP_BytesperFrame	ds.w	1
TMP_numSampleFrames	ds.l	1
TMP_sampleRate		ds.l	1
TMP_BodyOffset		ds.l	1
TMP_BodySize		ds.l	1
TMP_FileSize		ds.l	1	;Gre des FORM Files von Offset 4 gelesen
TMP_LoadBuffer		ds.b	$100

TMP_Filelock		ds.l	1	;fr RAW-Abspieler zum Check der Dateilnge
PR_Filelock		ds.l	1	;Lock fr zu ladendes File, wird vom Proze dupliziert
PR_Bytesread		ds.l	1	;Anzahl der vom Proze gelesenen Bytes

PlaybufNext		ds.l	1			;welcher Abspielpuffer gerade benutzt wird
PlaybufL		ds.b	Playbuffersize*2	;Puffer  fr Daten links (double buffered)
PlaybufR		ds.b	Playbuffersize*2	;Puffer  fr Daten rechts (double buffered)
Playbufend		ds.b	0
			ds.b	100

mytags:			ds.l	10*2

audstruct0		ds.b	as_sizeof*4	;*4 nur zur Sicherheit, man weiss ja nie bei Betas

DataSize = *-Datas

	ifne	test

		section	2,data
testname	;dc.b	"Modules:ADPCM-IFF-MPEG-Wave/AIFF.Dark",0
		dc.b	"Storage:Sample.aiff",0
		;dc.b	"Modules:ADPCM-IFF-MPEG-Wave/AIFF.Brother",0
		;dc.b	"Modules:ADPCM-IFF-MPEG-Wave/AIFF.HS_Plastic_Fantastic",0



		even
testsample
		*incdir	"Modules:ADPCM-IFF-MPEG-Wave/"
		*incbin	"AIFF.Dark",30000
		incdir	"Storage:"
		incbin	"Sample.aiff",30000

;		incdir	src:
;		incbin	test1.aiff
;		incdir	modules:adpcm-aiff/
;		incbin	dark.aiff,30000
;		incbin	brother.aiff,30000
;		incbin	distain.aiff,30000
;		incbin	HS_Plastic_fantastic.aiff,30000
testsize = *-testsample

testloadbuff	ds.b	LB_Sizeof*MinLoadBuffers
	endc
