*************************************************************************************
*           MPEG Audio decoder routines utilizing mpega.library                     *
*                        (C) Henryk Richter                                         *
*************************************************************************************
;TODO:
; - ID3v2.4 support (unicode UTF-8, UTF-16), V2.4 is tolerated in the prelimiary check to enable playback at least
; - proper Genre parsing, including strings for predefined genre codes
;
;Signale:
; CTRL_C fr Beenden des Playtasks
; OpenFile
; CloseFile
; Start
; Stop
; Seek
;

;14.4. Check verbessert, Player luft nun auch mit mp3`s, die einen Text davor stehen
;haben
;9.5. Delay in Signalisierung des LadeTasks
;5.6. -Versuch, Pitch up/down Synchronisationsproblem zu beheben
;     -Signalprioritten neu sortiert, Versuch Crash-Probleme zu beheben
;16.6. -GetPositon umgebaut, verwendet jetzt eigene Routinen (PPC proof)
;21.6. -begonnen, Asyncio Untersttzung zu verwenden
;22.6. -Asyncio luft und bringt ne Menge Speed
;      -16->8 Bit Umrechnung schneller in DecodeFrame Routine
;22.6. -Crash bei Bifat, Sicherungen hinzugefgt
;29.6. -MI_Bitrate untersttzt
;4.7.  -Mungwall hits -> Memsize increased
;7.7.  -Mungwall hits -> mgliche Ursache nicht zurckgesetzter aktueller Ladepuffer, fixed
;9.7.  -Probleme bei 16 zu 8 Bit Konvertierung gelst (size=0 wurde nicht mehr abgefangen)
;9.7.16 - direct support for ID3v2 in the check routine, bypass ID3v2 tag in initialization (but only with asyncio.library)
;       - initial ID3v2 parsing, some tags need revision before release (like genre)
;10.7.16- simple genre parsing code
;22.11.16- preliminary UTF-16 parsing
ver		macro
		dc.b	"0.77"
		endm
PVersion	macro
		dc.w	0
		dc.w	77
		endm
date	macro
;	dc.b	"13.08.99"
	dc.b	"22.11.16"
	endm
;---------------------------- Optionen --------------------------------------------
Eagleplayer	EQU	1
test		EQU	0	;topaz nehmen bzw. tester fr Replay ?
SetMenus	=	0	;Mens einbinden ? (hier keine Mens definiert!!)
Timestep	EQU	5	;Steps in Sekunden fr FastForward/Rewind
PrefsVersion	EQU	1	;min. Version des Prefsfiles
useAsyncIO	EQU	1	;asyncio.library verwenden, wenn verfgbar
	;
	;
	incdir	include:
	include	libraries/mpega_lib.i
	include	libraries/mpega.i
	include	exec/execbase.i
	include	exec/types.i
	include	exec/tasks.i
	include	exec/memory.i
	include	exec/exec_lib.i
	include	exec/libraries.i
	include	exec/interrupts.i
	include	misc/BuggsMacros.i
	include	dos/dos_lib.i
	include	dos/dostags.i
	include	dos/dos.i
	include	"misc/EaglePlayer.i"
	include	"misc/EaglePlayerengine.i"
	include	libraries/gadtools.i
	include	libraries/gadtools_lib.i
 	include	intuition/intuition.i
	include	intuition/intuition_LIB.i
	include	graphics/graphics_lib.i

	include	libraries/asyncio_lib.i
	include	libraries/asyncio.i

Playbuffersize	=	MPEGA_PCM_SIZE*4	;Abspielpuffersize in Bytes

mplib_Buffersize = 16384

Async_Buffersize = 131072			;128 k Default

loadbuffersize	= MPEGA_PCM_SIZE*MPEGA_MAX_CHANNELS*2*4
NumBuffers	= 78				;max. ~8s Puffer
MinBuffers	= 10				;~1 s Minimum

 structure	LoadBuffer,0
 	WORD	LB_Number		;Nummer des Puffers, beginnend mit 0, wird fr den
 					;Fall bentigt, da das gesamte File beim Start
 					;eingeladen wird
	BYTE	LB_LastBuffer		;dies ist der letzte Puffer, durch Ladetask gesetzt (!=0)
	BYTE	LB_Pad			;align auf Longwortgre
	LONG	LB_Playoffset		;aktuelle Position beim Lesen, wird durch Laderoutine
					;auf 0 rckgesetzt
 	LONG	LB_LoadSize		;Anzahl der geladenen Bytes
 	STRUCT	LB_Datas,loadbuffersize	;Daten
	LABEL	LB_Sizeof

mpFLag_NoWait	equ	1		;Flag: Warten auf Antwort (alle Signale werden quittiert)

;/* ID3v2 header */
 structure ID3v2,0
 	STRUCT	ID32_Tag,3	;"ID3"
 	BYTE	ID32_Version	;0-4
 	BYTE	ID32_Revision	;0-fe
 	BYTE	ID32_Flags	;
 	LONG	ID32_Size	;
 	LABEL	ID32_HeaderLen

;/* header flags */
ID3F_Unsynchronization	equ	$80
ID3F_ExtendedHeader	equ	$40
ID3F_Experimental	equ	$20

ID3v2_Version		equ	4	;/* this one includes unicode which I don't support yet */
					;/* but at least allows proper detection of MP3 content */

;/* ID3v2 frame (much like IFF) */
  structure ID3v2frm,0
  	STRUCT  ID32frm_4cc,4
  	LONG	ID32frm_len
  	WORD	ID32frm_flags
  	LABEL	ID32frm_HeaderLen


;---------------------------------------------------------------------------------------------
DrawBevelBoxA EQU	_LVODrawBevelBoxA
_SysBase	EQU	4
CopyMem		EQU	_LVOCopyMem
IntuiTextLength	EQU	_LVOIntuiTextLength

MaxTagLen	EQU	127	;max. length for ID3v2 tags (needs to be impair because of +1 in ds.b)

Project0Width = 310		;Windowbreite (default bei Topaz 8)
Project0Height = 197
Project0Left = 41
Project0Top = 45
ZoomWidth = 200

GD_LIM_Quality                         EQU    0
GD_L1M_FMax                            EQU    1
GD_L3M_Quality                         EQU    2
GD_L3M_FMax                            EQU    3
GD_L1S_Quality                         EQU    4
GD_L1S_FMax                            EQU    5
GD_L1S_Mono                            EQU    6
GD_L3S_Quality                         EQU    7
GD_L3S_FMax                            EQU    8
GD_L3S_Mono                            EQU    9
GD_Save                                EQU    10
GD_Use                                 EQU    11
GD_Cancel                              EQU    12
GD_BufferTime                          EQU    13
GD_Priority                            EQU    14

Project0_CNT    EQU    15

;---------------------------------------------------------------------------------------------
		basereg	datas,a4

	ifeq	Eagleplayer
Start:
		lea	datas,a4
		bsr	InitProgram
;		bsr	InitPrefs
		bsr	LoadConfig
		bsr	mp_check
;		bsr	Configurate
		bsr	InitDecodingtask

		bsr	InitPlay
		bsr	InitSound

;		bsr	StartPlay
;		bsr	StopPlay

		ifne	test
loa
		bsr	DecodeFrame
		bsr	Int_Aud
;		btst	#6,$bfe001
;		bne	loa
		endc
endptr:
		bsr	EndSound
		bsr	EndPlay
		bsr	End
	ifne	test
		illegal
	else
		rts	
	endc
	else
		section	0,code
	endc


		PLAYERHEADER PlayerTags

		dc.b '$VER: MPEG Audio Eagleplayer V'
		ver
		dc.b	'('
		date
		dc.b	`)`,0
		even

PlayerTags
		dc.l	EP_AttnFlags,AFF_68020
		dc.l	EP_PlayerVersion,12		;Eagleversion
		dc.l	EP_Flags,EPB_Prevpatt!EPB_Nextpatt!EPB_CalcDuration!EPB_Moduleinfo!EPB_VolVoices!EPB_Restart!EPB_Songend!EPB_Volume!EPB_Balance!EPB_Voices!EPB_Analyzer
		dc.l	DTP_PlayerVersion
		PVersion
		dc.l	DTP_PlayerName,MI_Name
		dc.l	DTP_Creator,MI_Buggs

		dc.l	DTP_Check1,mp_Check

		dc.l	DTP_config,Initreplayer
		dc.l	DTP_UserConfig,Configurate
		dc.l	EP_EjectPlayer,End

		dc.l	DTP_InitPlayer,Initplay
		dc.l	DTP_EndPlayer,EndPlay

		dc.l	EP_GetPositionNr,GetPosNr
		dc.l	DTP_NextPatt,FastForward
		dc.l	DTP_PrevPatt,FastRewind
;		dc.l	EP_SetPosition,SetPosition

		dc.l	DTP_InitSound,InitSound
		dc.l	DTP_EndSound,EndSound

		dc.l	DTP_Startint,StartPlay

		dc.l	DTP_Volume,SetVoices
		dc.l	DTP_Balance,SetVoices
		dc.l	EP_Voices,SetVoices

		dc.l	EP_SetSpeed,Speedit

		dc.l	EP_NewModuleInfo,MI_InfoBuffer

		dc.l	EP_InitAmplifier,InitAudstruct

;		dc.l	EP_SetPlayFrequency,SetRAWSpeed

		dc.l	EP_Eaglebase,EPBase
		dc.l	0

MI_Name		dc.b	`MPEG Audio`,0
MI_Buggs	dc.b	`uses mpega.library by Stephane Tavenard, player written by Buggs of Defect`,0

MI_myPlaymode	dc.b	`Player currently runs in `
MI_Playmodeadd	dc.b	0,0,0,0,0,0,0
MI_8Bit		dc.b	`8 Bit`,0
MI_16Bit	dc.b	`16 Bit`,0

MI_myExtraStuff	dc.b	`MPEG `
MpegNorm:	dc.b	`  ,Layer `
MpegLayer:	dc.b	`  ,Bitrate `
MpegRate:	dc.b	`    kBps, `
MpegMode:	dc.b	`             `,0

Mode_Stereo	dc.b	`Stereo`,0
Mode_Mono	dc.b	`Mono`,0
Mode_Dual	dc.b	`Dual Channel`,0
Mode_Joint	dc.b	`Joint Stereo`,0

	even
MI_InfoBuffer:	
	dc.l	MI_Samples,1			;4
	dc.l	MI_Duration,0			;12
	dc.l	MI_Playfrequency,0		;20
	dc.l	MI_LoadSize,0			;28
	dc.l	MI_Extrainfo,MI_myPlaymode	;36
	dc.l	MI_Specialinfo,MI_myExtraStuff	;44
	dc.l	MI_Voices,0			;52
	dc.l	MI_Length,0			;60
Songnamepos:
	dc.l	MI_SongName,Tag_Title		;68
Authorpos:
	dc.l	MI_AuthorName,Tag_Author	;76
Albumpos:
	dc.l	MI_AlbumName,Tag_Album		;84
Yearpos:
	dc.l	MI_Year,Tag_Year		;92
Commentpos:
	dc.l	MI_Comment,Tag_Comment		;100
GenrePos:
	dc.l	MI_Genre,Tag_Genre		;108
Bitrate:
	dc.l	MI_Bitrate,0			;116
	dc.l	0

EPBase		dc.l	0

CustomAccessHook:
	dcb.b	mln_size,0
	dc.l	CustomAccessFunc
	dc.l	0
	dc.l	0

	ds.l	10
;----------------------------------------------------------------------------------------------------
;Hook for Access to Bitstream via Asyncio.library
;
;static ULONG __saveds __asm def_baccess( register __a0 struct Hook  *hook,
;                                         register __a2 APTR          handle,
;                                         register __a1 MPEGA_ACCESS *access ) {
;
;	structure	MPEGA_ACCESS,0
;	LONG		MPA_func		* MPEGA_BSFUNC_xxx *
;	LABEL		MPA_sizeof
;
;	structure	MPEGA_ACCESSOPEN,MPEGA_ACCESS
;	APTR		MPAO_stream_name 	* in
;	LONG		MPAO_buffer_size	* in
;	LONG		MPAO_stream_size	* out
;	LABEL		MPAO_sizeof
;
;	structure	MPEGA_ACCESSREAD,MPEGA_ACCESS
;	APTR		MPAR_buffer		* in/out
;	LONG		MPAR_num_bytes		* in
;	LABEL		MPAR_sizeof
;
;	structure	MPEGA_ACCESSSEEK,MPEGA_ACCESS
;	APTR		MPAS_abs_byte_seek_pos	* out
;	LABEL		MPAS_sizeof
;
CustomAccessFunc:
	push	d1-a6
	lea	Datas,a4

	move.l	a1,a5

	move.l	asynciobase(a4),d0		;async not found -> error (shouldn`t happen)
	beq	retaccess$

	move.l	MPA_func(a5),d0

	cmp.l	#MPEGA_BSFUNC_READ,d0
	bne	noread$

	move.l	a2,d0				;ho handle -> send eof
	beq	retaccess$

	move.l	MPAR_num_bytes(a5),d0		;requested Bytes
	move.l	MPAR_buffer(a5),a1		;dest Buffer
	move.l	a2,a0
	move.l	asynciobase(a4),a6		;Library base
	jsr	_LVOReadAsync(a6)
						;return # of bytes read
	bra	retaccess$
noread$
	cmp.l	#MPEGA_BSFUNC_SEEK,d0
	bne	noseek$

	move.l	a2,d0
	beq	retaccess$

	move.l	#MODE_START,d1
	move.l	MPAS_abs_byte_seek_pos(a5),d0
	bpl.s	hi$
	moveq	#0,d0				;not < 0 !
hi$
	add.l	ID3v2headersize,d0		;seek beyond ID3v2 header, if present -> fixes init problem with large ID3 headers
	move.l	a2,a0
	move.l	asynciobase(a4),a6		;Library base
	jsr	_LVOSeekAsync(a6)

		moveq	#0,d0
		bra	retaccess$
noseek$
		cmp.l	#MPEGA_BSFUNC_OPEN,d0
		bne.s	noopen$

		clr.l	MPAO_stream_size(a5)

		move.l	dosbase(a4),a6
		move.l	MPAO_stream_name(a5),d1
		moveq	#-2,d2
		jsr	_LVOLock(a6)
		move.l	d0,d7
		beq.s	nolock$
		move.l	d7,d1
		lea	mp_fib(a4),a3
		move.l	a3,d2
		addq.l	#3,d2			;align to 4 !
		and.l	#~3,d2			;
		move.l	d2,a3
		jsr	_LVOExamine(A6)
		move.l	fib_size(a3),MPAO_stream_size(a5)
		move.l	d7,d1
		jsr	_LVOUnlock(A6)
nolock$
		move.l	MPAO_stream_name(a5),A0
		moveq	#MODE_READ,d0
		move.l	#Async_Buffersize,d1
		move.l	asynciobase(a4),a6		;Library base
		move.l	myExecbase(a4),a1		;Exec base
		move.l	dosbase(a4),a2			;dos base
		jsr	_LVOOpenAsync(A6)

		move.l	d0,a2
		move.l	#MODE_START,d1
		move.l	ID3v2headersize,d0		;seek beyond ID3v2 header, if present -> fixes init problem with large ID3 headers
		move.l	a2,a0
		move.l	asynciobase(a4),a6		;Library base
		jsr	_LVOSeekAsync(a6)
		move.l	a2,d0
		bra	retaccess$			;return handle in d0
noopen$:
		cmp.l	#MPEGA_BSFUNC_CLOSE,d0
		bne	noclose$

		move.l	a2,d0				;no handle -> out here
		beq	retaccess$
		move.l	d0,a0

		move.l	asynciobase(a4),a6		;Library base
		jsr	_LVOCloseAsync(A6)

		moveq	#0,d0				;return 0
		bra	retaccess$
noclose$

retaccess$:
		pop	d1-a6
		tst.l	d0
		rts
;----------------------------------------------------------------------------------------------------
Speedit:
	lea	$dff0b0,a5
	move.l	mp_SamplePer,d0
	bsr	PokePer
	lea	-$10(a5),a5
	bsr	PokePer
	rts
;----------------------------------------------------------------------------------------------------
GetPosNr:
		lea	datas,a4
		move.l	mpegabase(a4),d0
		beq	nomp$
		move.l	d0,a6

		move.l	mpegstream(a4),d0
		beq	nomp$

;		move.l	d0,a0
;		lea	mytags(a4),a1		;ULONG* ms_time_position
;		jsr	_LVOMPEGA_time(a6)
;		tst.l	d0
;		bne	nomp$
;		move.l	mytags(a4),d0

		move.l	mp_Time(a4),d0
		divu.l	#1000*Timestep,d0
		rts
nomp$
		moveq	#0,d0
		rts
;----------------------------------------------------------------------------------------------------
FastForward:
		lea	datas,a4
		moveq	#-1,d0
		bsr	CallSeek
		rts
;----------------------------------------------------------------------------------------------------
FastRewind:
		lea	datas,a4
		moveq	#-2,d0
		bsr	CallSeek
		rts
;----------------------------------------------------------------------------------------------------
mp_Check:
		move.l	#0,ID3v2headersize		;def: no ID3v2 header
		bsr	mp_Checkold			;will change ID3v2 header size to >0, if present
		beq	mp_checkok$

		lea	datas,a4			;Daten-Array
		move.l	mpegabase(a4),d0
		beq	fail$
		move.l	d0,a6

		ifeq	Eagleplayer
			lea	testadr,a0
			move.l	#1024,d0
		else
			move.l	DTG_Chkdata(A5),a0
;			move.l	DTG_Chksize(A5),d0
			move.l	#1024,d0		;bis jetzt max. 1024 Bytes geladen
		endc
		jsr	_LVOMPEGA_find_sync(a6)		;1. Check-Sync gefunden ?
		cmp.l	#MPEGA_ERR_NO_SYNC,d0
		bne	weiter$

	ifne	Eagleplayer
		move.l	dtg_PathArrayPtr(a5),a0			;Filepfad zusammensetzen
		clr.b	(a0)					;
		move.l	dtg_CopyDir(a5),a0			;
		jsr	(a0)					;
		move.l	dtg_CopyFile(a5),a0			;
		jsr	(a0)					;
		move.l	dtg_PathArrayPtr(a5),a0			;kompletten Namen holen
	else
		lea	srcfile(pc),a0
	endc
		lea	filepatharray(a4),a1
copyname$	move.b	(a0)+,(a1)+
		bne	copyname$

		lea	filepatharray(A4),a1
		move.l	a1,d0

		lea	filepatharray(a4),a0
		move.l	a0,d1
		move.l	#MODE_OLDFILE,d2
		move.l	dosbase(a4),a6
		jsr	_LVOOpen(a6)
		move.l	d0,d7
		beq	fail$					;darf nicht vorkommen
	
		move.l	d7,d1
		move.l	#$1E20,d2
		moveq	#OFFSET_BEGINNING,d3
		jsr	_LVOSeek(a6)
		tst.l	d0
		bmi	close$					;sollte auch nicht passieren

		lea	Mpega_checkmem,a1
		move.l	a1,d2
		move.l	d7,d1
		move.l	#4600,d3
		jsr	_LVORead(a6)
		move.l	d7,d1
		jsr	_LVOClose(a6)

		lea	Mpega_checkmem,a0
		move.l	#4600,d0
		move.l	mpegabase(a4),a6
		jsr	_LVOMPEGA_find_sync(a6)		;1. Check-Sync gefunden ?
		cmp.l	#MPEGA_ERR_NO_SYNC,d0
		bne	weiter$
		bra	fail$
close$
		move.l	d7,d1
		move.l	dosbase(a4),a6
		jsr	_LVOClose(a6)
		bra	fail$
weiter$
							;wenn ja, 2. Check, lt sich
							;die Datei anstandslos dekodieren ?
	ifne	Eagleplayer
		move.l	dtg_PathArrayPtr(a5),a0			;Filepfad zusammensetzen
		clr.b	(a0)					;
		move.l	dtg_CopyDir(a5),a0			;
		jsr	(a0)					;
		move.l	dtg_CopyFile(a5),a0			;
		jsr	(a0)					;
		move.l	dtg_PathArrayPtr(a5),a0			;kompletten Namen holen
	else
		lea	srcfile(pc),a0
	endc
		lea	filepatharray(a4),a1
copyname1$	move.b	(a0)+,(a1)+
		bne	copyname1$

		lea	mpcontrol_check(a4),a1		;Ctrl-Struct clear
		lea	(a1),a0
		moveq	#MPC_sizeof-1,d0
clr$
		clr.b	(a0)+
		dbf	d0,clr$

		lea	MPC_layer_1_2(a1),a0		;copy settings for Layer 1/2
		move.w	#1,MPL_force_mono(a0)
		move	#4,MPO_freq_div+MPL_mono(a0)	;Freq_Div 4
		move	#0,MPO_quality+MPL_mono(a0)	;Low quality
		move.l	#0,MPO_freq_max+MPL_mono(a0)	

		move	#4,MPO_freq_div+MPL_stereo(a0)	;Freq_Div 1
		move	#0,MPO_quality+MPL_stereo(a0)	;Low Quality
		move.l	#0,MPO_freq_max+MPL_stereo(a0)	

		lea	MPC_layer_3(a1),a0		;copy settings for Layer 3
		move.w	#1,MPL_force_mono(a0)
		move	#4,MPO_freq_div+MPL_mono(a0)	;Freq_Div 4
		move	#0,MPO_quality+MPL_mono(a0)	;Low quality
		move.l	#0,MPO_freq_max+MPL_mono(a0)	

		move	#4,MPO_freq_div+MPL_stereo(a0)	;Freq_Div 1
		move	#0,MPO_quality+MPL_stereo(a0)	;Low Quality
		move.l	#0,MPO_freq_max+MPL_stereo(a0)	

		move.w	#0,MPC_check_mpeg(a1)
		move.l	#8192,MPC_stream_buffer_size(a1)
		clr.l	MPC_bs_access(a1)

		lea	filepatharray(a4),a0
		move.l	mpegabase(a4),a6
		jsr	_LVOMPEGA_open(a6)
		move.l	d0,d7
		beq	fail$

		move.l	#2*1000,d0
		move.l	d7,a0
		jsr	_LVOMPEGA_Seek(a6)	;2 Sekunden vorspulen

		moveq	#5,d6
loop$
		lea	Mpega_checkmem,a1	;Pointer auf 2 Pointer
		lea	8(a1),a0
		move.l	a0,(a1)
		move.l	a0,4(a1)

		move.l	d7,a0
		move.l	mpegabase(a4),a6
		jsr	_LVOMPEGA_decode_frame(a6)
		tst.l	d0
		bmi	fail2$

		dbf	d6,loop$

		move.l	d7,a0
		jsr	_LVOMPEGA_close(a6)
mp_checkok$
		moveq	#0,d0
		rts
fail2$
		move.l	d7,a0
		jsr	_LVOMPEGA_close(a6)
fail$
		moveq	#-1,d0
		rts
mp_Checkold:
		movem.l	d1-d5,-(sp)
		ifeq	Eagleplayer
			lea	testadr,a0
		else
			move.l	DTG_Chkdata(A5),a0
		endc

		; direct check for MP3 header (fails mostly these days, especially with ID3 tags)
		MOVE.L	(A0),D1
		MOVE.L	D1,D0
		AND.L	#$FFE00000,D0
		CMPI.L	#$FFE00000,D0
		BNE.B	.nomp3
		MOVE.L	D1,D0
		ANDI.L	#$60000,D0
		BEQ.B	.nomp3
		MOVE.L	D1,D0
		AND.L	#$F000,D0
		CMPI.L	#$F000,D0
		BEQ.B	.nomp3
		TST.L	D0
		BEQ.B	.nomp3
		ANDI.L	#$C00,D1
		CMPI.L	#$C000,D1
		BEQ.B	.nomp3
.yes_mp3:		
		movem.l	(sp)+,d1-d5
		MOVEQ	#0,D0
		rts
.mp3notfound:
		movem.l	(sp)+,d1-d5
		MOVEQ	#-1,D0
		rts
.nomp3:
		;don`t give up right now, try to identify ID3v2 header
		;-> if ID3v2 is detected, calculate length to address the first mp3 frame directly in the
		;   actual initialization phase
		; ID3 header:
		; 3 byte ID
		; 2 byte version (00 xx... 03 xx) (version, revision, never equal to $ff)
		; 1 byte flags
		; 4 byte size in DWORDS (calc *4 to get bytes)
;		move.l	DTG_Chkdata(A5),a0 ; redundant
		cmp.b	#`I`,ID32_Tag(a0)	;"ID3" header
		bne.s	.id3_noid3
		cmp.b	#`D`,ID32_Tag+1(a0)
		bne.s	.id3_noid3
		cmp.b	#`3`,ID32_Tag+2(a0)
		bne.s	.id3_noid3
		cmp.b	#ID3v2_Version,ID32_Version(a0)	;max. supported version is 3 for now but 4 is tolerated
		bhi.s	.id3_noid3
		cmp.b	#$ff,ID32_Revision(a0)	;revision should never be $ff
		beq.s	.id3_noid3
		moveq	#31,d0
		and.b	ID32_Flags(a0),d0	;flags, clear upper 3 bits (the defined ones)
		bne.w	.id3_noid3		;unknown flags, go out
		move.l	ID32_Size(a0),d0	;size, only 28 bits used, so check for wrong bit mask
		and.l	#$80808080,d0		;top bits must be zero in size spec
		bne.s	.id3_noid3		;bad size spec

		; ok, we are pretty sure to have a valid ID3v2 tag
		; 0x7f7f7f7f
		move.l	ID32_Size(a0),d0	;get size, then remove the 4 unused bits
		bsr	DIDv2_DecSize
	ifne	0
		moveq	#3,d2
		moveq	#0,d1
.dec_size
		moveq	#127,d3		;
		and	d0,d3		;LSB
		or.w	d3,d1		;insert 7 bits
		ror.l	#7,d1		;

		lsr.l	#8,d0		;2nd byte
		dbf	d2,.dec_size
		lsr.l	#4,d1				;(collected 28 bit, move down 4 bits)
	endc
		move.l	d0,d1
		moveq	#ID32_HeaderLen,d0
		add.l	d0,d1				;size excludes regular header (10 bytes)
		move.l	d1,ID3v2headersize		;def: no ID3v2 header
		
		bra.w	.yes_mp3
.id3_noid3	bra.w	.mp3notfound

;----------------------------------------------------------------------------------------------------
Initreplayer:
		lea	datas,a4
		bsr	InitProgram
		tst.l	d0
		bmi	fail$
;		bsr	InitPrefs
		bsr	LoadConfig
		bsr	InitDecodingtask
fail$
		rts
;----------------------------------------------------------------------------------------------------
InitAudstruct:
		bsr	InitStruct
		move.l	a0,EPG_Amplifiertaglist(a5)
		tst.l	d0
		rts
InitStruct:
		push	d1-d7/a1-a6
		lea	datas,a4

		lea	Audstruct0,a0		;Audio Struktur vorbereiten

		move.l	#EPAMB_AudioInts!EPAMB_Direct!EPAMB_8Bit,d7

		tst.b	mp_Convert_to_8(a4)
		bne.s	.8bit

		move.l	#EPAMB_AudioInts!EPAMB_Direct!EPAMB_16Bit,d7
.8bit
		move.l	d7,NPFlags

		lea	(a0),a1
		move.w	#as_sizeof*2-1,d0
.clr		clr.b	(a1)+
		dbf	d0,.clr

		move.w	#01,AS_Leftright(a0)			;1. Kanal links
		move.w	#-1,AS_Leftright+as_sizeof*1(a0)	;2. Kanal rechts

		move.l	#AudioINT,AS_Int(a0)

		lea	AudTagliste(pc),a0

		pop	d1-d7/a1-a6
		moveq	#0,d0
Setvoices:
myrts:		rts


AudTagliste
	dc.l	EPAMT_Numstructs,2
	dc.l	EPAMT_Audiostructs,Audstruct0
	dc.l	EPAMT_Flags
NPFlags
	dc.l	0
	dc.l    TAG_DONE,0

;-------------------------- Interruptroutine ----------------------------------------
INT_Aud:
		push	all
;		move	#$f0f,$dff180

		lea	datas,a4
		tst.b	mp_Started(a4)
		beq	fail$

		tst.b	mp_NoPlay(a4)
		bne	fatal$

		tst.b	mp_WaitPlay(a4)
		bne	not$
		move.b	#1,mp_WaitPlay(a4)

;		move	#$ff0,$dff180

;-------------------- Puffer holen -----------------------
		move.l	mpR_CurrentBuf(a4),d0
		bne.s	novol$
		
		; Lautstrke wiederherstellen nach "Hnger"
	ifeq	test
		move.l	EPBase,a5
		moveq	#64,d0
		moveq	#0,d1
		jsr	ENPP_PokeVol(a5)
		moveq	#1,d1
		jsr	ENPP_PokeVol(a5)
	endc

		moveq	#0,d0
novol$
		move.l	d0,a0
		bsr	newcurrentBuffer

		move.l	mpR_CurrentBuf(a4),d0
		beq.w	fail$

;---------------------------------------------------------

		move.l	d0,a0
		move.l	LB_LoadSize(a0),d2
		beq	novol$
		lsr.l	#1,d2			;Lnge in Bytes -> Lnge in Worten
		lea	LB_Datas(a0),a2

	ifeq	test
		move.l	EPBase,a5
		move.l	a2,d0
		moveq	#0,d1
		jsr	ENPP_PokeAdr(a5)
		move.l	d2,d0
		jsr	ENPP_PokeLen(a5)
;		move.l	mp_SamplePer,d0
;		jsr	ENPP_PokePer(a5)

		move.l	a2,d0
		cmp	#1,mp_NumChannels(a4)
		beq	samebuffer$
		add.l	#loadbuffersize/2,d0
samebuffer$
		moveq	#1,d1
		jsr	ENPP_PokeAdr(a5)
		move.l	d2,d0
		jsr	ENPP_PokeLen(a5)

		;----------------- Zeit berechnen, die dieses Stck Sample spielt -----------
		tst.b	mp_Convert_to_8(a4)
		beq.s	skip$
		lsl.l	#1,d2		;bei 8 Bit Gre mal 2 wg. 1 Byte pro Frame, bei 16 Bit Anzahl der Worte
skip$
		move.l	mp_SamplePer,d0	;
		mulu.l	#1000,d0	;mal 1000
		mulu.l	d2,d0		;Per * Size
		divu.l	#3579546,d0	;/Audiorate
		add.l	d0,mp_Time	;= Zeit in Millisekunden
 
;		move.l	mp_SamplePer,d0
;		jsr	ENPP_PokePer(a5)
	endc
not$
;------------------------------------------------------------------------------------
		subq.b	#1,mp_WaitPlay(A4)
		pop	all
		rts
fail$
		; "Muting" falls keine Daten zum Abspielen vorhanden
	ifeq	test
		move.l	EPBase,a5
		moveq	#0,d0
		moveq	#0,d1
		jsr	ENPP_PokeVol(a5)
		moveq	#1,d1
		jsr	ENPP_PokeVol(a5)
	endc
		pop	all
		rts
fatal$
	ifeq	test
;		moveq	#$3,d0
;		bsr	PokeDMA
	endc
		pop	all
		rts

;------------------------------------------------------------------------------------------
;- Input:  A0 - alter Puffer oder 0
;- Output: A0 - neuer Puffer oder 0 (selbiges gilt fr AIFFR_CurrentBuf)
;
NewCurrentBuffer:
		push	d0-d7/a1-a6

		move.l	mp_Delayedready1(a4),d1	;verzgerten Puffer holen
		move.l	a0,mp_Delayedready1(a4)	;Puffer verzgern
		move.l	mp_Delayedready2(a4),d0
		move.l	d1,mp_Delayedready2(a4)

		tst.l	d0
		beq.s	noold$
		move.l	d0,a0

		lea	mp_ReadyBufList(a4),a1
such$		tst.l	(a1)+			;einer ist garantiert frei, da genau der jetzige
		bne.s	such$			;Puffer in eine Liste soll, die fr alle ausreicht

		move.l	a0,-4(a1)		;und in Readyliste eintragen

;		tst.b	AIFFR_LoadOnce(a6)	;mssen wir darauf achten, da der Puffer erhalten
;		bne.s	keepNum$		;bleibt ?
		clr.w	LB_Number(a0)		;nein, Puffer freigeben
;keepNum$
		tst.b	LB_LastBuffer(a0)	;zuende gespielt ?
		beq.s	nosongend$

		move.l	EPBase(pc),a2		;Eagleplayer benachrichtigen, da das
		move.l	EPG_SomePrefs(a2),d0
		and.l	#EGPRB_Songend,d0
		beq	nosongend$
		jsr	ENPP_Songend(a2)	;Songende erreicht wurde
nosortlist$
nosongend$

noold$
		lea	mp_LoadedBufList(a4),a1 ;Liste der fertig geladenen Puffer
		move	#NumBuffers*2-1,d0	;
findfree$
		move.l	(a1)+,d1		;falls einmal aus Handshaking-Grnden ein Puffer
		bne	found$			;ausgelassen wurde, muss die gesamte Liste
		dbf	d0,findfree$		;durchsucht werden

		suba.l	a0,a0			;sorry, wir haben nix zum Fttern des Players
		clr.l	mpR_CurrentBuf(a4)	;kein aktueller Puffer

		bsr	signal_load$		;aber Hallo! Sofort Daten Laden, wird`s bald ?
		bra	fail$
found$
		move.l	d1,a0			;neuer Puffer

		lea	mp_LoadedBufList(a4),a2 ;alles bis nach oben durchscrollen
		move	#NumBuffers*2-1,d0
copylist$
		move.l	(a1)+,(a2)+
		dbf	d0,copylist$

		move.l	a0,mpR_CurrentBuf(a4)	;eintragen in Globals

;		move.b	AIFFR_CountBufferchg(A6),d0
;		addq.b	#1,d0
;		cmp.b	AIFFR_NumCountBuffer(A6),d0
;		blt	nosig$

		bsr	signal_load$		;Signal nur alle 2 mal schicken, das sollte reichen

;		moveq	#0,d0
;nosig$		move.b	d0,AIFFR_CountBufferchg(A6)

fail$
		pop	d0-d7/a1-a6
		rts

signal_load$
		push	all
		
		tst.b	mp_Ready(a4)		;ist der Lade-Task noch da ?
		beq	local_fail$		;

		move.l	mpP_Address(A4),a1	;ok, geben wir dem mal was zu tun
		move.l	mp_SignalLoad(a4),d1	;
		moveq	#0,d0			;
		bset	d1,d0			;
		move.l	myExecbase(a4),a6	;
		jsr	_LVOsignal(a6)		;
local_fail$
		pop	all
		rts
;--------------------------------------------------------------------------------------------------
StartPlay:
		lea	datas,a4

		moveq	#$3,d0
		bsr	PokeDMA

		lea	PlaybufL(A4),a0
		lea	(a0),a1
		lea	PlaybufR(a4),a2
		lea	(a2),a3
		move	#Playbuffersize*2/4-1,d0
.clr
		clr.l	(a1)+
		clr.l	(a3)+
		dbf	d0,.clr

		lea	$dff0a0,a5
		move.l	a0,D0
		bsr	PokeAdr
		move.l	#Playbuffersize/8,d0
		bsr	PokeLen
		move.l	mp_SamplePer(a4),d0
		bsr	PokePer
		moveq	#64,d0
		bsr	PokeVol

		lea	$dff0b0,a5
		move.l	a2,D0
		bsr	PokeAdr
		move.l	#Playbuffersize/8,d0
		bsr	PokeLen
		move.l	mp_SamplePer(a4),d0
		bsr	PokePer
		moveq	#64,d0
		bsr	PokeVol

		move	#Playbuffersize,PlaybufNext

		move.b	#3,mp_WaitPlay

		move	#$8003,d0
		bsr	PokeDMA
		moveq	#0,d0
		rts
;-----------------------------------------------------------------------------------
PokeVol:			;in D0 Lautstrke
	movem.l	d1/a5,-(sp)
	move.w	a5,d1		;Dff0a0/b0/c0/d0
	sub.w	#$f0a0,d1
	lsr.w	#4,d1		;Nummer der Stimme von 0-3
	move.l	EPBase,a5
	jsr	ENPP_Pokevol(a5)
	movem.l	(sp)+,d1/a5
	rts
PokePer:			;in D0 Periodenwert
		push	d1/d2/a5

		move.w	a5,d1		;Dff0a0/b0/c0/d0
		sub.w	#$f0a0,d1
		lsr.w	#4,d1		;Nummer der Stimme von 0-3
		and.w	#$f,d1

		move.l	EPBase,a5

		move	EPG_Speed(a5),d2
		beq.s	.speed0
	
		bmi.s	.slower
		mulu	#200,d0
		add	#200,d2
		divu	d2,d0
		bra.s	.speed0
.slower
		neg	d2
		add	#200,d2
		mulu	d2,d0
		divu	#200,d0
.speed0
		jsr	ENPP_PokePer(a5)
		pop	d1/d2/a5
		rts
PokeLen:			;in D0 Lnge in Worten
	movem.l	d1/a5,-(sp)
	move.w	a5,d1		;Dff0a0/b0/c0/d0
	sub.w	#$f0a0,d1
	lsr.w	#4,d1		;Nummer der Stimme von 0-3

	move.l	EPBase,a5
	jsr	ENPP_PokeLen(a5)

	movem.l	(sp)+,d1/a5
	rts
PokeAdr:			;in D0 Adresse
	movem.l	d1/a5,-(sp)
	move.w	a5,d1		;Dff0a0/b0/c0/d0
	sub.w	#$f0a0,d1
	lsr.w	#4,d1		;Nummer der Stimme von 0-3
	move.l	EPBase,a5
	jsr	ENPP_PokeAdr(a5)
	movem.l	(sp)+,d1/a5
	rts
PokeDMA:
	movem.l	d1/d2/a5,-(sp)
	move.l	EPBase,a5
	move.w	d0,d1
	and.w	#$8000,d0	;D0.w neg=enable ; 0/pos=disable
	and.l	#15,d1		;D1 = Maske (LONG !!)
	jsr	ENPP_DmaMask(a5)
	movem.l	(sp)+,d1/d2/a5
	rts
;-------------------------------------------------------------------------------------------
Initplay:		;File ffnen, Speicher allozieren etc.
		lea	datas,a4

		moveq	#-1,d0				;Signal allozieren, 
		move.l	myExecbase(a4),a6		;fr Returnmeldungen vom Proze
		jsr	_LVOallocsignal(a6)		;
		move.l	d0,mp_SignalReturn(a4)		;
		bmi	fail$				;

	ifne	Eagleplayer
		move.l	dtg_PathArrayPtr(a5),a0			;Filepfad zusammensetzen
		clr.b	(a0)					;
		move.l	dtg_CopyDir(a5),a0			;
		jsr	(a0)					;
		move.l	dtg_CopyFile(a5),a0			;
		jsr	(a0)					;
		move.l	dtg_PathArrayPtr(a5),a0			;kompletten Namen holen
	else
		lea	srcfile(pc),a0
	endc
		lea	filepatharray(a4),a1
copyname$	move.b	(a0)+,(a1)+
		bne	copyname$

		move.l	mp_SignalOpen(A4),d0
		moveq	#0,d1
		bsr	SendSignal

		move.b	mp_OpenState(a4),d0
		cmp.b	#1,d0
		bne	fail$

		move.l	#TAG_IGNORE,D0
		lea	Songnamepos(pc),a0
		move.l	d0,(a0)
		lea	Authorpos(pc),a0
		move.l	d0,(a0)
		lea	Albumpos(pc),a0
		move.l	d0,(a0)
		lea	Yearpos(pc),a0
		move.l	d0,(a0)
		lea	Commentpos(pc),a0
		move.l	d0,(a0)
		lea	GenrePos(pc),a0
		move.l	d0,(a0)

	;Filesize ermitteln
		move.l	dosbase(a4),a6
		lea	filepatharray(a4),a0
		move.l	a0,d1
		moveq	#-2,d2
		jsr	_LVOLock(a6)
		move.l	d0,d7
		beq.w	nolock$

		move.l	d7,d1
		lea	mp_fib(a4),a3
		move.l	a3,d2
		addq.l	#3,d2			;align to 4 !
		and.l	#~3,d2			;
		move.l	d2,a3
		jsr	_LVOExamine(A6)
		move.l	fib_size(a3),MI_InfoBuffer+28
		move.l	d7,d1
		jsr	_LVOUnlock(A6)

	;MP3 TAG Info lesen wenn mglich
		lea	filepatharray(a4),a0
		move.l	a0,d1
		move.l	#MODE_OLDFILE,d2
		jsr	_LVOOpen(a6)
		move.l	d0,d7
		beq	nolock$		;darf nicht vorkommen
	
		move.l	d7,d1
		move.l	#-128,d2
		move.l	#OFFSET_END,d3
		jsr	_LVOSeek(a6)
		tst.l	d0
		bmi	nolock$		;sollte auch nicht passieren

		move.l	d7,d1
		lea	Tag_Buffer(a4),a0
		move.l	a0,d2
		move.l	#128,d3
		jsr	_LVORead(a6)
		move.l	d0,d6
		move.l	d7,d1
		jsr	_LVOClose(a6)
		cmp.l	#128,d6		;LeseFehler ?
		bne	nolock$
	;TAG Info analysieren und dekodieren -> ID3v1
		cmp.b	#`T`,Tag_Buffer(a4)
		bne	nolock$
		cmp.b	#`A`,Tag_Buffer+1(a4)
		bne	nolock$
		cmp.b	#`G`,Tag_Buffer+2(a4)
		bne	nolock$

		lea	Songnamepos(pc),a0
		lea	Tag_Buffer+3(a4),a1
		move.l	#MI_SongName,d0
		moveq	#30,d1
		bsr	CopyString$

		lea	Authorpos(pc),a0
		lea	Tag_Buffer+33(a4),a1
		move.l	#MI_AuthorName,d0
		moveq	#30,d1
		bsr	CopyString$

		lea	Albumpos(pc),a0
		lea	Tag_Buffer+63(a4),a1
		move.l	#MI_AlbumName,d0
		moveq	#30,d1
		bsr	CopyString$

		lea	Yearpos(pc),a0
		lea	Tag_Buffer+93(a4),a1
		move.l	#MI_Year,d0
		moveq	#4,d1
		bsr	CopyString$

		lea	Commentpos(pc),a0
		lea	Tag_Buffer+97(a4),a1
		move.l	#MI_Comment,d0
		moveq	#30,d1
		bsr	CopyString$
nolock$
	;------------ decode ID3v2, if applicable --------------------------------------------------
		lea	filepatharray(a4),a0
		bsr	DecodeID3V2

	;------------ Hier Suche nach geeignetem Amplifier fr 16 Bit Abspielen einfgen ------------
		sf	mp_Convert_to_8(a4)			;nicht nach 8 Bit
		move	#PlayBuffersize/2,mp_ReadPerInt(A4)	;Gre setzen
		lea	MI_16Bit(pc),a3

	ifne	Eagleplayer
		bsr	InitStruct			;Audio-Struct + Tagliste init + in A0 zurck
		jsr	ENPP_FindAmplifier(a5)
		tst.l	d0
		bne.s	.16bit

		st	mp_Convert_to_8(a4)
		move	#PlayBuffersize,mp_ReadPerInt(A4)
		lea	MI_8Bit(pc),a3
.16bit
		lea	MI_Playmodeadd(pc),a2
playmode$
		move.b	(a3)+,(a2)+
		bne.s	playmode$

	endc
		moveq	#0,d0
		rts
fail$		
		moveq	#-1,d0
		rts
CopyString$
		move.l	d0,(a0)
		move.l	4(a0),a0
		subq	#1,d1
copytext$
		move.b	(a1)+,(a0)+
		dbf	d1,copytext$

such$
		cmp.b	#" ",-(a0)
		beq	such$

		clr.b	1(a0)
		rts

		;ID3v2 tag decode, assumes that the check routine already provided the size
		;input: A0 - pointer to path
		;       A4 - pointer to datas
		;       ID3v2headersize - previously decoded size of ID3v2 (used as trigger)

DecodeID3V2:
		push	all
		move.l	a0,a5
		moveq	#0,d4
		move.l	ID3v2headersize,d5
		beq.w	did3v2_quit$			;no ID3v2 tag detected, don't waste time and go
		addq	#8,d5				;some more space (you never know...)

		move.l	d5,d0				;
		moveq	#MEMF_Public,d1			;don't care about RAM type, temporary anyway
		move.l	myExecBase(A4),a6		;
		jsr	_LVOAllocMem(A6)		;
		move.l	d0,d4
		beq.w	did3v2_quit$

		move.l	a5,d1				;ptr in d4
		move.l	dosbase(a4),a6
		move.l	#MODE_OLDFILE,d2
		jsr	_LVOOpen(a6)
		move.l	d0,d7
		beq	did3v2_quit$	;shouldn't happen
	
		move.l	d7,d1
		move.l	d4,d2
		move.l	d5,d3
		jsr	_LVORead(a6)
		move.l	d0,d6

		move.l	d7,d1
		jsr	_LVOClose(a6)	;close file before error checking
		cmp.l	d5,d6		;read error ?
		bne	did3v2_quit$

		;occupied: d4,d5 for memory data, rest is free
		move.l	d4,a0			;ID3 header
		cmp.w	#'ID',ID32_Tag(a0)	;this shouldn't lead to an error but one never knows...
		bne.w	did3v2_quit$

		cmp.b	#ID3v2_Version,ID32_Version(a0)	;max. supported version is 3 for now but 4 is tolerated
		beq.w	did3v2_quit$		;quit for now, we assume to find UTF-16 in the file which isn't parsed right now

		move.l	ID32_Size(a0),d0
		bsr	DIDv2_DecSize
		lea	(A0,d0.l),a5		;end ptr

		move.b	ID32_Flags(a0),d0
		and.b	#ID3F_ExtendedHeader,d0
		bne.w	didv2_extheader$	;didv2_noextheader$
didv2_noextheader$
		lea	ID32_HeaderLen(a0),a0	;first frame (pending the parsing of ext header)

didv2_frameloop$
			bsr	DIDv2_GetFrame
			beq	did3v2_quit$		;D0=fourCC D1=length including header

			lea	ID3v2Taglist(pc),a1
didv2_tagsearch$
				cmp.l	(a1),d0
				beq.s	didv2_tagfound$
				tst.l	(a1)
				beq.s	didv2_tagnotfound$
				addq.l	#8,a1
			bra.s	didv2_tagsearch$
didv2_tagfound$
			; jump to processing routine
			move.l	4(a1),a1
			jsr	(a1)
didv2_tagnotfound$
			lea	(a0,d1.l),a0
			cmp.l	a5,a0
		blt.s	didv2_frameloop$	;loop until we have parsed everything

didv2_extheader$	;sorry, without file to test, I can't confirm whether this is literal or 7 bit coded
did3v2_quit$	;free mem and go (d4=mem ptr, d5=mem size)
		tst.l	d4
		beq.s	did3v2_nomem$
		move.l	d4,a1
		move.l	d5,d0
		move.l	myExecbase(A4),a6			;
		jsr	_LVOFreeMem(A6)
did3v2_nomem$
		pop	all
		rts
	;call: 
	; A0 - pointer to frame header
	; D0 - fourCC
	; D1 - length (excluding header)
DID3v2_Title:	
		push	d0/d1/a0/a1
		sub.w	#ID32frm_HeaderLen,d1
		cmp.w	#MaxTagLen+1,d1	;includes indicator byte
		bls.s	.ok
		move	#MaxTagLen+1,d1
.ok
		lea	ID32frm_HeaderLen(a0),a0
		lea	Songnamepos,A1
		move.l	#MI_SongName,D0
		bsr	DID3v2_CopyMIString

		pop	d0/d1/a0/a1
		rts
DID3v2_Author:
		push	d0/d1/a0/a1
		sub.w	#ID32frm_HeaderLen,d1
		cmp.w	#MaxTagLen+1,d1
		bls.s	.ok
		move	#MaxTagLen+1,d1
.ok
		lea	ID32frm_HeaderLen(a0),a0
		lea	Authorpos,A1
		move.l	#MI_AuthorName,D0
		bsr	DID3v2_CopyMIString

		pop	d0/d1/a0/a1
		rts
DID3v2_Album:
		push	d0/d1/a0/a1
		sub.w	#ID32frm_HeaderLen,d1
		cmp.w	#MaxTagLen+1,d1
		bls.s	.ok
		move	#MaxTagLen+1,d1
.ok
		lea	ID32frm_HeaderLen(a0),a0
		lea	Albumpos,A1
		move.l	#MI_AlbumName,D0
		bsr	DID3v2_CopyMIString
		pop	d0/d1/a0/a1
		rts
DID3v2_Year:
		push	d0/d1/a0/a1
		sub.w	#ID32frm_HeaderLen,d1
		cmp.w	#5,d1 ; includes first byte
		bls.s	.ok
		move	#5,d1
.ok
		lea	ID32frm_HeaderLen(a0),a0
		lea	Yearpos,A1
		move.l	#MI_Year,D0
		bsr	DID3v2_CopyMIString
		pop	d0/d1/a0/a1
		rts
DID3v2_Comment:
		push	d0/d1/a0/a1
		sub.w	#ID32frm_HeaderLen,d1
		cmp.w	#MaxTagLen+1,d1
		bls.s	.ok
		move	#MaxTagLen+1,d1
.ok
		lea	ID32frm_HeaderLen+4(a0),a0
		subq	#2,d1
.strstart
		subq	#1,d1
		tst.b	(a0)+
		bne.s	.strstart
		tst.w	d1
		blt.s	.out
		subq.l	#1,a0

		lea	Commentpos,A1
		move.l	#MI_Comment,D0
		bsr	DID3v2_CopyMIString
.out
		pop	d0/d1/a0/a1
		rts
		; genre is a string of the type t(xx)Blahfasel
		; -> if string length is >5, output blahfasel
		; -> else re-calculate number to match ID3v1 code
DID3v2_Genre:
		push	d0/d1/a0/a1

		sub.w	#ID32frm_HeaderLen,d1
		cmp.w	#MaxTagLen+1,d1
		bls.s	.ok
		move	#MaxTagLen+1,d1
.ok
		cmp.w	#5,d1
		ble.s	.codeonly
		move.b	(a0),4(a0)	;FIXME: applies to codes 00-99 only
		lea	4(a0),a0
		subq.w	#4,d1
		bra.s	.copy
.codeonly	; we do have only the code (xx), hopefully
		bra.s	.nogenre	;evil
.copy
		lea	ID32frm_HeaderLen(a0),a0
		lea	GenrePos,A1
		move.l	#MI_Genre,D0
		bsr	DID3v2_CopyMIString
.nogenre
		pop	d0/d1/a0/a1
		rts

	; pity, no MI_ specification for track number yet
DID3v2_Track:
		rts

	; Inputs
	; A0 - source, beginning of string
	; A1 - destination in moduleinfo tag list, pointing to the tag to be activated
	; D0 - Tag ID to be inserted
	; D1 - max. length
DID3v2_CopyMIString:
		push	d1/a0/a1

		move.l	d0,(a1)
		move.l	4(a1),a1

		cmp.b	#1,(a0)+		;indicator byte (00=8859-1,01=unicode)
		beq.s	unicode$

		subq	#2,d1			;subtract first byte (00=8859-1 01=unicode - unsupported yet)
		blt.s	copytext_finish$

		;---------- ASCII copy loop ----------------
copytext$
		move.b	(a0)+,(a1)+
		tst.b	-1(a1)
		beq.s	copytext_finish$
		dbf	d1,copytext$
copytext_finish$
		clr.b	(a1)
		bra.s	end$
		;---------- Unicode copy loop --------------
		; UTF-16 only right now
unicode$
		cmp.w	#$fffe,(a0)+
		bne.s	copytext_finish$	;NO UTF-16 ?

		subq	#3,d1			;01 FF FE
		asr.l	#1,d1			;length/2
		subq	#1,d1
		blt.s	copytext_finish$

copytext_utf16$
		move.b	(a0)+,(a1)+
		addq.l	#1,a0
		dbf	d1,copytext_utf16$
		clr.b	(a1)
end$		
		pop	d1/a0/a1
		rts

; tags to search for and jumps into handling routine (currently all of them are so similar that a generic handler would be sufficient)
ID3v2Taglist:
		dc.l	'COMM',DID3v2_Comment	;
		dc.l	'TALB',DID3v2_Album	;
		dc.l	'TPE1',DID3v2_Author	;TPE2 would be "Band", check if necessary
		dc.l	'TIT2',DID3v2_Title	;TIT1 is general, TIT2 should apply
		dc.l	'TYER',DID3v2_Year	;
		dc.l	'TCON',DID3v2_Genre	;
		dc.l	'TRCK',DID3v2_Track	;
		dc.l	0,0

; return frame type and length
; Input: A0 - first byte of current frame header
; D0 - frame type (ASCII id) - 0 for error cases
; D1 - length     (literal in bytes, including header)
DIDv2_GetFrame
		push	d2-d7
		move.l	ID32frm_len(a0),d0
;		bsr	DIDv2_DecSize
;		beq.s	didv2_fail$
		moveq	#ID32frm_HeaderLen,d1
		add.l	d0,d1

		move.l	ID32frm_4cc(a0),d0
didv2_fail$
		pop	d2-d7
		tst.l	d0
		rts

; Input:  D0 - 7 bit encoded size field (32 bit, including padded bits)
; Output: D0 - decoded size field (24 bit) but without adding header length (0 for failure)
DIDv2_DecSize:
		push	d1-d3
		
		move.l	d0,d1
		and.l	#$80808080,d1	;upper bit(s) set -> error
		bne.s	.dec_err
		cmp.l	#$10000000,d0	;>28 Bit -> error
		bhi.s	.dec_err

		moveq	#3,d2
		moveq	#0,d1
.dec_size:
		moveq	#127,d3		;
		and	d0,d3		;LSB
		or.w	d3,d1		;insert 7 bits
		ror.l	#7,d1		;

		lsr.l	#8,d0		;2nd byte
		dbf	d2,.dec_size

		lsr.l	#4,d1				;(collected 28 bit, move down 4 bits)
		move.l	d1,d0
.dec_end:
		pop	d1-d3
		tst.l	d0
		rts
.dec_err:
		moveq	#0,d0
		bra.s	.dec_end
;------------------------------------------------------------------------------
InitSound:
		lea	datas,a4

		moveq	#0,d0
		bsr	CallSeek

		sf	mp_Started(a4)		;alle Puffer neu einlesen !
		move.l	mp_SignalStart(A4),d0
		moveq	#0,d1
		bsr	SendSignal

		clr.l	mp_Time(a4)	;Zeit neu initialisieren (wird im Interrupt berechnet)
		rts
EndSound:
		lea	datas,a4

		move.l	mp_SignalStop(A4),d0
		moveq	#0,d1
		bsr	SendSignal
		rts
;--------------------------------------------------------------------------------------
Endplay:
		lea	datas,a4

		move.l	mp_SignalClose(A4),d0
		moveq	#0,d1
		bsr	SendSignal

		move.l	mp_SignalReturn(a4),d0
		cmp.l	#-1,d0
		beq	nosig$
		move.l	myExecbase(A4),a6
		jsr	_LVOFreeSignal(A6)
		move.l	#-1,mp_SignalReturn(a4)
nosig$
		rts
;---------------------------------------------------------------------------------------
End:
		lea	datas,a4

		moveq	#SIGBREAKB_CTRL_C,d0
		moveq	#1,d1
		bsr	SendSignal

		bsr	ExitProgram
		rts
;---------------------------------------------------------------------------------------
;Inputs: D0 - Signal
;        D1 - Flags
SendSignal:
		push	all
		move.l	d0,d6
		move.l	d1,d7

		move.l	dosbase(a4),a6
		moveq	#1,d1
		jsr	_LVODelay(a6)

		lea	PR_Name(pc),a1			;Nachsehen, ob der LadeTask noch da ist
		move.l	myExecbase(A4),a6		;
		jsr	_LVOFindtask(a6)		;
		tst.l	d0				;
		beq	ende$				;
		move.l	d0,a1				;

		moveq	#0,d0				;
		bset	d6,d0				;
		move.l	myExecbase(A4),a6		;
		jsr	_LVOsignal(a6)			;

		move.l	dosbase(a4),a6
		moveq	#3,d1
		jsr	_LVODelay(a6)

		cmp.l	#0,d7
		bne	ende$
		
		moveq	#0,d0				;Auf Meldung vom Proze warten
		move.l	mp_SignalReturn(a4),d3		;
		bset	d3,d0				;
		move.l	myExecbase(A4),a6		;
		jsr	_LVOWait(A6)			;
ende$
		pop	all
		rts
;----------------- Aufruf des Playtasks, Kommando "Seek" -------------------
CallSeek:
		push	all
		move.l	d0,mp_NewPosition(A4)	;Position: Anfang der Datei

		ifeq	Eagleplayer
		bsr	SeekPosition
		else
		move.l	mp_SignalSeek(A4),d0
		moveq	#0,d1
		bsr	SendSignal
		endc

		pop	all
		rts
;----------------- Programm Init -------------------------------------------
InitProgram:
	push	d1-a6

	move.l	a4,a0
	move.w	#dataslen-1,d0
clr$	clr.b	(a0)+
	dbf	d0,clr$

	move.l	4,a6
	move.l	a6,myExecBase(a4)

	lea	mpeganame(pc),a1
	moveq	#1,d0
	move.l	myExecBase(a4),a6
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,mpegabase(a4)
	beq	fail$

	ifne	useAsyncIO
		lea	asyncioname(pc),a1
		moveq	#39,d0
		move.l	myExecBase(a4),a6
		jsr	_LVOOpenLibrary(a6)
		move.l	d0,asynciobase(a4)
;		beq	fail$
	endc

	lea	mydosname(pc),a1
	moveq	#37,d0
	move.l	myExecBase(a4),a6
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,dosbase(a4)
	beq	fail$

	pop	d1-a6
	moveq	#0,d0
	rts
fail$
	bsr	ExitProgram

	pop	d1-a6
	moveq	#-1,d0
	rts
;--------------------- alles freigeben -------------------------------------
ExitProgram:
	push	all
	
	move.l	mpegabase(a4),d0
	beq	no$
	move.l	d0,a1
	move.l	4,a6
	jsr	_LVOCloseLibrary(a6)
	clr.l	mpegabase(a4)
no$
	ifne	useAsyncIO
		move.l	asynciobase(a4),d0
		beq	no3$
		move.l	d0,a1
		move.l	4,a6
		jsr	_LVOCloseLibrary(a6)
		clr.l	asynciobase(a4)
no3$
	endc
	
	move.l	dosbase(a4),d0
	beq	no2$
	move.l	d0,a1
	move.l	4,a6
	jsr	_LVOCloseLibrary(a6)
	clr.l	dosbase(a4)
no2$
	pop	all
	rts
;-------------------------------------------------------------------------------------
;-                 Prefs laden bzw. default-Prefs setzen                             -
;-------------------------------------------------------------------------------------
InitPrefs:
	push	all
	; Defaultwerte setzen
	move.l	#"EPMP",MPP_ID(a4)			;ID
	move.l	#PrefsVersion,MPP_ID+4(a4)		;Version

	lea	mplayer2prefs(a4),a0			;Layer 1/2
	clr.w	MPL_force_mono(a0)
	move	#0,MPO_freq_div+MPL_mono(a0)		;Freq_Div 1
	move	#2,MPO_quality+MPL_mono(a0)		;High quality
	move.l	#48000,MPO_freq_max+MPL_mono(a0)	;max. 48 kHz

	clr.w	MPL_force_mono(a0)
	move	#0,MPO_freq_div+MPL_stereo(a0)		;Freq_Div 1
	move	#2,MPO_quality+MPL_stereo(a0)		;High quality
	move.l	#48000,MPO_freq_max+MPL_stereo(a0)	;max. 48 kHz

	lea	mplayer3prefs(a4),a0			;Layer 3
	clr.w	MPL_force_mono(a0)
	move	#0,MPO_freq_div+MPL_mono(a0)		;Freq_Div 1
	move	#2,MPO_quality+MPL_mono(a0)		;High quality
	move.l	#48000,MPO_freq_max+MPL_mono(a0)	;max. 48 kHz

	clr.w	MPL_force_mono(a0)
	move	#0,MPO_freq_div+MPL_stereo(a0)		;Freq_Div 1
	move	#2,MPO_quality+MPL_stereo(a0)		;High quality
	move.l	#48000,MPO_freq_max+MPL_stereo(a0)	;max. 48 kHz

	move	#3,buffertime(a4)
	move	#3,priority(a4)
	pop	all
	rts
;-------------------------------------------------------------------------------------
;--                   Pufferspeicher besorgen                                       --
;-------------------------------------------------------------------------------------
;Inputs: A4 - Base Register
;Output: D0 = 0 ->ok
AllocMemory:
	push	d1-a6
	bsr	FreeMemory			;alle Puffer freigeben, falls nicht geschehen

	sf	mp_Started(a4)			;Puffer nicht valid
	st	mp_NoPlay(a4)			;Amplifier-Abspielroutine stoppen

	lea	mp_LoadBuf1(a4),a3

	moveq	#0,d7
	move	buffertime(a4),d7
	mulu.l	#176800,d7				;Gre des Puffers fr angegebene Zeit
	divu.l	#loadbuffersize,d7			;durch Gre eines Puffers

	cmp	#MinBuffers,d7
	bge.s	nomin$
	moveq	#MinBuffers,d7
	bra.s	take$
nomin$
	cmp	#NumBuffers,d7
	ble.s	take$
	moveq	#NumBuffers,d7
take$
	subq	#1,d7
;	moveq	#NumBuffers-1,d7
buffers$
	move.l	#LB_Sizeof+1152*4,d0			;Mindestanzahl an Puffern allozieren
	moveq	#MEMF_Fast!MEMF_Public,d1		;
	move.l	myExecBase(A4),a6			;
	jsr	_LVOAllocMem(A6)			;
	move.l	d0,(a3)+				;
	beq	fail$					;
	dbf	d7,buffers$

	pop	d1-a6
	moveq	#0,d0
	rts
fail$
	bsr	FreeMemory
	pop	d1-a6
	moveq	#-1,d0
	rts
;-------------------------------------------------------------------------------------
;Inputs: A4 - Base Register
;Output: -
FreeMemory:
	push	all
	sf	mp_Started(a4)			;Puffer nicht valid
	st	mp_NoPlay(a4)			;Amplifier-Abspielroutine stoppen

	lea	mp_LoadBuf1(a4),a3
	moveq	#NumBuffers-1,d7
buffers$
	move.l	(a3),d1
	beq	nomem$
	move.l	d1,a1
	move.l	#LB_Sizeof+1152*4,d0
	move.l	myExecbase(A4),a6			;
	jsr	_LVOFreeMem(A6)
nomem$
	clr.l	(a3)+
	dbf	d7,buffers$

	pop	all
	rts
;-------------- Pufferliste initialisieren -------------------
;Input: A4 - Base Register
;Output: -
InitBuffers:
		push	all
		tst.b	mp_Started(a4)			;Puffer bereits initialisiert ?
		bne.s	ok$

		st	mp_NoPlay(a4)			;Amplifier-Abspielroutine stoppen

		tst.l	mp_LoadBuf1(a4)			;Speicher alloziert ?
		beq	ok$				;nein, Fehler

		clr	mp_Bufnumber(a4)

		lea	mp_LoadBuf1(A4),a3		;alle Puffer in Readylist setzen, sprich
		lea	mp_ReadyBufList(A4),a1		;alle knnen vom LadeProze voll Daten
		moveq	#NumBuffers-1,d0		;geladen werden
initreadybuffers$					;
		suba.l	a0,a0
		move.l	(a3)+,d1
		beq	next$
		move.l	d1,a0
		clr	LB_Number(a0)			;
		sf	LB_LastBuffer(a0)		;
next$
		move.l	a0,(a1)+			;
		dbf	d0,initreadybuffers$		;
		clr.l	mp_Delayedready1(a4)		;
		clr.l	mp_Delayedready2(a4)		;

		move.l	#-1,mp_DummyBuf(a4)		;siehe in Datenarea
		
		move	#NumBuffers*3-1,d0		;kein Puffer ist `ready to play`
		lea	mp_LoadedBufList(A4),a2		;
initloadedbuffer$					;
		clr.l	(a2)+				;
		dbf	d0,initloadedbuffer$		;

		clr.l	mpR_CurrentBuf(a4)		;
		clr.l	mp_Currentloadbuf(a4)		;
		st	mp_Started(a4)			;Puffer bereits initialisiert ?
		sf	mp_NoPlay(a4)
ok$
		pop	all
		rts
;Input: A4 - Base Register
EndBuffers:
		sf	mp_Started(a4)			;Puffer nicht valid
		rts
;-------------------------------------------------------------------------------------
;Inputs: -
;Output: d0 = 0 <-> ok
InitDecodingtask:
		push	d1-a6

		suba.l	a1,a1				;eigenen Task suchen
		move.l	myExecbase(A4),a6		;
		jsr	_LVOFindtask(A6)		;
		move.l	d0,mpeg_SigTask(A4)		;

		lea	mytags(A4),a0			;LadeProze starten
		move.l	a0,d1				;
		move.l	#NP_Entry,(a0)+			;
		move.l	#Dec_Process,(a0)+		;
		move.l	#NP_Name,(A0)+			;
		move.l	#PR_Name,(A0)+			;
		move.l	#NP_Priority,(a0)+		;
		moveq	#0,d0				;
	ifne	Eagleplayer
		move	priority(a4),d0			;
	endc
		move.l	d0,(a0)+			;> als Executive def. Catch Range
		clr.l	(a0)				;
		move.l	Dosbase(a4),a6			;
		jsr	_LVOCreateNewProc(a6)		;
		move.l	d0,mp_TaskAddress(a4)		;
		beq.s	fail$				;

		moveq	#0,d0				;Auf Meldung vom Proze warten
		move.l	mp_SignalReturn(a4),d3		;
		bset	d3,d0				;
		move.l	myExecbase(A4),a6		;
		jsr	_LVOWait(A6)			;

		pop	d1-a6
		moveq	#0,d0
		rts
fail$
		pop	d1-a6
		moveq	#-1,d0
		rts
;-------------------------------------------------------------------------------------
;--                          Decoding-Proze                                        --
;-------------------------------------------------------------------------------------
Dec_Process:
		push	all
		lea	datas,a4
		sf	mp_Ready(a4)
		
		bsr	AllocSignals
		bne	exit$

		suba.l	a1,a1				;eigenen Task suchen
		move.l	myExecbase(A4),a6		;
		jsr	_LVOFindtask(A6)		;
		move.l	d0,mpP_Address(a4)

		st	mp_Ready(a4)
		bsr	ReturnSignal

		moveq	#0,d0
loop$
		btst	#SIGBREAKB_CTRL_C,d0
		bne	exit$
		;Bearbeitung der entsprechenden Kommandos an den Dekoder-Task

		and.l	mp_SignalMask(a4),d0	;mask our Signals out
		beq	noSpecial$
		lea	mp_SignalStop(a4),a1
nosig$
		move.l	(a1)+,d1
		move.l	(a1)+,a0
		btst	d1,d0
		beq.s	next$
		move.l	a0,d2			;kein Einsprung ?
		beq	next$
		jsr	(a0)
next$
		bclr	d1,d0
		tst.l	d0
		bne	nosig$
		bsr	ReturnSignal		;Signal vom Hauptproze erwidern (nach Abarbeitung der Kommandos)
noSpecial$
;		move	#$f0f,$dff180
		;Einsprung in Dekodierer
	ifeq	test
		bsr	DecodeFrame
	else
		moveq	#0,d0
	endc
		beq	wait$			;wenn 0 zurck, warten

		;nachschauen, ob neue Kommandos vorliegen
		moveq	#0,d0
		move.l	mp_SignalMask(a4),d1	;clear Signals after processing
		move.l	myExecBase(A4),a6
		jsr	_LVOSetSignal(a6)	;neue Kommandos ?
		bra	loop$			;
wait$
		;warten auf was auch immer
		move.l	mp_SignalMask(a4),d0
		move.l	myExecBase(A4),a6
		jsr	_LVOWait(a6)

		move.l	mp_SignalLoad(a4),d1	;Signalload nicht erwidern
		bclr	d1,d0
		tst.l	d0
		beq	noSpecial$
		bra	loop$
exit$
		st	mp_FailInit(a4)
		sf	mp_Ready(a4)
		clr.l	mpP_Address(a4)
		bsr	ReturnSignal
		pop	all
		rts
DecodeFrame:
		tst.b	mp_Started(a4)
		beq.w	wait$
		move.l	mpegstream(a4),d7
		beq.w	wait$
		
		move.l	mp_Currentloadbuf(a4),d0
		bne.s	load$

		bsr	NewLoadBuf		;neuen Puffer holen
		beq	wait$			;alle voll -> warten
		move.l	d0,mp_Currentloadbuf(a4)
load$
		move.l	d0,a3
		lea	LB_Datas(a3),a2
		lea	mp_PCMBuffers(a4),a1	;Pointer auf 2 Pointer

		move.l	LB_LoadSize(a3),d1	;Anzahl der Bytes pro Kanal
		add.l	d1,a2
		move.l	a2,(a1)			;Zieladr linker Kanal

		add.l	#loadbuffersize/2,a2
		move.l	a2,4(a1)		;Zieladr rechter Kanal

		move.l	d7,a0
		move.l	mpegabase(a4),a6
		jsr	_LVOMPEGA_decode_frame(a6)
		tst.l	d0
		bmi	error$

		tst.b	mp_Convert_to_8(a4)
		beq.s	do16$

		lea	LB_Datas(a3),a2
		move.l	LB_LoadSize(a3),d1	;Anzahl der Bytes pro Kanal
		add.l	d1,a2

		lea	(a2),a0
		lea	(a2),a1
		lsr	#1,d0
		move	d0,d1
		lsr	#1,d1			;frech aber sollte laufen: immer 2 Worte pro Kanal
		subq	#1,d1
		bmi.s	zero$
		move	d1,d3
conv16_8$
		move.w	(a0)+,d2		;1. upper byte
		move.b	(a0),d2			;2. upper byte
		move.l	(a0)+,d4		;3. upper byte
		swap	d2
		move.b	(a0),d4
		addq.l	#2,a0
		move.w	d4,d2
		move.l	d2,(a1)+
		dbf	d1,conv16_8$

		add.l	#loadbuffersize/2,a2
		lea	(a2),a0
		lea	(a2),a1
conv16_82$
		move.w	(a0)+,d2		;1. upper byte
		move.b	(a0),d2			;2. upper byte
		move.l	(a0)+,d4		;3. upper byte
		swap	d2
		move.b	(a0),d4
		addq.l	#2,a0
		move.w	d4,d2
		move.l	d2,(a1)+
		dbf	d3,conv16_82$
		bra.s	do16$
zero$
		moveq	#0,d0
do16$
		add.l	d0,d0
cont8$
		add.l	LB_LoadSize(a3),d0	;
		move.l	d0,LB_LoadSize(a3)

		move.l	#loadbuffersize/2,d1	;Gesamtgre des Puffers (pro Kanal)
		sub.l	d0,d1			;minus aktuelle Gre
		cmp.l	#MPEGA_PCM_SIZE*2,d1	;Platz fr noch ein Frame ?
		bgt.s	ok$			;
		bsr	InsertBuffer		;nein, Puffer in Readylist einsortieren
ok$
		moveq	#1,d0
		rts
error$
		cmp.l	#MPEGA_ERR_BADFRAME,d0
		bne.s	nobadframe$
		bra	ok$
nobadframe$
		cmp.l	#MPEGA_ERR_NO_SYNC,d0
		bne.s	nosync$
		bra	ok$
nosync$
		cmp.l	#MPEGA_ERR_EOF,d0
		bne.s	noeof$
		st	LB_LastBuffer(a3)
		bsr	InsertBuffer

		clr.l	mp_NewPosition(a4)
		bsr	SeekPosition
		bra	ok$
noeof$
		move.l	EPBase(pc),a2		;Eagleplayer benachrichtigen, da das
		jsr	ENPP_Songend(a2)	;Songende erreicht wurde

		sf	mp_Started(a4)
wait$
		moveq	#0,d0
		rts
;Input: -
;Output: D0 - Pufferadresse oder 0 fr Fehler
NewLoadBuf:
		push	d1-a6
		lea	mp_ReadyBufList(a4),a1	;Liste der freien Puffer
		moveq	#NumBuffers-1,d1	;max. Anzahl
searchempty$
		move.l	(a1)+,d0		;dieser frei ?
		bne.s	foundempty$		;yep, verwenden
searchnextempty$
		dbf	d1,searchempty$

		pop	d1-a6
		moveq	#0,d0
		rts
foundempty$
		clr.l	-4(a1)			;Puffer aus Liste nehmen

		move.l	d0,a1
		clr.l	LB_Number(a1)
		clr.l	LB_Playoffset(a1)
		clr.l	LB_LoadSize(a1)
		pop	d1-a6
		tst.l	d0
		rts
;-------------------------------------------------------------------------------------
;Input:  A3 - einzusortierender Puffer
;Output: -
InsertBuffer:
		push	all
		move.l	a3,d0		;kein Puffer bergeben -> nix einsortieren
		beq	error$

		lea	mp_LoadedBufList+[NumBuffers*2]*4(a4),a1 ;letzten freien Puffer suchen,
suchloop$	move.l	-(a1),d1	 ;da doppelt so viel Platz wie ntig reserviert, 
		beq	suchloop$	 ;ist immer was frei

		clr.l	LB_Playoffset(a3)			;bei Offset 0 starten
		move	mp_Bufnumber(a4),LB_Number(a3)		;numerieren
		addq	#1,mp_Bufnumber(a4)

		move.l	a3,4(a1)	;in Liste einfgen

		clr.l	mp_Currentloadbuf(a4)
error$
		pop	all
		rts
;-------------------------------------------------------------------------------------
;Input:  -
;Output: D0 = 0 <-> ok
AllocSignals:
		push	d1-a6
		moveq	#0,d7			;Signalmaske

		lea	mp_SignalStart(a4),a5
		bsr	alloc$
		move.l	d0,(a5)
		bmi	fail$
		bset	d0,d7
		lea	InitBuffers(pc),a0
		move.l	a0,4(a5)

		lea	mp_SignalStop(a4),a5
		bsr	alloc$
		move.l	d0,(a5)
		bmi	fail$		
		bset	d0,d7
		lea	EndBuffers(pc),a0
		move.l	a0,4(a5)

		lea	mp_SignalSeek(a4),a5
		bsr	alloc$
		move.l	d0,(a5)
		bmi	fail$		
		bset	d0,d7
		lea	SeekPosition(pc),a0
		move.l	a0,4(a5)

		lea	mp_SignalOpen(a4),a5
		bsr	alloc$
		move.l	d0,(a5)
		bmi	fail$		
		bset	d0,d7
		lea	OpenmyMPFile(pc),a0
		move.l	a0,4(a5)

		lea	mp_SignalClose(a4),a5
		bsr	alloc$
		move.l	d0,(a5)
		bmi	fail$
		bset	d0,d7
		lea	ClosemyMPFile(pc),a0
		move.l	a0,4(a5)

		lea	mp_SignalLoad(a4),a5
		bsr	alloc$
		move.l	d0,(a5)
		bmi	fail$
		bset	d0,d7

		lea	mp_SignalQuit(a4),a5
		moveq	#SIGBREAKB_CTRL_C,d0
		move.l	d0,(a5)
		bset	d0,d7

		move.l	d7,mp_SignalMask(a4)

		pop	d1-a6
		moveq	#0,d0
		rts
fail$
		pop	d1-a6
		moveq	#-1,d0
		rts
alloc$
		moveq	#-1,d0				;Signal allozieren, 
		move.l	myExecbase(A4),a6		;fr Returnmeldungen vom Proze
		jsr	_LVOallocsignal(a6)		;
		rts
;-------------------------------------------------------------------------------------
ReturnSignal:
		push	d1-a6

		move.l	mp_SignalReturn(A4),d1		;wir sind schon abgeschrieben ?
		cmp.l	#-1,d1
		beq	failsignal$			;ok, also `QUIT` !
		moveq	#0,d0
		bset	d1,d0
		move.l	mpeg_SigTask(A4),a1
		move.l	myExecbase(A4),a6
		jsr	_LVOsignal(a6)
		moveq	#0,d1
failsignal$	move.l	d1,d0

		pop	d1-a6
		rts
;-------------------------------------------------------------------------------------
InitModuleinfo:
	push	d1-a6
	move.l	mpegstream(a4),d0
	beq	nomp$			;sollte nicht vorkommen
	move.l	d0,a0
	lea	MI_InfoBuffer,a3

	move	MPS_norm(a0),d0
	add.b	#`0`,d0
	move.b	d0,MpegNorm	

	move	MPS_layer(a0),d0
	add.b	#`0`,d0
	move.b	d0,MpegLayer

	move	MPS_bitrate(a0),d1
	move	d1,d0
	mulu	#1000,d0
	move.l	d0,Bitrate+4

	divu	#100,d1
	add.b	#`0`,d1
	move.b	d1,MpegRate	
	clr	d1
	swap	d1
	divu	#10,d1
	add.b	#`0`,d1
	move.b	d1,MpegRate+1
	swap	d1
	add.b	#`0`,d1
	move.b	d1,MpegRate+2

;	move.l	MPS_dec_frequency(a0),d0
	move.l	MPS_frequency(a0),d0
	move.l	d0,20(a3)

	move.l	MPS_ms_duration(a0),d0
	divu.l	#1000,d0
	move.l	d0,12(a3)
	divu.l	#TimeStep,d0
	move.l	d0,60(a3)			;Length

	moveq	#0,d0
	move	MPS_channels(a0),d0
	move.l	d0,52(a3)

	move	MPS_mode(a0),d0
	lea	Mode_Stereo,a1
	cmp.w	#MPEGA_MODE_STEREO,d0
	beq	set$
	lea	Mode_Dual,a1
	cmp.w	#MPEGA_MODE_DUAL,d0
	beq	set$
	lea	Mode_Mono,a1
	cmp.w	#MPEGA_MODE_MONO,d0
	beq	set$
	lea	Mode_Joint,a1
set$
	lea	MpegMode(pc),a2
copy$
	move.b	(a1)+,(a2)+
	bne.s	copy$

	move.l	MPS_dec_frequency(a0),d0
	move.l	d0,mp_SampleRate(a4)

	move.w	MPS_dec_channels(a0),d0
nomp$
	pop	d1-a6
	rts
;-------------------------------------------------------------------------------------
;Inputs: mp_NewPosition
;        >=0 : Zeit in Millisekunden
;         -1 : 10 Sekunden vor
;         -2 : 10 Sekunden zurck
SeekPosition:
	push	d1-a6
	move.l	mpegabase(a4),d0
	beq	nomp$
	move.l	d0,a6

	move.l	mpegstream(a4),d0
	beq	nomp$
	move.l	d0,a0

	move.l	mp_NewPosition(a4),d0
	bge	ok$

;	move.l	mp_Time(a4),d0

	lea	mytags(a4),a1		;ULONG* ms_time_position
	jsr	_LVOMPEGA_time(a6)
	tst.l	d0
	bne	nomp$
	move.l	mytags(a4),d0

	add.l	#TimeStep*1000,d0	;10s vor
	cmp.l	#-2,mp_NewPosition(a4)
	bne.s	ok$
	sub.l	#TimeStep*2000,d0	;10 s zurck
	bge.s	ok$
	moveq	#0,d0
ok$
	move.l	d0,mp_Time(a4)

	move.l	mpegstream(a4),a0
	jsr	_LVOMPEGA_Seek(a6)
nomp$
	pop	d1-a6
	moveq	#0,d0
	rts
;------------- Kommando: mpeg Stream ffnen ---------------------------------
OpenmyMPFile:
	push	all

	bsr	AllocMemory
	bne	failinitplay$
	bsr	OpenMPFile
	bne	failinitplay$

	bsr	InitModuleinfo			;Output: d0 - Channels

	move	d0,mp_NumChannels(a4)
	lsl	#1,d0
	move	d0,mp_BytesperFrame(a4)

	move.l	myExecbase(A4),a1		;
	move.l	ex_eclockfrequency(a1),d2	;
	move.l	d2,d0				;
	lsl.l	#2,d2				;mal 4
	add.l	d0,d2				;mal 4+1 = mal 5!

	move.l	mp_SampleRate(a4),d0		;
	divu	d0,d2				;
	and.l	#$ffff,d2			;
	move.l	d2,mp_SamplePer(A4)		;
	
	move.b	#1,mp_OpenState(a4)
	pop	all
	rts
failinitplay$
	st	mp_OpenState(a4)
	pop	all
	rts
;------------ Kommando: mpeg Stream schlieen -------------------------------
ClosemyMPFile:
	push	all
	bsr	CloseMPFile
	bsr	FreeMemory
	pop	all
	rts
;-------------------------------------------------------------------------------------
;MPEG File ffnen:
;Inputs: mplayer2prefs,mplayer3prefs,filepatharray
;Output: D0 = 0 -> ok , D0<>0 -> Fehler
OpenMPFile:
	push	d1-a6
	bsr	CloseMPFile			;altes File schlieen wenn vorhanden

	move.l	mpegabase(a4),d0
	beq	nomp$
	move.l	d0,a6

	lea	mpcontrol(a4),a1		;Ctrl-Struct clear
	lea	(a1),a0
	moveq	#MPC_sizeof-1,d0
clr$
	clr.b	(a0)+
	dbf	d0,clr$

	lea	MPC_layer_1_2(a1),a0		;copy settings for Layer 1/2
	lea	mplayer2prefs(a4),a2
	move	#MPL_sizeof-1,d0
copy1$
	move.b	(a2)+,(a0)+
	dbf	d0,copy1$

	lea	MPC_layer_3(a1),a0		;copy settings for Layer 3
	lea	mplayer3prefs(a4),a2
	move	#MPL_sizeof-1,d0
copy2$
	move.b	(a2)+,(a0)+
	dbf	d0,copy2$

	move.w	#0,MPC_check_mpeg(a1)
;	move.l	#8192,MPC_stream_buffer_size(a1)
	move.l	#mplib_Buffersize,MPC_stream_buffer_size(a1)

		clr.l	MPC_bs_access(a1)	;clear by default
	ifne	useAsyncIO
		move.l	asynciobase(a4),d0	;Asyncio Library found ?
		beq	noasync$		;no, use default routines

		lea	CustomAccessHook(pc),a0	;Asyncio found -> own hook for supplying mpega with data
		move.l	a0,MPC_bs_access(a1)
noasync$
	endc

	lea	filepatharray(a4),a0
	jsr	_LVOMPEGA_open(a6)
	move.l	d0,mpegstream(a4)
	beq	nomp$

	suba.l	a1,a1				;eigenen Task suchen
	move.l	myExecbase(A4),a6		;
	jsr	_LVOFindtask(A6)		;
	move.l	d0,a1
	moveq	#0,d0
	move	priority(A4),d0
	jsr	_LVOSetTaskPri(A6)

	pop	d1-a6
	moveq	#0,d0
	rts
nomp$
	pop	d1-a6
	moveq	#-1,d0
	rts
;-----------------------------------------------------------------------------------------
;Inputs: mpegstream
;Output: -
CloseMPFile:
	push	all
	move.l	mpegstream(a4),d0
	beq	no$
	move.l	d0,a0
	move.l	mpegabase(a4),d0
	beq	no$
	move.l	d0,a6
	jsr	_LVOMPEGA_close(a6)
no$
	clr.l	mpegstream(a4)
	clr.b	mp_OpenState(a4)
	pop	all
	rts
;-------------------------------------------------------------------------------------

		endb	a4
		basereg	datas,a5
;------------------------------------------------------------------------
Configurate:
	push	all
	
	move.l	4.w,a6

	lea	datas,a5

	sf	onsysfont(A5)

	suba.l	A1,A1
	JSR	_LVOfindtask(A6)
	move.l	d0,mytask(a5)

	lea	dos(pc),a1
	moveq	#37,d0			;Brauchen DOS V1.2,fr Message,falls
	jsr	_LVOopenlibrary(a6)	;Start von 1.2/1.3 aus
	move.l	d0,_dos(a5)
	beq	NODOS

	lea	int(pc),a1
	moveq	#37,d0
	jsr	_LVOopenlibrary(a6)
	move.l	d0,intsave(a5)
	beq	NOINT

	lea	graf(pc),a1
	moveq	#37,d0
	jsr	_LVOopenlibrary(a6)
	move.l	d0,grafsave(a5)
	beq	NOGraf

	lea	gad(pc),a1

	moveq	#37,d0
	jsr	_LVOopenlibrary(a6)
	move.l	d0,gadsave(a5)
	beq	NoGadTo

	bsr	OpenWin
	tst.l	winhandle(a5)
	beq	fail$
	bsr	MakeSettings
	bsr	HandleActions		;Auf Usereingaben reagieren
	tst	d0			;Fehler ?
	beq	fail$
	cmp	#3,d0			;Cancel ?
	beq	fail$
	bsr	GetSettings
	cmp	#1,d0
	bne	fail$
	bsr	SaveConfig
fail$
	bsr	closewin

nopubscreen
Nogadgets
nowin
	move.l	gadsave(a5),a1
	move.l	4,a6
	jsr	_LVOcloselibrary(A6)
	clr.l	gadsave(A5)
nogadto
	move.l	grafsave(a5),a1
	move.l	4,a6
	jsr	_LVOcloselibrary(a6)
NoGraf
	move.l	intsave(a5),a1
	move.l	4,a6
	jsr	_LVOcloselibrary(a6)
noint
	move.l	4,a6
	move.l	_dos(a5),a1
	jsr	_LVOcloselibrary(a6)
nodos
Endprog
NoSignal
	pop	all
	rts
********************************************************************
*                Settings in die Layer-Struct schreiben            *
********************************************************************
GetSettings:
	push	all
	lea	Prefstab,a4
next$
	move.l	(a4),d0
	bmi	end$
	bsr	_GADR			;Gadgetadresse in A0

	lea	numboo(a5),a1
	move.l	gadsave(A5),a6		;lib
	sub.l	a2,a2			;req
	lea	mytags(a5),a3		;tags
	move.l	4(a4),(A3)+
	move.l	a1,(a3)+
	clr.l	(A3)+
	lea	mytags(a5),a3		;tags

	move.l	winhandle(A5),a1	;win
	jsr	_LVOGT_Getgadgetattrsa(A6)

	move.l	numboo(a5),d1

	move.l	8(a4),a1		;Adresse fr Daten
	move.l	12(a4),d0		;Flag fr Byte/Word/Long
	beq	byte$
	cmp	#1,d0
	beq	word$
	move.l	d1,(a1)
	bra	use$
byte$
	move.b	d1,(a1)
	bra	use$
word$
	move.w	d1,(a1)
	bra	use$
use$

	lea	Ptab_Size(a4),a4
	bra	next$
end$
	pop	all
	rts
********************************************************************
*                Settings aus der Layer-Struct holen               *
********************************************************************
MakeSettings:
	push	all
	lea	Prefstab,a4
next$
	move.l	(a4),d0
	bmi	end$
	bsr	_GADR			;Gadgetadresse in A0

	move.l	8(a4),a1		;Adresse fr Daten
	move.l	12(a4),d0		;Flag fr Byte/Word/Long
	beq	byte$
	cmp	#1,d0
	beq	word$
	move.l	(a1),d0
	bra	use$
byte$
	move.b	(a1),d0
	bra	use$
word$
	move.w	(a1),d0
	bra	use$
use$
	move.l	gadsave(A5),a6		;lib
	sub.l	a2,a2			;req
	lea	mytags(a5),a3		;tags
	move.l	4(a4),(A3)+
	move.l	d0,(a3)+
	clr.l	(A3)+
	lea	mytags(a5),a3		;tags

	move.l	winhandle(A5),a1	;win
	jsr	_LVOGT_Setgadgetattrsa(A6)

	lea	Ptab_Size(a4),a4
	bra	next$
end$
	pop	all
	rts
********************************************************************
*                   Usereingaben berwachen                        *
********************************************************************
;Input: -
;Output: D0 = 0 -> Fehler
;        D0 = 1 -> Save
;        D0 = 2 -> Use
;        D0 = 3 -> Cancel
HandleActions:
	push	d1-a6
.ma
	move.l	gadsave(a5),a6

	move.l	port(a5),d0
	beq.s	nowin$
	move.l	d0,a0
	jsr	_LVOGT_getimsg(a6)
	tst.l	d0
	bne	msg$

	moveq	#0,d0
	move.l	Port(a5),d2
	beq.s	nowin$
	move.l	d2,a0
	move.b	mp_sigbit(a0),d1
	bset	d1,d0
nomain$
	move.l	4,a6
	jsr	_LVOwait(a6)
	bra	.ma
msg$
	move.l	d0,a1
	move.l	im_class(a1),d7
	move.w	im_code(a1),d5 		<- Fr Tastatur / Selnummer Listview
	move.l	im_Iaddress(a1),d6 	<- Fr Gadgetabfrage
	move.l	im_seconds(a1),d2	<- fr Doppelclick
	move.l	im_micros(a1),d3	<- auch f. Doppelclick
	jsr	_LVOGT_replyimsg(a6)

	cmp.l	#Gadgetup,d7
	bne.w	notup$

	move.l	d6,a1
	move.w	gg_gadgetid(A1),d4	;ID Fr Gadgets

	moveq	#1,d0
	cmp	#GD_Save,d4
	beq	nowin$
	moveq	#2,d0
	cmp	#GD_Use,d4
	beq	nowin$
	moveq	#3,d0
	cmp	#GD_Cancel,d4
	beq	nowin$

	bra	.ma
notup$
	bra	.ma
nowin$
	pop	d1-a6
	rts
********************************************************************
*                  Init & Open Window                              *
********************************************************************
Openwin:
	tst.l	winhandle(A5)
	bne.w	.endme

	clr.l	port(A5)

	move.l	intsave(a5),a6
	bsr	Setupscreen		;Public Screen holen
	bne	.Endme
	bsr	SetUpWin		;Fenster ffnen
	tst.l	d0
	bne	.Endme

	bsr	Project0Render

	move.l	Winhandle(a5),a0
	move.l	wd_userport(a0),a0	;User Port
	move.l	a0,port(a5)
.endme
rtsA
	rts

Project0Render:
    movem.l d0-d5/a0-a2/a6,-(sp)
	move.l	Winhandle(a5),a0
	move.l	#Project0Width,d2
	move.l	#Project0Height,d3
	bsr	ComputeFont

	move.l	Vi(a5),NR+4
	move.l	Vi(a5),IR+4

	move.l  Gadsave(A5),a6
	move.l	Winhandle(a5),a0
	move.l	wd_RPort(a0),a2

;----------------------- Bevelboxen zeichnen (Austauschroutine) ---------------------------
    move.l  a2,a0
    lea.l   NR,a1
    move.l  #78,d0
    jsr     ComputeY
    add.w   OffY,d0
    move.l  d0,d1
    move.l  #123,d0
    jsr     ComputeX
    move.l  d0,d2
    move.l  #41,d0
    jsr     ComputeY
    move.l  d0,d3
    move.l  #9,d0
    jsr     ComputeX
    add.w   OffX,d0
    jsr     DrawBevelBoxA(a6)
    move.l  a2,a0
    lea.l   NR,a1
    move.l  #15,d0
    jsr     ComputeY
    add.w   OffY,d0
    move.l  d0,d1
    move.l  #123,d0
    jsr     ComputeX
    move.l  d0,d2
    move.l  #41,d0
    jsr     ComputeY
    move.l  d0,d3
    move.l  #9,d0
    jsr     ComputeX
    add.w   OffX,d0
    jsr     DrawBevelBoxA(a6)
    move.l  a2,a0
    lea.l   NR,a1
    move.l  #128,d0
    jsr     ComputeY
    add.w   OffY,d0
    move.l  d0,d1
    move.l  #300,d0
    jsr     ComputeX
    move.l  d0,d2
    move.l  #40,d0
    jsr     ComputeY
    move.l  d0,d3
    move.l  #5,d0
    jsr     ComputeX
    add.w   OffX,d0
    jsr     DrawBevelBoxA(a6)
    move.l  a2,a0
    lea.l   NR,a1
    move.l  #78,d0
    jsr     ComputeY
    add.w   OffY,d0
    move.l  d0,d1
    move.l  #157,d0
    jsr     ComputeX
    move.l  d0,d2
    move.l  #41,d0
    jsr     ComputeY
    move.l  d0,d3
    move.l  #139,d0
    jsr     ComputeX
    add.w   OffX,d0
    jsr     DrawBevelBoxA(a6)
    move.l  a2,a0
    lea.l   NR,a1
    move.l  #15,d0
    jsr     ComputeY
    add.w   OffY,d0
    move.l  d0,d1
    move.l  #159,d0
    jsr     ComputeX
    move.l  d0,d2
    move.l  #41,d0
    jsr     ComputeY
    move.l  d0,d3
    move.l  #138,d0
    jsr     ComputeX
    add.w   OffX,d0
    jsr     DrawBevelBoxA(a6)
    move.l  a2,a0
    lea.l   NR,a1
    move.l  #69,d0
    jsr     ComputeY
    add.w   OffY,d0
    move.l  d0,d1
    move.l  #300,d0
    jsr     ComputeX
    move.l  d0,d2
    move.l  #55,d0
    jsr     ComputeY
    move.l  d0,d3
    move.l  #5,d0
    jsr     ComputeX
    add.w   OffX,d0
    jsr     DrawBevelBoxA(a6)
    move.l  a2,a0
    lea.l   NR,a1
    move.l  #5,d0
    jsr     ComputeY
    add.w   OffY,d0
    move.l  d0,d1
    move.l  #300,d0
    jsr     ComputeX
    move.l  d0,d2
    move.l  #56,d0
    jsr     ComputeY
    move.l  d0,d3
    move.l  #5,d0
    jsr     ComputeX
    add.w   OffX,d0
    jsr     DrawBevelBoxA(a6)

;---------------- Texte ausgeben (Standardroutine) ---------------------------------
    moveq   #0,d3
    lea.l   Project0Text0,a2
Project0TLoop:
    move.l  _SysBase,a6
    lea.l   BufIText(a5),a1
    move.l  a2,a0
    move.l  d3,d0
    mulu    #it_SIZEOF,d0
    add.l   d0,a0
    moveq   #it_SIZEOF,d0
    jsr     CopyMem(a6)
    lea.l   BufIText(a5),a0
    move.l  Intsave(a5),a6
    move.l  Font(a5),it_ITextFont(a0)
    jsr     IntuiTextLength(a6)
    asr.l   #1,d0
    move.l  d0,-(sp)
    lea.l   BufIText(a5),a0
    move.w  it_LeftEdge(a0),d0
    jsr     ComputeX
    add.w   Offx(a5),d0
    ext.l   d0
    sub.l   (sp)+,d0
    move.w  d0,it_LeftEdge(a0)
    move.w  it_TopEdge(a0),d0
    jsr     ComputeY
    add.w   Offy(a5),d0
    move.l  Font(a5),a1
    move.w  ta_YSize(a1),d1
    asr.w   #1,d1
    sub.w   d1,d0
    move.w  d0,it_TopEdge(a0)
    move.l  a0,a1
    move.l  winhandle(A5),a0
    move.l  wd_RPort(a0),a0
    moveq   #0,d0
    moveq   #0,d1
    jsr     _LVOPrintIText(a6)
    addq.l  #1,d3
    cmp.l   #Project0_TNUM,d3
    bmi     Project0TLoop
    movem.l (sp)+,d0-d5/a0-a2/a6
    rts


*************** Window & Screen freigeben *************************
Closewin:
	bsr	closedownwin
	bra	closedownscreen
*******************************************************************
*      Public Screen ranholen und Visual Info anfordern           *
*******************************************************************
SetupScreen:
	move.l	Intsave(a5),a6

	moveq	#0,d0
;	lea	begin(pc),a0
;	move.l	eus_epbase(a0),d0
;	beq.s	.noep
;	move.l	d0,a0
;	move.l	EPG_Pubscreen(A0),d0
;	move.w	EPG_Wordreserved7(A0),word7(A5)
;.noep
	move.l	d0,a0
	jsr	_LVOLockPubScreen(a6)
	move.l	d0,MyPubscreen(A5)
	beq.s	.error

	move.l	mypubscreen(A5),a0
	move.l	Gadsave(A5),a6
	suba.l	a1,a1
	jsr	_LVOGetVisualInfoA(a6)
	move.l	d0,Vi(A5)
	beq.s	.error     
	moveq	#0,d0
	rts
.error
	moveq	#-1,d0
	rts
*******************************************************************
*      Public Screen ranholen und Visual Info anfordern           *
*******************************************************************
CloseDownScreen:
	push	all
	
	move.l	Gadsave(a5),a6
	move.l	Vi(A5),d0
	beq.s	.novi
	move.l	d0,a0
	jsr	_LVOFreeVisualInfo(a6)
	clr.l	Vi(A5)
.novi
	move.l	Intsave(A5),a6
	suba.l	a0,a0
	move.l	Mypubscreen(A5),d0
	beq.s	.nopub
	move.l	d0,a1
	jsr	_LVOUnlockPubScreen(a6)
.nopub
	pop	all
	rts
GetFont
	tst.b	onsysfont(A5)
	beq.s	.stand

	move.l	grafsave(A5),a6
	lea.l	MyRastPort(a5),a3
	move.l	a3,a1
	jsr	_LVOInitrastport(A6)
	move.l	a3,a1
	lea.l	Attr(a5),a0
	jsr	_LVOAskFont(A6)
	lea.l	Attr(a5),a0
	jsr	_LVOopenfont(A6)
	move.l	d0,fontadr(A5)
	beq.s	.stand
	move.l	d0,a1
	rts
.stand
	move.l	mypubscreen(A5),a1
	lea.l	sc_RastPort(a1),a1
	move.l	rp_Font(a1),a1
	rts
ComputeFont:
	bsr	GetFont

	lea.l	Attr(a5),a0
	move.l	a0,Font(A5)

	move.l  LN_NAME(a1),ta_Name(a0)
	move.w  tf_YSize(a1),ta_YSize(a0)
	move.w  tf_XSize(a1),d0
	addq	#1,d0
	move	d0,FontX(A5)
	move.w  tf_YSize(a1),FontY(A5)

	move.l	fontadr(A5),d0
	beq.s	.nofree
	move.l	d0,a1
	move.l	grafsave(A5),a6
	jsr	_LVOclosefont(A6)
.nofree
	move.l	mypubscreen(A5),a0
	move.b	sc_WBorLeft(a0),d0
	ext.w	d0
	move.w	d0,OffX(A5)

	move.l	sc_font(A0),a1
	move.w	ta_YSize(a1),d0

	addq.w	#1,d0
	move.b	sc_WBorTop(a0),d1
	ext.w	d1
	add.w	d1,d0
	move.w	d0,OffY(A5)

	tst.w	d2
	beq.s	CompDone
	tst.w	d3
	beq.s	CompDone
	move.w	d2,d0
	bsr	ComputeX

	add.w   OffX(A5),d0
	move.b	sc_WBorRight(a0),d1
	ext.w	d1
	add.w	d1,d0
	cmp.w	sc_Width(a0),d0

	ifne	test
	bra.s	Usetopaz
	endc

	bhi.s	UseTopaz
	move.w	d0,d2

	move.w	d3,d0
	bsr	ComputeY
	add.w	OffY(a5),d0
	move.b	sc_WBorBottom(a0),d1
	ext.w	d1
	add.w	d1,d0
	cmp.w	sc_Height(a0),d0
	bhi.s	UseTopaz
	move.w	d0,d3
CompDone:
	rts
UseTopaz:
	add.w   OffX(A5),d2
	move.b	sc_WBorRight(a0),d1
	ext.w	d1
	add.w	d1,d2

	add.w	OffY(a5),d3
	move.b	sc_WBorBottom(a0),d1
	ext.w	d1
	add.w	d1,d3

	move.l	Font(A5),a0
	move.l	#TopazName,ta_Name(a0)
	move.w	#8,FontY(A5)
	move.w	#8,FontX(a5)
	move.w	#8,ta_YSize(a0)
	rts
ComputeX:
	move.l	d1,-(sp)
	move.w	FontX(a5),d1
	bra.s	ComputeItX
ComputeY:
	move.l	d1,-(sp)
	move.w	FontY(A5),d1
	mulu	d1,d0
	addq.w	#4,d0
	lsr.w	#3,d0
	move.l	(sp)+,d1
	rts
ComputeItX:
	mulu	d1,d0
	addq.w	#4,d0
	lsr.w	#3,d0
	move.l	(sp)+,d1
	rts

CreateGadgets
	move.l	Gadsave(A5),a6
	lea.l	Project0GList(a5),a0
	jsr	_LVOCreateContext(a6)
	move.l	d0,a3
	tst.l	d0
	beq.w	.Project0CError

	moveq	#0,d3
	lea.l	Project0GTags(pc),a4
.Project0GL:
	move.l	4,a6
	lea.l	Project0NGads(pc),a0
	move.l	d3,d0
	mulu	#gng_SIZEOF,d0
	add.l	d0,a0
	lea.l	BufNewGad(a5),a1
	moveq	#gng_SIZEOF,d0
	jsr	_LVOCopyMem(a6)
	lea.l	BufNewGad(a5),a0
	move.l	Vi(a5),gng_VisualInfo(a0)
	move.l	Font(a5),gng_TextAttr(a0)

	move.w	gng_LeftEdge(a0),d0
	bsr	computex
	add.w	OffX(a5),d0
	move.w	d0,gng_LeftEdge(a0)

	move.w	gng_TopEdge(a0),d0
	bsr	computey
	add.w	OffY(a5),d0
	move.w	d0,gng_TopEdge(a0)

	move.w	gng_Width(a0),d0
	bsr	computex
	move.w	d0,gng_Width(a0)

	move.w	gng_Height(a0),d0
	bsr	computey
	move.w	d0,gng_Height(a0)

	move.l	Gadsave(a5),a6
	lea.l	Project0GTypes(pc),a0
	moveq	#0,d0
	move.l	d3,d1
	asl.l	#1,d1
	add.l	d1,a0
	move.w	(a0),d0
	move.l	a3,a0
	lea.l	BufNewGad(a5),a1
	move.l	a4,a2
	jsr	_LVOCreateGadgetA(a6)
	tst.l	d0
	bne.s	.Project0COK
	bra	.Project0CError
.Project0COK:
	move.l	d0,a3
	move.l	d3,d0
	asl.l	#2,d0
	lea.l	Project0Gadgets(a5),a0
	add.l	d0,a0
	move.l	a3,(a0)
.Project0TL:
	tst.l	(a4)
	beq.s	.Project0DN
	addq.w	#8,a4
	bra.s	.Project0TL
.Project0DN:
	addq.w	#4,a4
	addq.w	#1,d3
	cmp.w	#Project0_CNT,d3
	bmi	.Project0GL
.Project0CError
	rts
*************************************************************************
*            Fenster ffnen, Gadgets und Mens init                     *
*************************************************************************
SetUpWin:
	movem.l d1-d4/a0-a4/a6,-(sp)

	move.l	mypubscreen(a5),a0
	move.l  sc_Font(a0),a1
	move.w  ta_YSize(a1),d3
	addq.w  #1,d3
	move.b  sc_WBorTop(a0),d0
	ext.w   d0
	add.w	d3,d0
	move.w	d0,offy(a5)

	move.b  sc_WBorLeft(a0),d0
	ext.w   d0
	move.w	d0,offx(a5)

	move.w	#Project0Width,d2
	move.w	#Project0Height,d3

	bsr	ComputeFont
	move.l	mypubscreen(A5),a0

	move.l	d2,ahawidth
	move.l	d3,ahaheight

	move.l	d2,d0
	move.l	d0,d4

	moveq	#0,d2
	add.w	d2,d0
	add.w	OffX(a5),d0
	move.b	sc_WBorRight(a0),d1
	ext.w	d1
	add.w	d1,d0
	cmp.w	sc_Width(a0),d0
	bls.s	.Project0WOk
	move.w	sc_Width(a0),d0
	sub.w	d4,d0
	move.w	d0,d2
.Project0WOk:
	move.l	d3,d0
	move.l	d0,d4

;	lea	begin(pc),a1
;	move.w	eus_winy(a1),d3
	add.w	d3,d0

	add.w	OffY(A5),d0
	move.b	sc_WBorBottom(a0),d1
	ext.w	d1
	add.w	d1,d0
	cmp.w	sc_Height(a0),d0
	bls.s	Project0HOk
	move.w	sc_Height(a0),d0
	sub.w	d4,d0
	move.w	d0,d3
Project0HOk:

		clr.l	Project0Menus(A5)
	ifne	SetMenus
		move.l	Gadsave(A5),a6
		lea.l	Project0NewMenu0(pc),a0

		lea.l	MTags0(pc),a1
		jsr	_LVOCreateMenusA(a6)
		move.l	d0,Project0Menus(A5)
		tst.l	d0
		beq	Project0MError
		move.l	d0,a0
		move.l	Vi(A5),a1
		lea.l	mtags0(pc),a2
		jsr	_LVOLayoutMenusA(a6)
	endc

	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
	moveq	#0,d7
;	lea	begin(Pc),a1
;	move	eus_Winx(a1),d0
;	move	eus_Winy(a1),d1
;	move	ZoomPosX(a1),d2
;	move	ZoomPosY(a1),d3

	move.l	ahawidth(pc),d4
	move.l	ahaheight(pc),d5
	move.l	#ZoomWidth,d6
	move	offy(A5),d7

;	tst.b	ZoomState(a1)
;	beq.s	.Normal
;	exg.l	d0,d2
;	exg.l	d1,d3
;	exg.l	d4,d6
;	exg.l	d5,d7
;.normal
	lea.l	Project0WindowTags(pc),a1
	move.l	d0,Project0L+4-Project0WindowTags(A1)
	move.l	d1,Project0T+4-Project0WindowTags(A1)
	move.l	d4,Project0W+4-Project0WindowTags(A1)
	move.l	d5,Project0H+4-Project0WindowTags(A1)
	move.w	d2,ZoomStruct-Project0WindowTags(A1)
	move.w	d3,ZoomStruct+2-Project0WindowTags(A1)
	move	d6,ZoomStruct+4-Project0WindowTags(A1)
	move	d7,ZoomStruct+6-Project0WindowTags(A1)

	move.l	Intsave(A5),a6
	move.l	mypubscreen(a5),Pubadr-Project0WindowTags(a1)
	suba.l	a0,a0
	jsr	_LVOOpenWindowTagList(a6)
	move.l	d0,Winhandle(a5)
	tst.l	d0
	beq	Project0WError
.open13
	ifne	SetMenus
		move.l	Winhandle(a5),a0
		move.l	Project0Menus(A5),a1
		jsr	_LVOSetMenuStrip(a6)
	endc

	bsr	createGadgets

	bsr	AddGads

	moveq	#0,d0
Project0Done:
	movem.l	(sp)+,d1-d4/a0-a4/a6
	rts
Project0CError:
	moveq	#1,d0
	bra.s	Project0Done
Project0GError:
	moveq	#2,d0
	bra.s	Project0Done
Project0MError:
	moveq	#3,d0
	bra.s	Project0Done
Project0WError:
	moveq	#4,d0
	bra.s	Project0Done

AddGads:
	movem.l	d0-a6,-(sp)
	move.l	Project0GList(a5),d0
	beq.s	.nogads
	move.l	d0,a1

	moveq	#0,d1
.count
	move.l	d0,a0

	addq.l	#1,d1

	move.l	(A0),d0
	bne.s	.count

	move.w	d1,RealNumGadgets(A5)

	move.l	intsave(a5),a6
	move.l	winhandle(a5),a0
	moveq	#-1,d0
	moveq	#-1,d1
	suba.l	a2,a2
	jsr	_LVOaddglist(a6)

	move.l	Project0GList(a5),a0
	move.l	winhandle(a5),a1
	suba.l	a2,a2
	moveq	#-1,d0
	jsr	_LVOrefreshglist(a6)

	move.l	GadSave(a5),a6
	move.l	Winhandle(a5),a0
	suba.l	a1,a1
	jsr	_LVOGT_RefreshWindow(a6)

.nogads
	movem.l	(sp)+,d0-a6
	rts
*************************************************************************
*            Fenster schlieen, Gadgets und Mens free                  *
*************************************************************************
Closedownwin:
	push	all
	move.l	Intsave(A5),a6
	move.l	Project0Menus(A5),a0
	cmpa.l	#0,a0
	beq	Project0NMenu
	move.l	Winhandle(a5),a0
	jsr	_LVOClearMenuStrip(a6)
	move.l	GadSave(a5),a6
	move.l	Project0Menus(A5),a0
	jsr	_LVOFreeMenus(a6)
	move.l	#0,Project0Menus(A5)
Project0NMenu:
	move.l	Intsave(A5),a6
	move.l	Winhandle(a5),d0
	beq.s	.nowin
	move.l	d0,a0
	jsr	_LVOCloseWindow(a6)
	clr.l	Winhandle(a5)
	clr.l	port(a5)
.nowin
	bsr	Freegadgets
	pop	all
	rts
FreeGadgets
	movem.l	d0-a6,-(sp)

	move.l	GadSave(a5),a6
	move.l	Project0GList(A5),a0
	cmpa.l	#0,a0
	beq	.nogad
	jsr	_LVOFreeGadgets(a6)
	clr.l	Project0GList(A5)
.nogad
	movem.l	(sp)+,d0-a6
	rts
*************************************************************
*    Gadgetadresse ausrechnen                               *
* Input D0 - Gadgetnummer (0 < X < MAX)                     *
*************************************************************
_Gadr
	lea	Gadgetadrs(a5),a0
	asl.l	#2,d0
	move.l	(a0,d0),a0
	rts
;============= Save Player Config Routine ===========================
SaveConfig:
	movem.l	d0-a6,-(sp)
	
	move.l	dosbase,d0
	beq	error$
	move.l	d0,a6

	move.l	EPBase(pc),a0
	move.l	EPG_ConfigDirArrayPtr(a0),d1
	moveq	#-2,d2			;access_read
	jsr	_LVOlock(a6)
	tst.l	d0
	beq	.nolock			;Path not found
	move.l	d0,d1
	jsr	_LVOcurrentdir(A6)
	move.l	d0,d7

	lea	savename(pc),a1
	move.l	a1,d1
	move.l	#1006,d2		;MODE_NEWFILE
	jsr	_LVOopen(A6)
	move.l	d0,d6
	beq.s	.fail

	move.l	d0,d1				;Handle
	move.l	#ConfigDatas,d2			;Adr
	move.l	#ConfigDatasLen,d3		;len
	jsr	_LVOwrite(a6)

	move.l	d6,d1
	jsr	_LVOclose(a6)
.fail
	move.l	d7,d1
	jsr	_LVOCurrentdir(A6)
	move.l	d0,d1
	jsr	_LVOUnlock(A6)
.nolock
error$
	movem.l	(Sp)+,d0-a6
	rts
;============= Load Player Config Routine ===========================
Loadconfig:
	movem.l	d0-a6,-(sp)
	bsr	InitPrefs		;Vorinit

	move.l	dosbase,d0
	beq	error$
	move.l	d0,a6

	ifeq	Eagleplayer
		move.l	#testpath,d1
	else
		move.l	EPBase(pc),a0
		move.l	EPG_ConfigDirArrayPtr(a0),d1
	endc

	moveq	#-2,d2			;access_read
	jsr	_LVOlock(a6)
	tst.l	d0
	beq	.nolock			;Path not found
	move.l	d0,d1
	jsr	_LVOcurrentdir(A6)
	move.l	d0,d7

	lea	savename(pc),a1
	move.l	a1,d1
	move.l	#MODE_Oldfile,d2		;MODE_NEWFILE
	jsr	_LVOopen(A6)
	move.l	d0,d6
	beq.s	.fail

	move.l	d0,d1				;Handle
	move.l	#ConfigDatas,d2			;Adr
	move.l	#ConfigDatasLen,d3		;len
	jsr	_LVOread(a6)

	move.l	d6,d1
	jsr	_LVOclose(a6)

	move.l	MPP_ID,d0
	cmp.l	#"EPMP",d0
	bne.s	def$
	move.l	MPP_ID+4,d0
	cmp.l	#PrefsVersion,d0
	beq.s	ok$
def$
	bsr	InitPrefs
ok$

.fail
	move.l	d7,d1
	jsr	_LVOCurrentdir(A6)
	move.l	d0,d1
	jsr	_LVOUnlock(A6)
.nolock
error$
	movem.l	(sp)+,d0-a6
	rts

savename:	dc.b	`MPEG_Audio.cfg`,0

	ifeq	Eagleplayer
testpath	dc.b	`EP:Configs`,0
	endc
	cnop	0,4
;*****************************************************************************
;*                        Daten und Initialisierungen                        *
;*****************************************************************************
mpeganame:	dc.b	`mpega.library`,0
asyncioname:	dc.b	`asyncio.library`,0
mydosname:	dc.b	`dos.library`,0
PR_Name:	dc.b	`Eagleplayer MPEG Audio Decoder Task`,0

	even
AudioINT
	dc.l	0			;letzter Node
	dc.l	0			;nchster Node
	dc.b	2			;Node Type = Interrupt
	dc.b	0			;Prioritt
	dc.l	0			;Name
	dc.l	0			;Zeiger auf Daten
	dc.l	INT_Aud			;Interrupt Routine

;----------------------------------- Daten des Prefs-Fensters --------------------------

int:	dc.b	`intuition.library`,0

gad:	dc.b	`gadtools.library`,0

dos:	dc.b	`dos.library`,0
graf	dc.b	`graphics.library`,0

	even
	Project0WindowTags:
Project0L:
	DC.L	WA_Left,0
Project0T:
	DC.L	WA_Top,0
Project0W:
	DC.L	WA_Width,0
Project0H:
	DC.L	WA_Height,0

	DC.L	WA_IDCMP,IDCMP_Changewindow!IDCMP_RawKey!IDCMP_Menupick!LISTVIEWIDCMP!BUTTONIDCMP!IDCMP_CLOSEWINDOW!IDCMP_REFRESHWINDOW
;	DC.L	WA_Flags,WFLG_DRAGBAR!WFLG_DEPTHGADGET!WFLG_CLOSEGADGET!WFLG_SMART_REFRESH
	DC.L	WA_Flags,WFLG_DRAGBAR!WFLG_DEPTHGADGET!WFLG_SMART_REFRESH

	DC.L	WA_Title,Project0WTitle
	DC.L	WA_ScreenTitle,Project0STitle
	dc.l	wa_newlookmenus,1
	dc.l	wa_autoadjust,1

	dc.l	wa_pubscreen
Pubadr
	dc.l	0

;	dc.l	WA_Zoom
;	dc.l	ZoomStruct
	DC.L	TAG_DONE,0
ZoomStruct
	dc.w	0,0,150,0

Ahawidth
	dc.l	399
Ahaheight
	dc.l	80

NR:
	DC.L    GT_VisualInfo,$00000000,TAG_DONE
IR:
	DC.L	GT_VisualInfo,$00000000,GTBB_recessed,1
	dc.l	TAG_DONE
MTags0:
	DC.L	GTMN_Newlookmenus,1
	dc.l	TAG_DONE

TopazName:
	DC.B	'topaz.font',0


Project0WTitle:
	dc.b	'MPEG Audio replayer options',0
Project0STitle:
	DC.B	'Eagleplayer MPEG Audio replayer options, DEFECT Softworks',0
	even

Project0GTypes:
    DC.W    CYCLE_KIND
    DC.W    INTEGER_KIND
    DC.W    CYCLE_KIND
    DC.W    INTEGER_KIND
    DC.W    CYCLE_KIND
    DC.W    INTEGER_KIND
    DC.W    CHECKBOX_KIND
    DC.W    CYCLE_KIND
    DC.W    INTEGER_KIND
    DC.W    CHECKBOX_KIND
    DC.W    BUTTON_KIND
    DC.W    BUTTON_KIND
    DC.W    BUTTON_KIND
    DC.W    SLIDER_KIND
    DC.W    SLIDER_KIND

Project0NGads:
    DC.W    55,24,73,11
    DC.L    LIM_QualityText,0
    DC.W    GD_LIM_Quality
    DC.L    PLACETEXT_LEFT,0,0
    DC.W    62,39,66,12
    DC.L    L1M_FMaxText,0
    DC.W    GD_L1M_FMax
    DC.L    PLACETEXT_LEFT,0,0
    DC.W    55,87,73,11
    DC.L    L3M_QualityText,0
    DC.W    GD_L3M_Quality
    DC.L    PLACETEXT_LEFT,0,0
    DC.W    62,102,66,12
    DC.L    L3M_FMaxText,0
    DC.W    GD_L3M_FMax
    DC.L    PLACETEXT_LEFT,0,0
    DC.W    183,23,73,11
    DC.L    L1S_QualityText,0
    DC.W    GD_L1S_Quality
    DC.L    PLACETEXT_LEFT,0,0
    DC.W    190,38,66,12
    DC.L    L1S_FMaxText,0
    DC.W    GD_L1S_FMax
    DC.L    PLACETEXT_LEFT,0,0
    DC.W    264,38,26,11
    DC.L    L1S_MonoText,0
    DC.W    GD_L1S_Mono
    DC.L    PLACETEXT_ABOVE,0,0
    DC.W    183,87,73,11
    DC.L    L3S_QualityText,0
    DC.W    GD_L3S_Quality
    DC.L    PLACETEXT_LEFT,0,0
    DC.W    190,102,66,12
    DC.L    L3S_FMaxText,0
    DC.W    GD_L3S_FMax
    DC.L    PLACETEXT_LEFT,0,0
    DC.W    264,101,26,11
    DC.L    L3S_MonoText,0
    DC.W    GD_L3S_Mono
    DC.L    PLACETEXT_ABOVE,0,0
    DC.W    6,175,63,15
    DC.L    SaveText,0
    DC.W    GD_Save
    DC.L    PLACETEXT_IN,0,0
    DC.W    123,175,63,15
    DC.L    UseText,0
    DC.W    GD_Use
    DC.L    PLACETEXT_IN,0,0
    DC.W    240,175,63,15
    DC.L    CancelText,0
    DC.W    GD_Cancel
    DC.L    PLACETEXT_IN,0,0
    DC.W    105,131,162,13
    DC.L    BufferTimeText,0
    DC.W    GD_BufferTime
    DC.L    PLACETEXT_LEFT,0,0
    DC.W    105,150,162,13
    DC.L    PriorityText,0
    DC.W    GD_Priority
    DC.L    PLACETEXT_LEFT,0,0

Project0GTags:
    DC.L    GTCY_Labels,LIM_QualityLabels
    DC.L    TAG_DONE
    DC.L    GTIN_Number,48000
    DC.L    GTIN_MaxChars,10
    DC.L    TAG_DONE
    DC.L    GTCY_Labels,L3M_QualityLabels
    DC.L    TAG_DONE
    DC.L    GTIN_Number,48000
    DC.L    GTIN_MaxChars,10
    DC.L    TAG_DONE
    DC.L    GTCY_Labels,L1S_QualityLabels
    DC.L    TAG_DONE
    DC.L    GTIN_Number,48000
    DC.L    GTIN_MaxChars,10
    DC.L    TAG_DONE
    DC.L    TAG_DONE
    DC.L    GTCY_Labels,L3S_QualityLabels
    DC.L    TAG_DONE
    DC.L    GTIN_Number,48000
    DC.L    GTIN_MaxChars,10
    DC.L    TAG_DONE
    DC.L    TAG_DONE
    DC.L    TAG_DONE
    DC.L    TAG_DONE
    DC.L    TAG_DONE
    DC.L    GTSL_Min,1
    DC.L    GTSL_Max,8
    DC.L    GTSL_Level,3
    DC.L    GTSL_MaxLevelLen,5
    DC.L    GTSL_LevelFormat,BufferTimeFormat
    DC.L    GTSL_LevelPlace,PLACETEXT_RIGHT
    DC.L    PGA_Freedom,LORIENT_HORIZ
    DC.L    GA_RelVerify,1
    DC.L    TAG_DONE
    DC.L    GTSL_Min,-3
    DC.L    GTSL_Max,19
    DC.L    GTSL_Level,3
    DC.L    GTSL_MaxLevelLen,5
    DC.L    GTSL_LevelFormat,PriorityFormat
    DC.L    GTSL_LevelPlace,PLACETEXT_RIGHT
    DC.L    PGA_Freedom,LORIENT_HORIZ
    DC.L    GA_RelVerify,1
    DC.L    TAG_DONE

BufferTimeFormat:
    DC.B    '%lds',0
    CNOP     0,2

PriorityFormat:
    DC.B    '%ld',0
    CNOP     0,2

LIM_QualityText:
    DC.B    'Qual',0

L1M_FMaxText:
    DC.B    'F.Max',0

L3M_QualityText:
    DC.B    'Qual',0

L3M_FMaxText:
    DC.B    'F.Max',0

L1S_QualityText:
    DC.B    'Qual',0

L1S_FMaxText:
    DC.B    'F.Max',0

L1S_MonoText:
    DC.B    'Mono',0

L3S_QualityText:
    DC.B    'Qual',0

L3S_FMaxText:
    DC.B    'F.Max',0

L3S_MonoText:
    DC.B    'Mono',0

SaveText:
    DC.B    'Save',0

UseText:
    DC.B    'Use',0

CancelText:
    DC.B    'Cancel',0

BufferTimeText:
    DC.B    'Buffer Time',0

PriorityText:
    DC.B    'Priority',0

	cnop	0,2

    XDEF    LIM_QualityLabels

LIM_QualityLabels:
    DC.L    LIM_QualityLab0
    DC.L    LIM_QualityLab1
    DC.L    LIM_QualityLab2
    DC.L    0

    XDEF    L3M_QualityLabels

L3M_QualityLabels:
    DC.L    LIM_QualityLab0
    DC.L    LIM_QualityLab1
    DC.L    LIM_QualityLab2
    DC.L    0

    XDEF    L1S_QualityLabels

L1S_QualityLabels:
    DC.L    LIM_QualityLab0
    DC.L    LIM_QualityLab1
    DC.L    LIM_QualityLab2
    DC.L    0

    XDEF    L3S_QualityLabels

L3S_QualityLabels:
    DC.L    LIM_QualityLab0
    DC.L    LIM_QualityLab1
    DC.L    LIM_QualityLab2
    DC.L    0

LIM_QualityLab0:    DC.B    'Low',0
LIM_QualityLab1:    DC.B    'Medium',0
LIM_QualityLab2:    DC.B    'High',0

;------------------------------------------------------------------------------------------

Project0Text0:
    DC.B    1,0
    DC.B    RP_JAM2
    DC.B    0
    DC.W    62,16
    DC.L    0
    DC.L    Project0IText0
    DC.L    0

Project0Text1:
    DC.B    1,0
    DC.B    RP_JAM2
    DC.B    0
    DC.W    93,6
    DC.L    0
    DC.L    Project0IText1
    DC.L    0

Project0Text2:
    DC.B    1,0
    DC.B    RP_JAM2
    DC.B    0
    DC.W    199,16
    DC.L    0
    DC.L    Project0IText2
    DC.L    0

Project0Text3:
    DC.B    1,0
    DC.B    RP_JAM2
    DC.B    0
    DC.W    77,70
    DC.L    0
    DC.L    Project0IText3
    DC.L    0

Project0Text4:
    DC.B    1,0
    DC.B    RP_JAM2
    DC.B    0
    DC.W    62,80
    DC.L    0
    DC.L    Project0IText4
    DC.L    0

Project0Text5:
    DC.B    1,0
    DC.B    RP_JAM2
    DC.B    0
    DC.W    199,80
    DC.L    0
    DC.L    Project0IText5
    DC.L    0

Project0_TNUM EQU 6

Project0IText0:
    DC.B    ' Mono file ',0

Project0IText1:
    DC.B    ' MPEG Layers I & II ',0

Project0IText2:
    DC.B    ' Stereo file ',0

Project0IText3:
    DC.B    ' MPEG Layer III ',0

Project0IText4:
    DC.B    ' Mono File ',0

Project0IText5:
    DC.B    ' Stereo file ',0

    CNOP    0,2

;----------------------------------------------------------------------------------------

	ifne	SetMenus

Project0NewMenu0:
    DC.B    NM_TITLE,0
    DC.L    Project0MName0
    DC.L    0
    DC.W    0
    DC.L    0,0

	DC.B	NM_ITEM,0
	DC.L	Project0MName91
	DC.L	Project0MComm9
Hiercheck_Mono
	DC.W	CHECKIT!Menutoggle
	DC.L	0,0

	DC.B    NM_ITEM,0
	DC.L    NM_BARLABEL,0
	DC.W    0
	DC.L    0,0

    DC.B    NM_ITEM,0
    DC.L    Project0MName6
    DC.L    Project0MComm6
    DC.W    0
    DC.L    0,0

    DC.B    NM_ITEM,0
    DC.L    Project0MName7
    DC.L    Project0MComm7
    DC.W    0
    DC.L    0,0

    DC.B    NM_ITEM,0
    DC.L    Project0MName8
    DC.L    Project0MComm8
    DC.W    0
    DC.L    0,0

    DC.B    NM_TITLE,0
    DC.L    Project0MName61
    DC.L    0
    DC.W    0
    DC.L    0,0

	DC.B	NM_ITEM,0
	DC.L	Project0MName1
	DC.L	Project0MComm1
Hiercheck
	DC.W	CHECKIT!Menutoggle
	DC.L	0,0

	DC.B    NM_ITEM,0
	DC.L    NM_BARLABEL,0
	DC.W    0
	DC.L    0,0

    DC.B    NM_ITEM,0
    DC.L    Project0MName71
    DC.L    0
    DC.W    0
    DC.L    0,0

    DC.B    NM_ITEM,0
    DC.L    Project0MName81
    DC.L    0
    DC.W    0
    DC.L    0,0

    DC.B    NM_END,0
    DC.L    0,0
    DC.W    0
    DC.L    0,0

Project0MName0:		DC.B    'Project',0
Project0MName1		dc.b	'Global',0
Project0MComm1		dc.b	'G',0
Project0MName6:		DC.B    'About',0
Project0MComm6:		DC.B    'A',0
Project0MName7:		DC.B    'Hide',0
Project0MComm7:		DC.B    'H',0
Project0MName8:		DC.B    'Quit',0
Project0MComm8:		DC.B    'Q',0
Project0MComm9:		DC.B    'M',0

Project0MName61:
    DC.B    'Settings',0

Project0MName71:
    DC.B    'Reset to Defaults',0

Project0MName81:
    DC.B    'Save Settings',0

Project0MName91:
    DC.B    'Mono Modules Mode',0

	even

	endc
TD:
    DC.L    TAG_DONE

;----------------------------------------------
;Tabelle fr Prefs-Einstellungen

;1. GagetID
;2. Property
;3. Zieladresse in Prefs-Struktur
;4. Modus: 0=byte, 1 = word, 2 = long
;5. eventuelle Umwandlungsroutine fr "SetPrefs"
;6. eventuelle Umwandlungsroutine fr "GetPrefs"
ptab	macro
	dc.l	\1,\2,\3,\4,\5,\6
	endm
Prefstab:
	ptab	GD_LIM_Quality,GTCY_Active,mplayer2prefs+MPO_quality+MPL_mono,1,0,0
Ptab_Size=*-Prefstab
	ptab	GD_L1M_FMax,GTIN_Number,mplayer2prefs+MPO_freq_max+MPL_mono,2,0,0

	ptab	GD_L1S_Quality,GTCY_Active,mplayer2prefs+MPO_quality+MPL_stereo,1,0,0
	ptab	GD_L1S_FMax,GTIN_Number,mplayer2prefs+MPO_freq_max+MPL_stereo,2,0,0
	ptab	GD_L1S_Mono,GTCB_Checked,mplayer2prefs+MPL_force_mono,1,0,0

	ptab	GD_L3M_Quality,GTCY_Active,mplayer3prefs+MPO_quality+MPL_mono,1,0,0
	ptab	GD_L3M_FMax,GTIN_Number,mplayer3prefs+MPO_freq_max+MPL_mono,2,0,0

	ptab	GD_L3S_Quality,GTCY_Active,mplayer3prefs+MPO_quality+MPL_stereo,1,0,0
	ptab	GD_L3S_FMax,GTIN_Number,mplayer3prefs+MPO_freq_max+MPL_stereo,2,0,0
	ptab	GD_L3S_Mono,GTCB_Checked,mplayer3prefs+MPL_force_mono,1,0,0

	ptab	GD_BufferTime,GTSL_Level,buffertime,1,0,0
	ptab	GD_Priority,GTSL_Level,priority,1,0,0
	ptab	-1,0,0,0,0,0


	ifeq	Eagleplayer
;srcfile:	dc.b	"audio:electro-EBM-industrial/Apoptygma Berzerk/BurningHeretics-Gothic    .mp3",0
;srcfile:	dc.b	"audio:misc/Blur-Song2.mp3",0
;srcfile:	dc.b	"modules:dmf/DMF.CAN-Love is a Key",0
;srcfile:	dc.b	"audio:oldies/creedenc.mp3",0
;srcfile:	dc.b	"modules:MP3/Wolfsheim/Elias.mp3",0
srcfile:	dc.b	"modules:MP3/Joy Machine-Separate Ways.mp3",0

	endc

	ifeq	Eagleplayer
testadr
;	incdir	audio:misc/
;	incbin	Blur-Song2.mp3,1000
;	incdir	modules:problem-modules/
;	incbin	dinger.mp3,3000
;	incdir	modules:dmf/
;	incbin	"DMF.CAN-Love is a Key",1000
;	incdir	audio:oldies/
;	incbin	creedenc.mp3,1000
;	incdir	modules:MP3/Wolfsheim/
;	incbin	Elias.mp3,30000
	incdir	modules:MP3/
	incbin  "Joy Machine-Separate Ways.mp3",30000
	endc

;------------------------------------------------------------------------------------------------
	
	section	1,bss_p
datas:
mp_fib		ds.b	fib_sizeof+8
audstruct0	ds.b	as_sizeof*4	;*4 nur zur Sicherheit, man weiss ja nie bei Betas

myExecBase	ds.l	1	;ExecBase sichern, spart Zugriff aufs Chipmem
dosbase		ds.l	1
mpegabase:	ds.l	1
asynciobase:	ds.l	1
mpegstream:	ds.l	1
mpcontrol:	ds.b	MPC_sizeof
mpcontrol_check:
		ds.b	MPC_sizeof	;Control-Struktur fr Check: Low Quality, Mono, Divide by 4


ConfigDatas:
MPP_ID		ds.b	8		;ID ("EPMP") und Version (1)
mplayer2prefs:	ds.b	MPL_sizeof
mplayer3prefs:	ds.b	MPL_sizeof
buffertime:	ds.w	1		;Lnge des Puffers (Def = 3)
priority:	ds.w	1
ConfigDatasLen = *-ConfigDatas

filepatharray:	ds.b	800
mytags		ds.l	30

		ds.l	5
mp_LoadBuf1:	ds.l	NumBuffers	;Pufferspeicher-Adressen
		ds.l	5

mpR_CurrentBuf:		ds.l	1
mp_Currentloadbuf:	ds.l	1	;aktuell, vollzuladender Puffer
mp_Bufnumber:		ds.w	1	;Nummer des aktuellen Puffers

mp_Delayedready1	ds.l	1		;Puffer bei Freigabe fr LadeTask um ein Frame verzgert,
mp_Delayedready2	ds.l	1		;da sonst u.U. der gerade abgespielte Puffer berschrieben
					;wrde
					
mp_ReadyBufList: ds.l	NumBuffers*2	;Puffer, die abgespielt wurden und nun wieder vollgepackt werden knnen,
				;bergabe: leere Speicherzelle suchen (min. eine ist immer frei) und Adr reinschreiben
				;bernahme: volle Speicherzelle suchen, auslesen und danach
				;           auf 0 rcksetzen

mp_DummyBuf	ds.l	1	;damit die Suchroutine des Prozesses richtig arbeitet, 
				;wird hier einfach ein Wert von -1 eingetragen
mp_LoadedBufList:
		ds.l	NumBuffers*4;Puffer, die komplett ins Ram geladen wurden
			;bergabe: von hinten an letzte freie Speicherzelle suchen und Daten dort reinlegen,
			;          wenn letzte Position belegt, warten und danach nochmal versuchen
			;bernahme: erste belegte Speicherzelle suchen, rauslesen und gesamten Block
			;           nach oben scrollen
			;
			;das *2 gilt nur fr das Upscrolling, nach der Anzahl von NumLoadBuffers
			;drfen keine Daten abgelegt werden, reine Speedup Storage


mp_FailInit	ds.b	1	;~0: Decoder-Proze konnte nicht initialisiert werden
mp_Ready	ds.b	1	;~0: Decoder Proze bereit
mp_OpenState	ds.b	1	;~0: Fehler beim ffnen der Datei/Mem Alloc
				; 1: Datei geffnet, alles ok
				; 0: Datei geschlossen
		ds.b	1
mpP_Address	ds.l	1	;Taskadr Hauptproze
mpeg_SigTask	ds.l	1	;Hauptproze
mp_SignalReturn	ds.l	1	;Returnmeldungen an den Hauptproze
mp_NewPosition	ds.l	1	;Neue Position im File
mp_NoPlay	ds.b	1	;Flag fr Abspielroutine: Daten nicht anrhren
mp_Started	ds.b	1	;Puffer initialisiert ?

mp_TaskAddress	ds.l	1	;Adresse Decodingtask

;------------------ nach Prioritten sortiert ---------------------------
mp_SignalStop	ds.l	2	;Stop Decoding
mp_SignalClose	ds.l	2	;Close File
mp_SignalQuit	ds.l	2	;Quit Task
mp_SignalOpen	ds.l	2	;Open File
mp_SignalStart	ds.l	2	;Start Decoding (Signal + Abarbeitungsroutine)
mp_SignalSeek	ds.l	2	;Seek Position
;------------------------------------------------------------------------
mp_SignalLoad	ds.l	2	;Signal: Puffer frei
mp_SignalMask	ds.l	1	;SignalMaske fr Decoder-Task

;-------------------- Daten des Players -----------------------------------------------------
mp_Convert_to_8		ds.b	1
mp_WaitPlay		ds.b	1
mp_ReadPerInt		ds.w	1
mp_BytesperFrame	ds.w	1
mp_NumChannels		ds.w	1
mp_SampleRate		ds.l	1
mp_SamplePer		ds.l	1
PlaybufNext		ds.l	1			;welcher Abspielpuffer gerade benutzt wird
PlaybufL		ds.b	Playbuffersize*2	;Puffer  fr Daten links (double buffered)
PlaybufR		ds.b	Playbuffersize*2	;Puffer  fr Daten rechts (double buffered)
Playbufend		ds.b	0

mp_PCMBuffers:		ds.l	2

;-------------------------------------------------------------------------------------------------
			ds.l	10
mp_Time			ds.l	1			;Zeit des Abspielens in Mikrosekunden
			ds.l	10
;------------------- Daten fr MP3 Info Tag ---------------------------------------------------
Tag_Buffer:		ds.b	128
Tag_Title:		ds.b	MaxTagLen+1	;31 with v1
Tag_Author:		ds.b	MaxTagLen+1	;31 with v1
Tag_Album:		ds.b	MaxTagLen+1	;31 with v1
Tag_Year:		ds.b	6		;4+1+1, last 1 to align data
Tag_Comment:		ds.b	MaxTagLen+1	;31 with v1
Tag_Genre:		ds.b	MaxTagLen+1	;21 with v1

;------------------- Daten des PrefsWindows ---------------------------------------------------

RealNumGadgets	ds.w	1
Attr		ds.l	2
intsave:	ds.l	1
grafsave	ds.l	1
gadsave:	ds.l	1
_dos		ds.l	1
Port:		ds.l	1
mypubscreen:	ds.l	1	;aktueller Publicscreen
fonth:		ds.l	1	;Fonthhe
vi:		ds.l	1	;Visualinfo
numboo:		ds.l	2	;tmp Area fr Get/SetGadgetAttrsA
Project0Gadgets:	ds.l	21
Gadgetadrs=Project0Gadgets

BufNewGad:		ds.w	4
			ds.l	2
			ds.w	1
			ds.l	3
BufIText:		ds.b    4
			ds.w	2
			ds.l	3

Project0GList:	ds.l	1
Project0Menus:	ds.l	1
Winhandle	ds.l	1
Font:		ds.l	1
FontX:		ds.w	1
FontY:		ds.w	1
OffX:		ds.w	1
OffY:		ds.w	1
		ds.w	2

Mytask		ds.l	1
onsysfont	ds.b	1
		ds.b	1

MyRastport	ds.b	rp_sizeof
fontadr		ds.l	1
ID3v2headersize	ds.l	1

dataslen = *-datas
Mpega_checkmem	ds.b	MPEGA_PCM_SIZE*4
