% Filtering experiments, chirp etc.
%
%
%
%lpFilt = designfilt('lowpassiir','FilterOrder',8, ...
%         'PassbandFrequency',35e3,'PassbandRipple',0.2, ...
%         'SampleRate',200e3)
%fvtool(lpFilt)
%dataIn = randn([1000 1]); dataOut = filter(lpFilt,dataIn);
%hpFilt = designfilt('highpassiir','Filterorder',1,...
%          'PassbandFrequency',3e3,'PassbandRipple',0.2,...
%          'SampleRate',41e3);
%hpFilt      
% FIR highpass
%fvtool([1 -0.95 0.1],0.125)
% IIR highpass
%fvtool([2 -0.25],[1 1])
% IIR highpass, shifts only, (mid-highs not nice)
%fvtool([1 -0.5],[1 0.5 -0.25])
% IIR highpass, shifts only, nonlinear mid-highs
%fvtool([1 -0.5],[1 0.5])
% 40 dB IIR highpass
%fvtool([1 -0.9],[1 0.9])

% Lowpass from UADE
if 0
omega = 2*pi*5000/44100;
b0 = 1 / (1 + 1 / omega)
%output(n) = b0 * input(n) + (1 - b0) * output(n - 1)
fvtool(b0,[1 -(1-b0)]);
endc

if 1
% shelving-filter first order highboost
%
V0=18;       % Amplification (for H(s=\infty)  9=good for 28 kHz,18=good for 44 kHz )
f_a=44100;
omega_g=2*pi*17000; % f/Hz
T=1/f_a;
H0=V0-1;

% amplification case
a_B=(tan( omega_g * T / 2 )-1)/( tan( omega_g * T / 2 ) + 1 );
% reduction case
a_C=(V0*tan( omega_g * T / 2 )-1)/( V0*tan( omega_g * T / 2 ) + 1 );
if 1
    a_C=1; % no reduction
end


b0=1+(1-a_B*a_C)*H0/2;
b1=a_B*a_C+(a_B*a_C-1)*H0/2;
a0=1;
a1=a_B*a_C;

fvtool([b0 b1],[a0 a1]);
%[b0 b1 a0 a1]
if 0
% actual EP implementation: use fvtool([1 -0.5],[1 0.5]); at 44 kHz
% actual EP implementation: use fvtool([1 -0.5],[1 0.25]); at 28 kHz
b0=4;b1=-2;a0=1;a1=0.5;    % good for 28 kHz, 19 dB at f_a/2
%b0=5.0;b1=-4;a0=1;a1=0.5; % good for 44 kHz, 30 dB at f_a/2
fvtool([b0 b1],[a0 a1]);

%
end

% filter test signal
if 0
warning('off');
w=wavread('~/music/Wolfsheim-NowIFall.wav');

wfilt=filter([b0 b1],[a0 a1],w);

wavwrite(wfilt,44100,16,'Wolfsheim_filt.wav');
end

end

%fvtool([ 8 -7 ],[1 -0.125])
%fvtool([-1 0.5],[1 0.5])
%fvtool([2 -1],1)

if 0
%
% sine tone at frequency f in Hz
% (len = fs*seconds)
% -> write WAV
%
% Paula clocks, OCS 15 kHz screenmodes (old Denise)
% NTSC 3579545/124 = 28867.3 Hz
% PAL  3546895/124 = 28604 Hz
%
sec=10;
f=10000; % 1 kHz

paulaclock=14187580/4; % PAL Amiga system clock / 4 = Paula clock
periods=[63 74 80 124 161 223 321 443 886 1419 1773]; % Paula periods

paulafreq=repmat(paulaclock,size(periods))./periods % corresponding sampling frequencies

for j=periods

fs=int32(paulaclock/j); % round down
    
len=fs*sec;
t=double([0:len-1]);

oa=int16(32767*cos( 2 * pi * double(f) * t./double(fs) ));

oname=sprintf('Sine_%dHz_at_%dHz.wav',int32(f),fs);

wavwrite(oa,fs,16,oname);

end

end


if 0
%
% linear frequency stepping from f0 to f1
% (len = fs*sec)
% -> write WAV
%
fs=12000; %44336; % (paula native) 44100; % Hz
f0=4000;  % 
f1=8000;  % 
%fs=15905; %44336; % (paula native) 44100; % Hz
%f0=0;     % 10 Hz
%f1=7952;  % f_g, 22050 Hz at fs=44100

step=2;   % step duration in seconds
sec=20;

len1=fs*sec;
oa=int16(zeros(len1,2));

n = fix(sec/step)-1;
for j=0:n

    len=fs*step;
    off=j*len;
    f = f0+(f1-f0)*j/n;

for i=0:len-1
    t = i/fs; % 1/fs step size
    oa(off+i+1,:) = 32767*cos( 2 * pi * f * t  ); % common cos(\omega t)
end

end

% reduce to square wave
%oa(oa>0)=32767;
%oa(oa<0)=-32768;

if 1
    % windowed total spectrum
    l2=len;
    t75=tukeywin(l2,0.01);
    OA=fft(t75.*double(oa(1:l2,1)));
else
    % windowed short time DFT
    OA=zeros(fs,1);
    t75 = tukeywin(fs,0.75);
    for i=0:fs:len-fs
        oa1=double(oa(i+1:i+fs,1));
        OA1=fft(oa1.*t75);
        
        OA = OA+abs(OA1);
        fprintf('%d ',i);
    end
end

figure;plot(abs(OA));
%K=ones(len/fs,1);
%OAf=filter(K,1,abs(OA));
%figure;plot(OAf);

wavwrite(oa,fs,16,'Freqstep.wav');

end



if 0
%
% linear chirp from f0 to fs/2
% (len = fs*sec)
% -> write WAV
%
    fs=44336;% (paula native) 44100; % Hz
    f0=10;    % 10 Hz
    f1=fs/2;  % f_g, 22050 Hz at fs=44100
    sec=20;
    
    len=fs*sec;
    oa=int16(zeros(len,2));
    for i=0:len-1
        t = i/fs; % 1/fs step size
        f = (f0 + 0.5*(f1-f0)*i/(len-1)); % 0.5: keep phase angle speedup in mind when "chirping"
        oa(i+1,:) = 32767*cos( 2 * pi * f * t  ); % common cos(\omega t)
    end
    
    if 1
        % windowed total spectrum
        l2=len;
        t75=tukeywin(l2,0.01);
        OA=fft(t75.*double(oa(1:l2,1)));
    else
        % windowed short time DFT
        OA=zeros(fs,1);
        t75 = tukeywin(fs,0.75);
        for i=0:fs:len-fs
            oa1=double(oa(i+1:i+fs,1));
            OA1=fft(oa1.*t75);
            
            OA = OA+abs(OA1);
            fprintf('%d ',i);
        end
    end
    
    figure;plot(abs(OA));
    %K=ones(len/fs,1);
    %OAf=filter(K,1,abs(OA));
    %figure;plot(OAf);
    
    wavwrite(oa,fs,16,'Chirp.wav');
    
end

if 0
%
% white noise
% (len = fs*seconds)
% -> write WAV
%
fs=44100;
f0=10; % 10 Hz
len=fs*30;
ftlen=fs/100;
oa=int16( 65535.*(rand(len,2)) - 32768 );

% Bartlett spectrum averaging
    OA=zeros(ftlen,1);
%    t75 = tukeywin(ftlen,0.75);
    t75 = ones(size(OA));
    num = 0;
    for i=0:ftlen:len-ftlen
        oa1=double(oa(i+1:i+ftlen,1));
        OA1=fft(oa1.*t75);
        OA = OA+OA1;
        
        oa1=double(oa(i+1:i+ftlen,2));
        OA1=fft(oa1.*t75);
        OA = OA+OA1;
       
        fprintf('%d ',i);
        num=num+2;
    end
    OA=OA./num;

figure;plot(abs(OA));
%K=ones(len/fs,1);
%OAf=filter(K,1,abs(OA));
%figure;plot(OAf);

wavwrite(oa,fs,16,'Noise.wav');

end
